﻿namespace core.Bitmaps.H2Bitmap
{
    using core.H2;
    using System;
    using System.IO;

    public sealed class H2DDS
    {
        public static void WriteDDSHeader(ref BinaryWriter bw, bitm.Bitmap_Data_Layout dataLayout, int LOD)
        {
            uint num = 0;
            int num2 = 0;
            int num3 = 0;
            num |= 1;
            num |= 0x1000;
            num |= 4;
            num |= 2;
            if (((dataLayout.Bitmap_Format == bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_DXT1) || (dataLayout.Bitmap_Format == bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_DXT2AND3)) || (dataLayout.Bitmap_Format == bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_DXT4AND5))
            {
                num |= 0x80000;
            }
            else
            {
                num |= 8;
            }
            switch (dataLayout.Bitmap_Format)
            {
                case bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_Y8:
                case bitm.Bitmap_Data_Layout.BitmapFormat.BITM_TYPE_LIGHTMAP:
                    num2 = 8;
                    break;

                case bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_A8Y8:
                case bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_R5G6B5:
                case bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_A1R5G5B5:
                case bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_A4R4G4B4:
                case bitm.Bitmap_Data_Layout.BitmapFormat.BITM_TYPE_UNK:
                    num2 = 0x10;
                    break;

                case bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_X8R8G8B8:
                case bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_A8R8G8B8:
                case bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_DXT1:
                case bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_DXT2AND3:
                case bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_DXT4AND5:
                case bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_P8:
                    num2 = 0x20;
                    break;
            }
            if ((num & 8) != 0)
            {
                num3 = dataLayout.Width.Value * (num2 / 8);
            }
            else if ((num & 0x80000) != 0)
            {
                num3 = dataLayout.rawdata.lod_size[LOD];
            }
            if (dataLayout.MipMap_Count.Value > 0)
            {
                num |= 0x20000;
            }
            int num4 = dataLayout.Width.Value;
            int num5 = num4;
            if ((num4 % 8) != 0)
            {
                num4 = (ushort) (num4 + (8 - (num4 % 8)));
            }
            bw.Write(0x20534444);
            bw.Write(0x7c);
            bw.Write(num);
            bw.Write((uint) dataLayout.Height.Value);
            bw.Write((uint) num4);
            bw.Write(num3);
            bw.Write(0);
            bw.Write((uint) dataLayout.MipMap_Count.Value);
            for (int i = 0; i < 11; i++)
            {
                bw.Write(0);
            }
            uint num7 = 0;
            uint num8 = 0;
            if (dataLayout.Bitmap_Format == bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_DXT1)
            {
                num8 = 0x31545844;
                num7 |= 4;
            }
            else if (dataLayout.Bitmap_Format == bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_DXT2AND3)
            {
                num8 = 0x33545844;
                num7 |= 4;
            }
            else if (dataLayout.Bitmap_Format == bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_DXT4AND5)
            {
                num8 = 0x34545844;
                num7 |= 4;
            }
            else if (dataLayout.Bitmap_Format == bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_A8)
            {
                num7 |= 2;
            }
            else
            {
                num7 |= 0x40;
            }
            if ((((dataLayout.Bitmap_Format == bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_A1R5G5B5) || (dataLayout.Bitmap_Format == bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_A4R4G4B4)) || ((dataLayout.Bitmap_Format == bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_A8R8G8B8) || (dataLayout.Bitmap_Format == bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_X8R8G8B8))) || (dataLayout.Bitmap_Format == bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_P8))
            {
                num7 |= 1;
            }
            uint num9 = 0;
            uint num10 = 0;
            uint num11 = 0;
            uint num12 = 0;
            if (dataLayout.Bitmap_Format == bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_R5G6B5)
            {
                num9 = 0xf800;
                num10 = 0x7e0;
                num11 = 0x1f;
                num12 = 0;
            }
            else if (dataLayout.Bitmap_Format == bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_A1R5G5B5)
            {
                num9 = 0x7c00;
                num10 = 0x3e0;
                num11 = 0x1f;
                num12 = 0x8000;
            }
            else if (dataLayout.Bitmap_Format == bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_A4R4G4B4)
            {
                num9 = 0xf00;
                num10 = 240;
                num11 = 15;
                num12 = 0xf000;
            }
            else if (dataLayout.Bitmap_Format == bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_X8R8G8B8)
            {
                num9 = 0xff000;
                num10 = 0xff00;
                num11 = 0xff;
                num12 = 0xff000000;
            }
            else if (dataLayout.Bitmap_Format == bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_A8R8G8B8)
            {
                num9 = 0xff0000;
                num10 = 0xff00;
                num11 = 0xff;
                num12 = 0xff000000;
            }
            else if (dataLayout.Bitmap_Format == bitm.Bitmap_Data_Layout.BitmapFormat.BITM_FORMAT_P8)
            {
                num9 = 0xff0000;
                num10 = 0xff00;
                num11 = 0xff;
                num12 = 0xff000000;
            }
            else
            {
                num9 = 0;
                num10 = 0;
                num11 = 0;
                num12 = 0;
            }
            bw.Write(0x20);
            bw.Write(num7);
            bw.Write(num8);
            bw.Write(num2);
            bw.Write(num9);
            bw.Write(num10);
            bw.Write(num11);
            bw.Write(num12);
            uint num13 = 0x1000;
            if (dataLayout.MipMap_Count.Value != 0)
            {
                num13 |= 0x400000;
                num13 |= 8;
            }
            bw.Write(num13);
            bw.Write(0);
            bw.Write(0);
            bw.Write(0);
            bw.Write(0);
        }

        public enum DdsEnum
        {
            DDPF_ALPHA = 2,
            DDPF_ALPHAPIXELS = 1,
            DDPF_FOURCC = 4,
            DDPF_PALETTEINDEXED8 = 0x20,
            DDPF_RGB = 0x40,
            DDSCAPS_COMPLEX = 8,
            DDSCAPS_MIPMAP = 0x400000,
            DDSCAPS_PALETTE = 0x100,
            DDSCAPS_TEXTURE = 0x1000,
            DDSCAPS2_CUBEMAP = 0x200,
            DDSCAPS2_CUBEMAP_NEGATIVEX = 0x800,
            DDSCAPS2_CUBEMAP_NEGATIVEY = 0x2000,
            DDSCAPS2_CUBEMAP_NEGATIVEZ = 0x8000,
            DDSCAPS2_CUBEMAP_POSITIVEX = 0x400,
            DDSCAPS2_CUBEMAP_POSITIVEY = 0x1000,
            DDSCAPS2_CUBEMAP_POSITIVEZ = 0x4000,
            DDSCAPS2_VOLUME = 0x200000,
            DDSD_CAPS = 1,
            DDSD_DEPTH = 0x800000,
            DDSD_HEIGHT = 2,
            DDSD_LINEARSIZE = 0x80000,
            DDSD_MIPMAPCOUNT = 0x20000,
            DDSD_PITCH = 8,
            DDSD_PIXELFORMAT = 0x1000,
            DDSD_WIDTH = 4
        }
    }
}

