﻿namespace core.Bitmaps.H2Bitmap
{
    using System;
    using System.Runtime.InteropServices;

    public sealed class H2DXT
    {
        public static byte[] DecodeDXT1(int height, int width, byte[] sourceData)
        {
            byte[] buffer = new byte[(height * width) * 4];
            ColorRGBA[] rrgbaArray = new ColorRGBA[4];
            int index = 0;
            int num3 = width / 4;
            ColorRGBA rrgba2 = new ColorRGBA();
            if (num3 == 0)
            {
                num3++;
            }
            for (int i = 0; i <= ((width * height) - 1); i += 0x10)
            {
                bool flag;
                uint color = (Convert.ToUInt32(sourceData[index + 1]) << 8) | sourceData[index];
                uint num5 = (Convert.ToUInt32(sourceData[index + 3]) << 8) | sourceData[index + 2];
                if (color > num5)
                {
                    flag = false;
                }
                else
                {
                    flag = true;
                }
                rrgbaArray[0] = Short2Rgba(color);
                rrgbaArray[1] = Short2Rgba(num5);
                if (!flag)
                {
                    rrgbaArray[2] = GradientColors(rrgbaArray[0], rrgbaArray[1]);
                    rrgbaArray[3] = GradientColors(rrgbaArray[1], rrgbaArray[0]);
                }
                else
                {
                    rrgbaArray[2] = GradientColorsHalf(rrgbaArray[0], rrgbaArray[1]);
                    rrgbaArray[3] = rrgba2;
                }
                int num2 = ((Convert.ToInt32(sourceData[index + 4]) | (Convert.ToInt32(sourceData[index + 5]) << 8)) | (Convert.ToInt32(sourceData[index + 6]) << 0x10)) | (Convert.ToInt32(sourceData[index + 7]) << 0x18);
                int num7 = i / 0x10;
                long num8 = num7 % num3;
                long num9 = (num7 - num8) / ((long) num3);
                int num11 = (height < 4) ? height : 4;
                int num12 = (width < 4) ? width : 4;
                for (int j = 0; j <= (num11 - 1); j++)
                {
                    for (int k = 0; k <= (num12 - 1); k++)
                    {
                        ColorRGBA rrgba = rrgbaArray[num2 & 3];
                        num2 = num2 >> 2;
                        long num10 = (((((num9 * 4L) + j) * width) + (num8 * 4L)) + k) * 4L;
                        buffer[(int) ((IntPtr) num10)] = rrgba.b;
                        buffer[(int) ((IntPtr) (num10 + 1L))] = rrgba.g;
                        buffer[(int) ((IntPtr) (num10 + 2L))] = rrgba.r;
                        buffer[(int) ((IntPtr) (num10 + 3L))] = rrgba.a;
                    }
                }
                index += 8;
            }
            return buffer;
        }

        public static byte[] DecodeDXT23(int height, int width, byte[] sourceData)
        {
            byte[] buffer = new byte[(height * width) * 4];
            ColorRGBA[] rrgbaArray = new ColorRGBA[4];
            int num2 = width / 4;
            if (num2 == 0)
            {
                num2 = 1;
            }
            for (int i = 0; i <= ((width * height) - 1); i += 0x10)
            {
                rrgbaArray[0] = Short2Rgba(Convert.ToUInt32(sourceData[i + 8]) | (Convert.ToUInt32(sourceData[i + 9]) << 8));
                rrgbaArray[1] = Short2Rgba(Convert.ToUInt32(sourceData[i + 10]) | (Convert.ToUInt32(sourceData[i + 11]) << 8));
                rrgbaArray[2] = GradientColors(rrgbaArray[0], rrgbaArray[1]);
                rrgbaArray[3] = GradientColors(rrgbaArray[1], rrgbaArray[0]);
                int num = ((Convert.ToInt32(sourceData[i + 12]) | (Convert.ToInt32(sourceData[i + 13]) << 8)) | (Convert.ToInt32(sourceData[i + 14]) << 0x10)) | (Convert.ToInt32(sourceData[i + 15]) << 0x18);
                int num4 = i / 0x10;
                long num5 = num4 % num2;
                long num6 = (num4 - num5) / ((long) num2);
                int num9 = (height < 4) ? height : 4;
                int num10 = (width < 4) ? width : 4;
                for (int j = 0; j <= (num9 - 1); j++)
                {
                    int num8 = sourceData[i + (2 * j)] | (Convert.ToInt32(sourceData[(i + (2 * j)) + 1]) << 8);
                    for (int k = 0; k <= (num10 - 1); k++)
                    {
                        ColorRGBA rrgba = rrgbaArray[num & 3];
                        num = num >> 2;
                        rrgba.a = (byte) ((num8 & 15) * 0x10);
                        num8 = num8 >> 4;
                        long num7 = (((((num6 * 4L) + j) * width) + (num5 * 4L)) + k) * 4L;
                        buffer[(int) ((IntPtr) num7)] = rrgba.b;
                        buffer[(int) ((IntPtr) (num7 + 1L))] = rrgba.g;
                        buffer[(int) ((IntPtr) (num7 + 2L))] = rrgba.r;
                        buffer[(int) ((IntPtr) (num7 + 3L))] = rrgba.a;
                    }
                }
            }
            return buffer;
        }

        public static byte[] DecodeDXT45(int height, int width, byte[] sourceData)
        {
            byte[] buffer = new byte[(height * width) * 4];
            ColorRGBA[] rrgbaArray = new ColorRGBA[4];
            int num2 = width / 4;
            if (num2 == 0)
            {
                num2 = 1;
            }
            for (int i = 0; i <= ((width * height) - 1); i += 0x10)
            {
                rrgbaArray[0] = Short2Rgba(Convert.ToUInt32(sourceData[i + 8]) | (Convert.ToUInt32(sourceData[i + 9]) << 8));
                rrgbaArray[1] = Short2Rgba(Convert.ToUInt32(sourceData[i + 10]) | (Convert.ToUInt32(sourceData[i + 11]) << 8));
                rrgbaArray[2] = GradientColors(rrgbaArray[0], rrgbaArray[1]);
                rrgbaArray[3] = GradientColors(rrgbaArray[1], rrgbaArray[0]);
                int num = ((Convert.ToInt32(sourceData[i + 12]) | (Convert.ToInt32(sourceData[i + 13]) << 8)) | (Convert.ToInt32(sourceData[i + 14]) << 0x10)) | (Convert.ToInt32(sourceData[i + 15]) << 0x18);
                byte[] buffer2 = new byte[8];
                buffer2[0] = sourceData[i];
                buffer2[1] = sourceData[i + 1];
                if (buffer2[0] > buffer2[1])
                {
                    buffer2[2] = (byte) ((((6 * buffer2[0]) + buffer2[1]) + 3) / 7);
                    buffer2[3] = (byte) ((((5 * buffer2[0]) + (2 * buffer2[1])) + 3) / 7);
                    buffer2[4] = (byte) ((((4 * buffer2[0]) + (3 * buffer2[1])) + 3) / 7);
                    buffer2[5] = (byte) ((((3 * buffer2[0]) + (4 * buffer2[1])) + 3) / 7);
                    buffer2[6] = (byte) ((((2 * buffer2[0]) + (5 * buffer2[1])) + 3) / 7);
                    buffer2[7] = (byte) (((buffer2[0] + (6 * buffer2[1])) + 3) / 7);
                }
                else
                {
                    buffer2[2] = (byte) ((((4 * buffer2[0]) + buffer2[1]) + 2) / 5);
                    buffer2[3] = (byte) ((((3 * buffer2[0]) + (2 * buffer2[1])) + 2) / 5);
                    buffer2[4] = (byte) ((((2 * buffer2[0]) + (3 * buffer2[1])) + 2) / 5);
                    buffer2[5] = (byte) (((buffer2[0] + (4 * buffer2[1])) + 2) / 5);
                    buffer2[6] = 0;
                    buffer2[7] = 0xff;
                }
                int num5 = sourceData[i + 2] | (Convert.ToInt32(sourceData[i + 3]) << 8);
                long num4 = ((sourceData[i + 4] | (Convert.ToInt32(sourceData[i + 5]) << 8)) | (sourceData[i + 6] << 0x10)) | (Convert.ToInt32(sourceData[i + 7]) << 0x18);
                long num6 = num5 | ((int) (num4 << 0x10));
                int num7 = i / 0x10;
                long num8 = num7 % num2;
                long num9 = (num7 - num8) / ((long) num2);
                int num11 = (height < 4) ? height : 4;
                int num12 = (width < 4) ? width : 4;
                for (int j = 0; j <= (num11 - 1); j++)
                {
                    for (int k = 0; k <= (num12 - 1); k++)
                    {
                        ColorRGBA rrgba = rrgbaArray[num & 3];
                        num = num >> 2;
                        rrgba.a = buffer2[(int) ((IntPtr) (num6 & 7L))];
                        num6 = num6 >> 3;
                        long num10 = (((((num9 * 4L) + j) * width) + (num8 * 4L)) + k) * 4L;
                        buffer[(int) ((IntPtr) num10)] = rrgba.b;
                        buffer[(int) ((IntPtr) (num10 + 1L))] = rrgba.g;
                        buffer[(int) ((IntPtr) (num10 + 2L))] = rrgba.r;
                        buffer[(int) ((IntPtr) (num10 + 3L))] = rrgba.a;
                    }
                }
            }
            return buffer;
        }

        private static ColorRGBA GradientColors(ColorRGBA Col1, ColorRGBA Col2)
        {
            ColorRGBA rrgba;
            rrgba.r = (byte) (((Col1.r * 2) + Col2.r) / 3);
            rrgba.g = (byte) (((Col1.g * 2) + Col2.g) / 3);
            rrgba.b = (byte) (((Col1.b * 2) + Col2.b) / 3);
            rrgba.a = 0xff;
            return rrgba;
        }

        private static ColorRGBA GradientColorsHalf(ColorRGBA Col1, ColorRGBA Col2)
        {
            ColorRGBA rrgba;
            rrgba.r = (byte) ((Col1.r / 2) + (Col2.r / 2));
            rrgba.g = (byte) ((Col1.g / 2) + (Col2.g / 2));
            rrgba.b = (byte) ((Col1.b / 2) + (Col2.b / 2));
            rrgba.a = 0xff;
            return rrgba;
        }

        private static int Rgba2Int(ColorRGBA c)
        {
            return ((((c.a << 0x18) | (c.r << 0x10)) | (c.g << 8)) | c.b);
        }

        private static ColorRGBA Short2Rgba(uint color)
        {
            ColorRGBA rrgba;
            rrgba.r = (byte) ((((color >> 11) & 0x1f) * 0xff) / 0x1f);
            rrgba.g = (byte) ((((color >> 5) & 0x3f) * 0xff) / 0x3f);
            rrgba.b = (byte) (((color & 0x1f) * 0xff) / 0x1f);
            rrgba.a = 0xff;
            return rrgba;
        }

        [StructLayout(LayoutKind.Sequential)]
        public struct ColorRGBA
        {
            public byte r;
            public byte g;
            public byte b;
            public byte a;
        }
    }
}

