﻿namespace core.Bitmaps.H2Bitmap
{
    using System;

    public sealed class H2Swizzle
    {
        private static uint maskX;
        private static uint maskY;
        private static uint maskZ;

        public static uint Swiz(int x, int y, int z)
        {
            return ((SwizzleAxis(x, maskX) | SwizzleAxis(y, maskY)) | ((z != -1) ? SwizzleAxis(z, maskZ) : 0));
        }

        public static byte[] Swizzle(byte[] data, uint bitCount, uint width, uint height, uint depth, bool DeSwizzle)
        {
            maskX = 0;
            maskY = 0;
            maskZ = 0;
            uint num = 1;
            uint num2 = 1;
            while (((num < width) || (num < height)) || (num < depth))
            {
                if (num < width)
                {
                    maskX |= num2;
                    num2 = num2 << 1;
                }
                if (num < height)
                {
                    maskY |= num2;
                    num2 = num2 << 1;
                }
                if (num < depth)
                {
                    maskZ |= num2;
                    num2 = num2 << 1;
                }
                num = num << 1;
            }
            try
            {
                int num7;
                byte[] buffer = new byte[data.Length];
                for (ushort i = 0; i < width; i = (ushort) (i + 1))
                {
                    for (int j = 0; j < height; j++)
                    {
                        uint num3;
                        uint num4;
                        if (!DeSwizzle)
                        {
                            num3 = ((uint) ((j * width) + i)) * (bitCount / 8);
                            num4 = Swiz(i, j, -1) * (bitCount / 8);
                        }
                        else
                        {
                            num4 = ((uint) ((j * width) + i)) * (bitCount / 8);
                            num3 = Swiz(i, j, -1) * (bitCount / 8);
                        }
                        num7 = 0;
                        while (num7 < (bitCount / 8))
                        {
                            buffer[(int) ((IntPtr) (num3 + num7))] = data[(int) ((IntPtr) (num4 + num7))];
                            num7++;
                        }
                    }
                }
                for (num7 = 0; num7 < data.Length; num7++)
                {
                    data[num7] = buffer[num7];
                }
            }
            catch
            {
            }
            return data;
        }

        public static uint SwizzleAxis(int val, uint mask)
        {
            uint num = 0;
            for (uint i = 1; i <= mask; i = i << 1)
            {
                if ((mask & i) != 0)
                {
                    num |= ((uint) val) & i;
                }
                else
                {
                    val = val << 1;
                }
            }
            return num;
        }
    }
}

