﻿namespace core
{
    using System;
    using System.Collections;
    using System.Reflection;

    public class CloneableObject : ICloneable
    {
        public object Clone()
        {
            object obj2 = Activator.CreateInstance(base.GetType());
            FieldInfo[] fields = obj2.GetType().GetFields(BindingFlags.NonPublic | BindingFlags.Public | BindingFlags.Instance);
            int index = 0;
            foreach (FieldInfo info in base.GetType().GetFields(BindingFlags.NonPublic | BindingFlags.Public | BindingFlags.Instance))
            {
                if (info.FieldType.GetInterface("ICloneable", true) != null)
                {
                    ICloneable cloneable = (ICloneable) info.GetValue(this);
                    if (cloneable != null)
                    {
                        fields[index].SetValue(obj2, cloneable.Clone());
                    }
                }
                else
                {
                    fields[index].SetValue(obj2, info.GetValue(this));
                }
                if (info.FieldType.GetInterface("IEnumerable", true) != null)
                {
                    IEnumerable enumerable = (IEnumerable) info.GetValue(this);
                    Type type3 = fields[index].FieldType.GetInterface("IList", true);
                    Type type4 = fields[index].FieldType.GetInterface("IDictionary", true);
                    int num2 = 0;
                    if (type3 != null)
                    {
                        IList list = (IList) fields[index].GetValue(obj2);
                        for (int i = 0; i < list.Count; i++)
                        {
                            object obj3 = list[i];
                            if (obj3.GetType().GetInterface("ICloneable", true) != null)
                            {
                                ICloneable cloneable2 = (ICloneable) obj3;
                                list[num2] = cloneable2.Clone();
                            }
                            num2++;
                        }
                    }
                    else if (type4 != null)
                    {
                        IDictionary dictionary = (IDictionary) fields[index].GetValue(obj2);
                        num2 = 0;
                        foreach (DictionaryEntry entry in enumerable)
                        {
                            if (entry.Value.GetType().GetInterface("ICloneable", true) != null)
                            {
                                dictionary[entry.Key] = ((ICloneable) entry.Value).Clone();
                            }
                            num2++;
                        }
                    }
                }
                index++;
            }
            return obj2;
        }
    }
}

