﻿namespace core
{
    using core.TagInterface;
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Text;
    using System.Windows.Forms;
    using System.Xml;

    public sealed class EntIO
    {
        private static string ExtendedTagType = "Not_Another_Noob_Editing_Plugins";
        private static Map.HaloVersionEnum MapType;
        private static string TagType = "";

        private static TagBlockLayout EntReader(ref XmlTextReader xtr)
        {
            TagBlockLayout layout = new TagBlockLayout(false);
            bool flag = false;
            while (xtr.Read())
            {
                Data.RawDataTypes types;
                string str4;
                TagBlockIndex.TagBlockIndexType type;
                string str5 = xtr.NodeType.ToString();
                if (str5 != null)
                {
                    if (!(str5 == "Element"))
                    {
                        if (str5 == "EndElement")
                        {
                            goto Label_0D87;
                        }
                    }
                    else
                    {
                        string str3;
                        str5 = xtr.Name.ToLower();
                        switch (str5)
                        {
                            case "plugin":
                            {
                                string attribute = xtr.GetAttribute("FullClassName");
                                string str2 = xtr.GetAttribute("Class");
                                ExtendedTagType = (attribute == null) ? ExtendedTagType : attribute;
                                TagType = (str2 == null) ? xtr.GetAttribute("class") : str2;
                                goto Label_0DBD;
                            }
                            case "angle":
                                layout.Add(new Angle(xtr.GetAttribute("name")));
                                goto Label_0DBD;

                            case "bitmaskflags":
                                layout.Add(new core.TagInterface.Flags(xtr.GetAttribute("name"), core.TagInterface.Flags.BitmaskTypeEnum.Long));
                                goto Label_0DBD;

                            case "byteflags":
                                layout.Add(new core.TagInterface.Flags(xtr.GetAttribute("name"), core.TagInterface.Flags.BitmaskTypeEnum.Byte));
                                goto Label_0DBD;

                            case "byteinteger":
                                layout.Add(new ByteInteger(xtr.GetAttribute("name")));
                                goto Label_0DBD;

                            case "data":
                                str3 = xtr.GetAttribute("RawDataType");
                                types = Data.RawDataTypes.H1_bitm;
                                types = (Data.RawDataTypes) Enum.Parse(types.GetType(), str3);
                                switch (types)
                                {
                                    case Data.RawDataTypes.H2_jmad:
                                        goto Label_05A2;

                                    case Data.RawDataTypes.H2_ugh_sound:
                                        goto Label_05C3;
                                }
                                goto Label_05E2;

                            case "raw_tag_block":
                                str3 = xtr.GetAttribute("RawDataType");
                                types = Data.RawDataTypes.H1_bitm;
                                types = (Data.RawDataTypes) Enum.Parse(types.GetType(), str3);
                                layout.Add(new Raw_Tag_Block(xtr.GetAttribute("name"), MapType, types, new TagBlockLayout()));
                                goto Label_0DBD;

                            case "unicode_raw":
                                str3 = xtr.GetAttribute("RawDataType");
                                layout.Add(new Unicode_Raw(xtr.GetAttribute("name")));
                                goto Label_0DBD;

                            case "sound_raw":
                                str3 = xtr.GetAttribute("RawDataType");
                                layout.Add(new Sound_Raw(xtr.GetAttribute("name"), MapType));
                                goto Label_0DBD;

                            case "bitmap_raw":
                                str3 = xtr.GetAttribute("RawDataType");
                                layout.Add(new Bitmap_Raw(xtr.GetAttribute("name")));
                                goto Label_0DBD;

                            case "enumerableindex":
                                layout.Add(new EnumerableIndex(xtr.GetAttribute("name")));
                                goto Label_0DBD;

                            case "core.TagInterface.TagEnumerator":
                                layout.Add(new core.TagInterface.Enumerator(xtr.GetAttribute("name"), core.TagInterface.Enumerator.TagEnumeratorIndexType.Long));
                                goto Label_0DBD;

                            case "halotagtype":
                                layout.Add(new HaloTagType(xtr.GetAttribute("name")));
                                goto Label_0DBD;

                            case "longflags":
                                layout.Add(new core.TagInterface.Flags(xtr.GetAttribute("name"), core.TagInterface.Flags.BitmaskTypeEnum.Long));
                                goto Label_0DBD;

                            case "longinteger":
                            case "uint":
                            case "undefined":
                                goto Label_0761;

                            case "padding":
                                goto Label_077F;

                            case "pointer":
                                goto Label_07AE;

                            case "realargbcolor":
                                goto Label_07CC;

                            case "realbounds":
                                goto Label_07EA;

                            case "realeulerangles32":
                                goto Label_0808;

                            case "realfloat":
                                goto Label_0826;

                            case "realfraction":
                                goto Label_0844;

                            case "realplane2d":
                                goto Label_0862;

                            case "realplane3d":
                                goto Label_0880;

                            case "realpoint3d":
                                goto Label_089E;

                            case "realquaternion":
                                goto Label_08BC;

                            case "rgbacolor":
                                goto Label_08DA;

                            case "realrgbcolor":
                                goto Label_08F8;

                            case "realvector3d":
                                goto Label_0916;

                            case "shortinteger":
                            case "ushort":
                                goto Label_0934;

                            case "string":
                                goto Label_0952;

                            case "stringid":
                            case "script":
                                goto Label_0981;

                            case "tagblock":
                            case "struct":
                                goto Label_099F;

                            case "tagblockindex":
                                str5 = xtr.GetAttribute("type").ToLower();
                                if (str5 != null)
                                {
                                    if (str5 == "byte")
                                    {
                                        goto Label_0A21;
                                    }
                                    if (str5 == "long")
                                    {
                                        goto Label_0A2D;
                                    }
                                }
                                goto Label_0A27;

                            case "tagident":
                                layout.Add(new TagIdent(xtr.GetAttribute("name")));
                                goto Label_0DBD;

                            case "tagreference":
                                layout.Add(new TagReference(xtr.GetAttribute("name"), MapType));
                                goto Label_0DBD;

                            case "wordflags":
                                layout.Add(new core.TagInterface.Flags(xtr.GetAttribute("name"), core.TagInterface.Flags.BitmaskTypeEnum.Word));
                                goto Label_0DBD;

                            case "bitmask":
                            case "bitmask32":
                                if (xtr.IsEmptyElement)
                                {
                                    layout.Add(new core.TagInterface.Flags(xtr.GetAttribute("name"), core.TagInterface.Flags.BitmaskTypeEnum.Long));
                                }
                                else
                                {
                                    layout.Add(new core.TagInterface.Flags(xtr.GetAttribute("name"), core.TagInterface.Flags.BitmaskTypeEnum.Long, GetBits(ref xtr)));
                                }
                                goto Label_0DBD;

                            case "bitmask16":
                                if (!xtr.IsEmptyElement)
                                {
                                    goto Label_0B3B;
                                }
                                layout.Add(new core.TagInterface.Flags(xtr.GetAttribute("name"), core.TagInterface.Flags.BitmaskTypeEnum.Word));
                                goto Label_0DBD;

                            case "bitmask8":
                                if (!xtr.IsEmptyElement)
                                {
                                    goto Label_0B90;
                                }
                                layout.Add(new core.TagInterface.Flags(xtr.GetAttribute("name"), core.TagInterface.Flags.BitmaskTypeEnum.Byte));
                                goto Label_0DBD;

                            case "byte":
                                layout.Add(new ByteInteger(xtr.GetAttribute("name")));
                                goto Label_0DBD;

                            case "enum":
                            case "enum32":
                                layout.Add(new core.TagInterface.Enumerator(xtr.GetAttribute("name"), core.TagInterface.Enumerator.TagEnumeratorIndexType.Long));
                                goto Label_0DBD;

                            case "enum16":
                                layout.Add(new core.TagInterface.Enumerator(xtr.GetAttribute("name"), core.TagInterface.Enumerator.TagEnumeratorIndexType.Word));
                                goto Label_0DBD;

                            case "enum8":
                                layout.Add(new core.TagInterface.Enumerator(xtr.GetAttribute("name"), core.TagInterface.Enumerator.TagEnumeratorIndexType.Byte));
                                goto Label_0DBD;

                            case "float":
                                layout.Add(new RealFloat(xtr.GetAttribute("name")));
                                goto Label_0DBD;

                            case "id":
                                layout.Add(new TagIdent(xtr.GetAttribute("name")));
                                goto Label_0DBD;

                            case "int":
                                layout.Add(new LongInteger(xtr.GetAttribute("name")));
                                goto Label_0DBD;

                            case "short":
                                layout.Add(new ShortInteger(xtr.GetAttribute("name")));
                                goto Label_0DBD;

                            case "string32":
                                layout.Add(new core.TagInterface.String(xtr.GetAttribute("name"), 0x20));
                                goto Label_0DBD;

                            case "string256":
                                layout.Add(new core.TagInterface.String(xtr.GetAttribute("name"), 0x100));
                                goto Label_0DBD;

                            case "tag":
                                layout.Add(new HaloTagType(xtr.GetAttribute("name")));
                                goto Label_0DBD;

                            case "unicode64":
                                layout.Add(new core.TagInterface.String(xtr.GetAttribute("name"), 0x40));
                                goto Label_0DBD;

                            case "unicode256":
                                layout.Add(new core.TagInterface.String(xtr.GetAttribute("name"), 0x100));
                                goto Label_0DBD;

                            case "unused":
                                layout.Add(new core.TagInterface.Padding(Convert.ToInt32(xtr.GetAttribute("size"))));
                                goto Label_0DBD;
                        }
                    }
                }
                goto Label_0DBD;
            Label_05A2:
                layout.Add(new Animation_Raw(xtr.GetAttribute("name"), MapType, types));
                goto Label_0DBD;
            Label_05C3:
                layout.Add(new Sound_Raw(xtr.GetAttribute("name"), MapType));
                goto Label_0DBD;
            Label_05E2:
                layout.Add(new Data(xtr.GetAttribute("name"), MapType, types));
                goto Label_0DBD;
            Label_0761:
                layout.Add(new LongInteger(xtr.GetAttribute("name")));
                goto Label_0DBD;
            Label_077F:
                layout.Add(new core.TagInterface.Padding(xtr.GetAttribute("name"), Convert.ToInt32(xtr.GetAttribute("Size"))));
                goto Label_0DBD;
            Label_07AE:
                layout.Add(new Pointer(xtr.GetAttribute("name")));
                goto Label_0DBD;
            Label_07CC:
                layout.Add(new RealARGBColor(xtr.GetAttribute("name")));
                goto Label_0DBD;
            Label_07EA:
                layout.Add(new RealBounds(xtr.GetAttribute("name")));
                goto Label_0DBD;
            Label_0808:
                layout.Add(new RealEulerAngles3D(xtr.GetAttribute("name")));
                goto Label_0DBD;
            Label_0826:
                layout.Add(new RealFloat(xtr.GetAttribute("name")));
                goto Label_0DBD;
            Label_0844:
                layout.Add(new RealFraction(xtr.GetAttribute("name")));
                goto Label_0DBD;
            Label_0862:
                layout.Add(new RealPlane2D(xtr.GetAttribute("name")));
                goto Label_0DBD;
            Label_0880:
                layout.Add(new RealPlane3D(xtr.GetAttribute("name")));
                goto Label_0DBD;
            Label_089E:
                layout.Add(new RealPoint3D(xtr.GetAttribute("name")));
                goto Label_0DBD;
            Label_08BC:
                layout.Add(new RealQuaternion(xtr.GetAttribute("name")));
                goto Label_0DBD;
            Label_08DA:
                layout.Add(new RGBAColor(xtr.GetAttribute("name")));
                goto Label_0DBD;
            Label_08F8:
                layout.Add(new RealRGBColor(xtr.GetAttribute("name")));
                goto Label_0DBD;
            Label_0916:
                layout.Add(new RealVector3D(xtr.GetAttribute("name")));
                goto Label_0DBD;
            Label_0934:
                layout.Add(new ShortInteger(xtr.GetAttribute("name")));
                goto Label_0DBD;
            Label_0952:
                layout.Add(new core.TagInterface.String(xtr.GetAttribute("name"), Convert.ToInt32(xtr.GetAttribute("Length"))));
                goto Label_0DBD;
            Label_0981:
                layout.Add(new core.TagInterface.StringID(xtr.GetAttribute("name")));
                goto Label_0DBD;
            Label_099F:
                str4 = xtr.GetAttribute("padding_interval");
                int num = 0;
                if (str4 != null)
                {
                    num = int.Parse(str4);
                }
                layout.Add(new TagBlock(xtr.GetAttribute("name"), EntReader(ref xtr), Map.HaloVersionEnum.Halo2, num));
                goto Label_0DBD;
            Label_0A21:
                type = TagBlockIndex.TagBlockIndexType.Byte;
                goto Label_0A33;
            Label_0A27:
                type = TagBlockIndex.TagBlockIndexType.Word;
                goto Label_0A33;
            Label_0A2D:
                type = TagBlockIndex.TagBlockIndexType.Long;
            Label_0A33:
                layout.Add(new TagBlockIndex(xtr.GetAttribute("name"), type));
                goto Label_0DBD;
            Label_0B3B:
                layout.Add(new core.TagInterface.Flags(xtr.GetAttribute("name"), core.TagInterface.Flags.BitmaskTypeEnum.Word, GetBits(ref xtr)));
                goto Label_0DBD;
            Label_0B90:
                layout.Add(new core.TagInterface.Flags(xtr.GetAttribute("name"), core.TagInterface.Flags.BitmaskTypeEnum.Byte, GetBits(ref xtr)));
                goto Label_0DBD;
            Label_0D87:
                str5 = xtr.Name;
                if ((str5 != null) && ((str5 == "struct") || (str5 == "plugin")))
                {
                    flag = true;
                }
            Label_0DBD:
                if (flag)
                {
                    break;
                }
            }
            layout.TrimExcess();
            return layout;
        }

        private static List<core.TagInterface.Flags.Bit> GetBits(ref XmlTextReader xtr)
        {
            List<core.TagInterface.Flags.Bit> list = new List<core.TagInterface.Flags.Bit>();
            while (xtr.Read())
            {
                string str = xtr.NodeType.ToString();
                if (str != null)
                {
                    if (!(str == "Element"))
                    {
                        if (str == "EndElement")
                        {
                            return list;
                        }
                    }
                    else
                    {
                        str = xtr.Name.ToLower();
                        if ((str != null) && (str == "option"))
                        {
                            core.TagInterface.Flags.Bit item = new core.TagInterface.Flags.Bit();
                            item.BitName = xtr.GetAttribute("name");
                            item.BitPosition = int.Parse(xtr.GetAttribute("value"));
                            list.Add(item);
                        }
                    }
                }
            }
            return list;
        }

        public static TagBlockLayout ReadEnt(string inputFilePath)
        {
            try
            {
                FileStream input = new FileStream(inputFilePath, FileMode.Open, FileAccess.ReadWrite);
                XmlTextReader xtr = new XmlTextReader(input);
                xtr.WhitespaceHandling = WhitespaceHandling.None;
                TagBlockLayout layout = EntReader(ref xtr);
                xtr.Close();
                input.Close();
                return layout;
            }
            catch
            {
                return null;
            }
        }

        private static string RecursiveWriteCSClass(TagBlockLayout BO, int linePadding, string className)
        {
            string str = "";
            string str2 = "";
            string str3 = "";
            List<string> list = new List<string>();
            className = className.Replace("!", "_").Replace("[", "_").Replace("]", "_");
            str2 = str2 + ("public class " + className + " : TagInterface.TagBlockLayout\r\n").Insert(0, "".PadLeft(linePadding)) + "{\r\n".Insert(0, "".PadLeft(linePadding));
            int num = 0;
            foreach (BaseObject obj2 in BO)
            {
                string str6;
                string[] strArray;
                if (obj2.Name == "")
                {
                    obj2.Name = "No_Name";
                }
                string name = obj2.Name;
                if (name == null)
                {
                    name = "unknown-" + num.ToString();
                    num++;
                }
                name = name.Replace(' ', '_').Replace("\"", "Qoute").Replace("?", "_Question_Mark_").Replace('(', '_').Replace(')', '_').Replace("#", "_Number_").Replace("+", "_Plus_").Replace("/", "_").Replace("-", "_").Replace("[", "_").Replace("]", "_").Replace(".", "_");
                if (list.IndexOf(name) == -1)
                {
                    list.Add(name);
                }
                else
                {
                    int num2 = 0;
                    while (list.IndexOf(name + "_" + num2.ToString()) != -1)
                    {
                        num2++;
                    }
                    name = name + "_" + num2.ToString();
                    list.Add(name);
                }
                switch (obj2.GetType().ToString())
                {
                    case "all":
                        goto Label_0495;

                    case "core.TagInterface.Angle":
                        str2 = str2 + ("public TagInterface.Angle " + name + " = new TagInterface.Angle(\"" + name.Replace("\"", "\\\"") + "\");\r\n").Insert(0, "".PadLeft(linePadding + 4));
                        goto Label_0495;

                    case "core.TagInterface.Flags":
                    {
                        core.TagInterface.Flags.BitmaskTypeEnum bitmaskType = ((core.TagInterface.Flags) obj2).BitmaskType;
                        if (bitmaskType != core.TagInterface.Flags.BitmaskTypeEnum.Byte)
                        {
                            if (bitmaskType == core.TagInterface.Flags.BitmaskTypeEnum.Word)
                            {
                                goto Label_05B3;
                            }
                            if (bitmaskType == core.TagInterface.Flags.BitmaskTypeEnum.Long)
                            {
                                goto Label_0615;
                            }
                        }
                        else
                        {
                            str2 = str2 + ("public TagInterface.Flags " + name + " = new TagInterface.Flags(\"" + name.Replace("\"", "\\\"") + "\", TagInterface.Flags.BitmaskTypeEnum.Byte);\r\n").Insert(0, "".PadLeft(linePadding + 4));
                        }
                        goto Label_0495;
                    }
                    case "core.TagInterface.ByteInteger":
                        str2 = str2 + ("public TagInterface.ByteInteger " + name + " = new TagInterface.ByteInteger(\"" + name.Replace("\"", "\\\"") + "\");\r\n").Insert(0, "".PadLeft(linePadding + 4));
                        goto Label_0495;

                    case "core.TagInterface.EnumerableIndex":
                        str2 = str2 + ("public TagInterface.EnumerableIndex " + name + " = new TagInterface.EnumerableIndex(\"" + name.Replace("\"", "\\\"") + "\");\r\n").Insert(0, "".PadLeft(linePadding + 4));
                        goto Label_0495;

                    case "core.TagInterface.core.TagInterface.TagEnumerator":
                        switch (((core.TagInterface.Enumerator) obj2).IndexType)
                        {
                            case core.TagInterface.Enumerator.TagEnumeratorIndexType.Word:
                                goto Label_07D2;

                            case core.TagInterface.Enumerator.TagEnumeratorIndexType.Long:
                                goto Label_0834;

                            case core.TagInterface.Enumerator.TagEnumeratorIndexType.Byte:
                                goto Label_076D;
                        }
                        goto Label_0495;

                    case "core.TagInterface.Raw_Tag_Block":
                        str6 = ("public TagInterface.Raw_Tag_Block " + name + " = new TagInterface.Raw_Tag_Block(\"" + name.Replace("\"", "\\\"") + "\", Map.HaloVersionEnum." + ((Raw_Tag_Block) obj2).Halo_Version.ToString() + ", TagInterface.Data.RawDataTypes." + ((Raw_Tag_Block) obj2).Raw_Data_Type.ToString() + ", new TagInterface.TagBlockLayout());\r\n").Insert(0, "".PadLeft(linePadding + 4));
                        str2 = str2 + str6;
                        goto Label_0495;

                    case "core.TagInterface.Data":
                        str6 = ("public TagInterface.Data " + name + " = new TagInterface.Data(\"" + name.Replace("\"", "\\\"") + "\", Map.HaloVersionEnum." + ((Data) obj2).Halo_Version.ToString() + ", TagInterface.Data.RawDataTypes." + ((Data) obj2).Raw_Data_Type.ToString() + ");\r\n").Insert(0, "".PadLeft(linePadding + 4));
                        str2 = str2 + str6;
                        goto Label_0495;

                    case "core.TagInterface.Animation_Raw":
                        str6 = ("public TagInterface.Animation_Raw " + name + " = new TagInterface.Animation_Raw(\"" + name.Replace("\"", "\\\"") + "\", Map.HaloVersionEnum." + ((Data) obj2).Halo_Version.ToString() + ", TagInterface.Data.RawDataTypes." + ((Data) obj2).Raw_Data_Type.ToString() + ");\r\n").Insert(0, "".PadLeft(linePadding + 4));
                        str2 = str2 + str6;
                        goto Label_0495;

                    case "core.TagInterface.Sound_Raw":
                        str6 = ("public TagInterface.Sound_Raw " + name + " = new TagInterface.Sound_Raw(\"" + name.Replace("\"", "\\\"") + "\", Map.HaloVersionEnum." + ((Data) obj2).Halo_Version.ToString() + ", TagInterface.Data.RawDataTypes." + ((Data) obj2).Raw_Data_Type.ToString() + ");\r\n").Insert(0, "".PadLeft(linePadding + 4));
                        str2 = str2 + str6;
                        goto Label_0495;

                    case "core.TagInterface.HaloTagType":
                        str2 = str2 + ("public TagInterface.HaloTagType " + name + " = new TagInterface.HaloTagType(\"" + name.Replace("\"", "\\\"") + "\");\r\n").Insert(0, "".PadLeft(linePadding + 4));
                        goto Label_0495;

                    case "core.TagInterface.LongInteger":
                        str2 = str2 + ("public TagInterface.LongInteger " + name + " = new TagInterface.LongInteger(\"" + name.Replace("\"", "\\\"") + "\");\r\n").Insert(0, "".PadLeft(linePadding + 4));
                        goto Label_0495;

                    case "core.TagInterface.Padding":
                    {
                        strArray = new string[7];
                        strArray[0] = "public TagInterface.Padding ";
                        strArray[1] = name;
                        strArray[2] = " = new TagInterface.Padding(\"";
                        strArray[3] = obj2.Name;
                        strArray[4] = "\", ";
                        int size = obj2.Size;
                        strArray[5] = size.ToString();
                        strArray[6] = ");\r\n";
                        str2 = str2 + string.Concat(strArray).Insert(0, "".PadLeft(linePadding + 4));
                        goto Label_0495;
                    }
                    case "core.TagInterface.Pointer":
                        str2 = str2 + ("public TagInterface.Pointer " + name + " = new TagInterface.Pointer(\"" + name.Replace("\"", "\\\"") + "\");\r\n").Insert(0, "".PadLeft(linePadding + 4));
                        goto Label_0495;

                    case "core.TagInterface.RealARGBColor":
                        str2 = str2 + ("public TagInterface.RealARGBColor " + name + " = new TagInterface.RealARGBColor(\"" + name.Replace("\"", "\\\"") + "\");\r\n").Insert(0, "".PadLeft(linePadding + 4));
                        goto Label_0495;

                    case "core.TagInterface.RGBAColor":
                        str2 = str2 + ("public TagInterface.RGBAColor " + name + " = new TagInterface.RealARGBColor(\"" + name.Replace("\"", "\\\"") + "\");\r\n").Insert(0, "".PadLeft(linePadding + 4));
                        goto Label_0495;

                    case "core.TagInterface.RealBounds":
                        str2 = str2 + ("public TagInterface.RealBounds " + name + " = new TagInterface.RealBounds(\"" + name.Replace("\"", "\\\"") + "\");\r\n").Insert(0, "".PadLeft(linePadding + 4));
                        goto Label_0495;

                    case "core.TagInterface.RealEulerAngles3D":
                        str2 = str2 + ("public TagInterface.RealEulerAngles3D " + name + " = new TagInterface.RealEulerAngles3D(\"" + name.Replace("\"", "\\\"") + "\");\r\n").Insert(0, "".PadLeft(linePadding + 4));
                        goto Label_0495;

                    case "core.TagInterface.RealFloat":
                        str2 = str2 + ("public TagInterface.RealFloat " + name + " = new TagInterface.RealFloat(\"" + name.Replace("\"", "\\\"") + "\");\r\n").Insert(0, "".PadLeft(linePadding + 4));
                        goto Label_0495;

                    case "core.TagInterface.RealFraction":
                        str2 = str2 + ("public TagInterface.RealFraction " + name + " = new TagInterface.RealFraction(\"" + name.Replace("\"", "\\\"") + "\"\");\r\n").Insert(0, "".PadLeft(linePadding + 4));
                        goto Label_0495;

                    case "core.TagInterface.RealPlane2D":
                        str2 = str2 + ("public TagInterface.RealPlane2D " + name + " = new TagInterface.RealPlane2D(\"" + name.Replace("\"", "\\\"") + "\");\r\n").Insert(0, "".PadLeft(linePadding + 4));
                        goto Label_0495;

                    case "core.TagInterface.RealPlane3D":
                        str2 = str2 + ("public TagInterface.RealPlane3D " + name + " = new TagInterface.RealPlane3D(\"" + name.Replace("\"", "\\\"") + "\");\r\n").Insert(0, "".PadLeft(linePadding + 4));
                        goto Label_0495;

                    case "core.TagInterface.RealPoint3D":
                        str2 = str2 + ("public TagInterface.RealPoint3D " + name + " = new TagInterface.RealPoint3D(\"" + name.Replace("\"", "\\\"") + "\");\r\n").Insert(0, "".PadLeft(linePadding + 4));
                        goto Label_0495;

                    case "core.TagInterface.RealQuaternion":
                        str2 = str2 + ("public TagInterface.RealQuaternion " + name + " = new TagInterface.RealQuaternion(\"" + name.Replace("\"", "\\\"") + "\");\r\n").Insert(0, "".PadLeft(linePadding + 4));
                        goto Label_0495;

                    case "core.TagInterface.RealRGBColor":
                        str2 = str2 + ("public TagInterface.RealRGBColor " + name + " = new TagInterface.RealRGBColor(\"" + name.Replace("\"", "\\\"") + "\");\r\n").Insert(0, "".PadLeft(linePadding + 4));
                        goto Label_0495;

                    case "core.TagInterface.RealVector3D":
                        str2 = str2 + ("public TagInterface.RealVector3D " + name + " = new TagInterface.RealVector3D(\"" + name.Replace("\"", "\\\"") + "\");\r\n").Insert(0, "".PadLeft(linePadding + 4));
                        goto Label_0495;

                    case "core.TagInterface.ShortInteger":
                        str2 = str2 + ("public TagInterface.ShortInteger " + name + " = new TagInterface.ShortInteger(\"" + name.Replace("\"", "\\\"") + "\");\r\n").Insert(0, "".PadLeft(linePadding + 4));
                        goto Label_0495;

                    case "core.TagInterface.String":
                        strArray = new string[] { "public TagInterface.String ", name, " = new TagInterface.String(\"", name.Replace("\"", "\\\""), "\", ", obj2.Size.ToString(), ");\r\n" };
                        str2 = str2 + string.Concat(strArray).Insert(0, "".PadLeft(linePadding + 4));
                        goto Label_0495;

                    case "core.TagInterface.StringID":
                        str2 = str2 + ("public TagInterface.StringID " + name + " = new TagInterface.StringID(\"" + name.Replace("\"", "\\\"") + "\");\r\n").Insert(0, "".PadLeft(linePadding + 4));
                        goto Label_0495;

                    case "core.TagInterface.TagBlock":
                        str2 = str2 + ("public TagInterface.TagBlock " + name + " = new TagInterface.TagBlock(\"" + name.Replace("\"", "\\\"") + "\", " + name + "_Layout.Layout, Map.HaloVersionEnum." + MapType.ToString() + ");\r\n").Insert(0, "".PadLeft(linePadding + 4));
                        str3 = str3 + RecursiveWriteCSClass(((TagBlock) obj2).Layout, linePadding + 4, name + "_Layout");
                        goto Label_0495;

                    case "core.TagInterface.TagBlockIndex":
                        switch (((TagBlockIndex) obj2).IndexType)
                        {
                            case TagBlockIndex.TagBlockIndexType.Word:
                                goto Label_145E;

                            case TagBlockIndex.TagBlockIndexType.Long:
                                goto Label_14C0;

                            case TagBlockIndex.TagBlockIndexType.Byte:
                                goto Label_13F9;
                        }
                        goto Label_0495;

                    case "core.TagInterface.TagIdent":
                        str2 = str2 + ("public TagInterface.TagIdent " + name + " = new TagInterface.TagIdent(\"" + name.Replace("\"", "\\\"") + "\");\r\n").Insert(0, "".PadLeft(linePadding + 4));
                        goto Label_0495;

                    case "core.TagInterface.TagReference":
                        str2 = str2 + ("public TagInterface.TagReference " + name + " = new TagInterface.TagReference(\"" + name.Replace("\"", "\\\"") + "\", Map.HaloVersionEnum." + MapType.ToString() + ");\r\n").Insert(0, "".PadLeft(linePadding + 4));
                        goto Label_0495;

                    default:
                        goto Label_160D;
                }
            Label_0495:
                str = str + "Add(".Insert(0, "".PadLeft(linePadding + 8)) + name + ");\r\n";
                goto Label_1631;
            Label_05B3:;
                str2 = str2 + ("public TagInterface.Flags " + name + " = new TagInterface.Flags(\"" + name.Replace("\"", "\\\"") + "\", TagInterface.Flags.BitmaskTypeEnum.Word);\r\n").Insert(0, "".PadLeft(linePadding + 4));
                goto Label_0495;
            Label_0615:;
                str2 = str2 + ("public TagInterface.Flags " + name + " = new TagInterface.Flags(\"" + name.Replace("\"", "\\\"") + "\", TagInterface.Flags.BitmaskTypeEnum.Long);\r\n").Insert(0, "".PadLeft(linePadding + 4));
                goto Label_0495;
            Label_076D:;
                str2 = str2 + ("public TagInterface.core.TagInterface.TagEnumerator " + name + " = new TagInterface.core.TagInterface.TagEnumerator(\"" + name.Replace("\"", "\\\"") + "\", TagInterface.core.TagInterface.TagEnumerator.TagEnumeratorIndexType.Byte);\r\n").Insert(0, "".PadLeft(linePadding + 4));
                goto Label_0495;
            Label_07D2:;
                str2 = str2 + ("public TagInterface.core.TagInterface.TagEnumerator " + name + " = new TagInterface.core.TagInterface.TagEnumerator(\"" + name.Replace("\"", "\\\"") + "\", TagInterface.core.TagInterface.TagEnumerator.TagEnumeratorIndexType.Word);\r\n").Insert(0, "".PadLeft(linePadding + 4));
                goto Label_0495;
            Label_0834:;
                str2 = str2 + ("public TagInterface.core.TagInterface.TagEnumerator " + name + " = new TagInterface.core.TagInterface.TagEnumerator(\"" + name.Replace("\"", "\\\"") + "\", TagInterface.core.TagInterface.TagEnumerator.TagEnumeratorIndexType.Long);\r\n").Insert(0, "".PadLeft(linePadding + 4));
                goto Label_0495;
            Label_13F9:;
                str2 = str2 + ("public TagInterface.TagBlockIndex " + name + " = new TagInterface.TagBlockIndex(\"" + name.Replace("\"", "\\\"") + "\", TagInterface.TagBlockIndex.TagBlockIndexType.Byte);\r\n").Insert(0, "".PadLeft(linePadding + 4));
                goto Label_0495;
            Label_145E:;
                str2 = str2 + ("public TagInterface.TagBlockIndex " + name + " = new TagInterface.TagBlockIndex(\"" + name.Replace("\"", "\\\"") + "\", TagInterface.TagBlockIndex.TagBlockIndexType.Word);\r\n").Insert(0, "".PadLeft(linePadding + 4));
                goto Label_0495;
            Label_14C0:;
                str2 = str2 + ("public TagInterface.TagBlockIndex " + name + " = new TagInterface.TagBlockIndex(\"" + name.Replace("\"", "\\\"") + "\", TagInterface.TagBlockIndex.TagBlockIndexType.Long);\r\n").Insert(0, "".PadLeft(linePadding + 4));
                goto Label_0495;
            Label_160D:
                MessageBox.Show("you missed type \"" + obj2.GetType().ToString() + "\"");
            Label_1631:;
            }
            string str9 = str2;
            return (((str9 + "public ".Insert(0, "".PadLeft(linePadding + 4)) + className + "()\r\n" + "{".Insert(0, "".PadLeft(linePadding + 4)) + "\r\n" + str + "}\r\n".Insert(0, "".PadLeft(linePadding + 4))) + str3) + ("public static readonly " + className + " Layout = new " + className + "();\r\n").Insert(0, "".PadLeft(linePadding + 4)) + "}\r\n".Insert(0, "".PadLeft(linePadding)));
        }

        private static void RecursiveWriteXML(ref XmlTextWriter xtw, TagBlockLayout BO, bool writeOffset)
        {
            foreach (BaseObject obj2 in BO)
            {
                int size;
                switch (obj2.GetType().ToString())
                {
                    case "core.TagInterface+Angle":
                        xtw.WriteStartElement("Angle");
                        goto Label_0696;

                    case "core.TagInterface+Raw_Tag_Block":
                        xtw.WriteStartElement("Raw_Tag_Block");
                        xtw.WriteAttributeString("RawDataType", ((Raw_Tag_Block) obj2).Raw_Data_Type.ToString());
                        goto Label_0696;

                    case "core.TagInterface+Unicode_Raw":
                        xtw.WriteStartElement("Unicode_Raw");
                        goto Label_0696;

                    case "core.TagInterface+Sound_Raw":
                        xtw.WriteStartElement("Sound_Raw");
                        goto Label_0696;

                    case "core.TagInterface+Animation_Raw":
                        xtw.WriteStartElement("Animation_Raw");
                        goto Label_0696;

                    case "core.TagInterface+Bitmap_Raw":
                        xtw.WriteStartElement("Bitmap_Raw");
                        goto Label_0696;

                    case "core.TagInterface+Data":
                        xtw.WriteStartElement("Data");
                        xtw.WriteAttributeString("RawDataType", ((Raw_Tag_Block) obj2).Raw_Data_Type.ToString());
                        goto Label_0696;

                    case "core.TagInterface+Flags":
                        switch (((core.TagInterface.Flags) obj2).BitmaskType)
                        {
                            case core.TagInterface.Flags.BitmaskTypeEnum.Word:
                                goto Label_03A6;

                            case core.TagInterface.Flags.BitmaskTypeEnum.Long:
                                goto Label_03B6;
                        }
                        goto Label_0696;

                    case "core.TagInterface+ByteInteger":
                        xtw.WriteStartElement("ByteInteger");
                        goto Label_0696;

                    case "core.TagInterface+EnumerableIndex":
                        xtw.WriteStartElement("EnumerableIndex");
                        goto Label_0696;

                    case "core.TagInterface+core.TagInterface.TagEnumerator":
                        xtw.WriteStartElement("core.TagInterface.TagEnumerator");
                        goto Label_0696;

                    case "core.TagInterface+HaloTagType":
                        xtw.WriteStartElement("HaloTagType");
                        goto Label_0696;

                    case "core.TagInterface+LongInteger":
                        xtw.WriteStartElement("LongInteger");
                        goto Label_0696;

                    case "core.TagInterface+Padding":
                        xtw.WriteStartElement("Padding");
                        size = ((core.TagInterface.Padding) obj2).Size;
                        xtw.WriteAttributeString("Size", size.ToString());
                        goto Label_0696;

                    case "core.TagInterface+Pointer":
                        xtw.WriteStartElement("Pointer");
                        goto Label_0696;

                    case "core.TagInterface+RealARGBColor":
                        xtw.WriteStartElement("RealARGBColor");
                        goto Label_0696;

                    case "core.TagInterface+RealBounds":
                        xtw.WriteStartElement("RealBounds");
                        goto Label_0696;

                    case "core.TagInterface+RealEulerAngles3D":
                        xtw.WriteStartElement("RealEulerAngles3D");
                        goto Label_0696;

                    case "core.TagInterface+RealFloat":
                        xtw.WriteStartElement("RealFloat");
                        goto Label_0696;

                    case "core.TagInterface+RealFraction":
                        xtw.WriteStartElement("RealFraction");
                        goto Label_0696;

                    case "core.TagInterface+RealPlane2D":
                        xtw.WriteStartElement("RealPlane2D");
                        goto Label_0696;

                    case "core.TagInterface+RealPlane3D":
                        xtw.WriteStartElement("RealPlane3D");
                        goto Label_0696;

                    case "core.TagInterface+RealPoint3D":
                        xtw.WriteStartElement("RealPoint3D");
                        goto Label_0696;

                    case "core.TagInterface+RealQuaternion":
                        xtw.WriteStartElement("RealQuaternion");
                        goto Label_0696;

                    case "core.TagInterface+RGBAColor":
                        xtw.WriteStartElement("RGBAColor");
                        goto Label_0696;

                    case "core.TagInterface+RealRGBColor":
                        xtw.WriteStartElement("RealRGBColor");
                        goto Label_0696;

                    case "core.TagInterface+RealVector3D":
                        xtw.WriteStartElement("RealVector3D");
                        goto Label_0696;

                    case "core.TagInterface+ShortInteger":
                        xtw.WriteStartElement("ShortInteger");
                        goto Label_0696;

                    case "core.TagInterface+String":
                        xtw.WriteStartElement("String");
                        xtw.WriteAttributeString("Length", ((core.TagInterface.String) obj2).stringlength.ToString());
                        goto Label_0696;

                    case "core.TagInterface+StringID":
                        xtw.WriteStartElement("StringID");
                        goto Label_0696;

                    case "core.TagInterface+TagBlock":
                        xtw.WriteStartElement("TagBlock");
                        xtw.WriteAttributeString("Name", obj2.Name);
                        if (writeOffset)
                        {
                            size = obj2.Offset;
                            xtw.WriteAttributeString("Offset", size.ToString());
                        }
                        if (((TagBlock) obj2).Padding_Interval != 0)
                        {
                            size = ((TagBlock) obj2).Padding_Interval;
                            xtw.WriteAttributeString("Padding_Interval", size.ToString());
                        }
                        RecursiveWriteXML(ref xtw, ((TagBlock) obj2).Layout, writeOffset);
                        xtw.WriteEndElement();
                        goto Label_0715;

                    case "core.TagInterface+TagBlockIndex":
                        xtw.WriteStartElement("TagBlockIndex");
                        xtw.WriteAttributeString("type", ((TagBlockIndex) obj2).IndexType.ToString());
                        goto Label_0696;

                    case "core.TagInterface+TagIdent":
                        xtw.WriteStartElement("TagIdent");
                        goto Label_0696;

                    case "core.TagInterface+TagReference":
                        xtw.WriteStartElement("TagReference");
                        goto Label_0696;

                    case "all":
                        goto Label_0696;

                    default:
                        MessageBox.Show("you missed type \"" + obj2.GetType().ToString() + "\"");
                        goto Label_0715;
                }
                xtw.WriteStartElement("ByteFlags");
                goto Label_0696;
            Label_03A6:
                xtw.WriteStartElement("WordFlags");
                goto Label_0696;
            Label_03B6:
                xtw.WriteStartElement("LongFlags");
            Label_0696:
                if (obj2.Name != "Padding")
                {
                    xtw.WriteAttributeString("Name", obj2.Name);
                }
                if (writeOffset)
                {
                    xtw.WriteAttributeString("Offset", obj2.Offset.ToString());
                }
                xtw.WriteEndElement();
            Label_0715:;
            }
        }

        public static void WriteCSClassEnt(string outputFilePath, TagBlockLayout TI, string tagtype)
        {
            StreamWriter writer = new StreamWriter(outputFilePath, false);
            writer.WriteLine("using System;");
            writer.WriteLine("using System.Collections.Generic;");
            writer.WriteLine("using System.Text;");
            writer.WriteLine("");
            writer.WriteLine("namespace core.H2");
            writer.WriteLine("{");
            writer.Write(RecursiveWriteCSClass(TI, 4, tagtype));
            writer.Write("}");
            writer.Close();
        }

        public static void WriteXMLEnt(string outputFilePath, TagBlockLayout TI)
        {
            XmlTextWriter xtw = new XmlTextWriter(outputFilePath, Encoding.Default);
            xtw.Formatting = Formatting.Indented;
            xtw.WriteStartElement("Plugin");
            xtw.WriteAttributeString("Class", TI.Parent.Name);
            xtw.WriteAttributeString("Header_Size", TI.Chunk_Size.ToString());
            RecursiveWriteXML(ref xtw, TI, true);
            xtw.WriteEndElement();
            xtw.Close();
        }
    }
}

