﻿namespace core
{
    using System;
    using System.Collections;
    using System.Collections.Generic;
    using System.Windows.Forms;

    public class FormFunctions
    {
        public List<ListViewItem> ListItems = new List<ListViewItem>();
        private Hashtable root = new Hashtable();

        public void AddMetaByFolderToTreeView(ref Map map, ref TreeView tv, bool checkbox)
        {
            tv.Nodes.Clear();
            tv.Sorted = false;
            tv.Nodes.Add(this.FolderNode(map.FilePath, ""));
            tv.Nodes[0].Checked = true;
            if (checkbox)
            {
                tv.CheckBoxes = true;
            }
            for (int i = 0; i < map.Index_Header.Meta_Count; i++)
            {
                string[] strArray = map.FileName[i].Name.Split(new char[] { '\\' });
                Hashtable root = this.root;
                TreeNode node = tv.Nodes[0];
                string path = "";
                for (int j = 0; j < (strArray.Length - 1); j++)
                {
                    string key = strArray[j];
                    path = path + key + @"\";
                    if (!root.ContainsKey(key))
                    {
                        root.Add(key, new Hashtable());
                        TreeNode node2 = this.FolderNode(key, path);
                        node2.Checked = checkbox;
                        node.Nodes.Add(node2);
                    }
                    root = (Hashtable) root[key];
                    node = this.FindNode(node, path);
                }
                root.Add(strArray[strArray.GetUpperBound(0)] + "." + map.Meta[i].TagType, i);
                TreeNode node3 = this.FolderNode(strArray[strArray.GetUpperBound(0)] + "." + map.Meta[i].TagType, map.FileName[i].Name + "." + map.Meta[i].TagType);
                node3.Checked = checkbox;
                node.Nodes.Add(node3);
            }
            tv.Nodes[0].Expand();
            tv.Sorted = true;
        }

        public void AddMetaByTagTypeToTreeView(ref Map map, ref TreeView tv, bool checkbox)
        {
            tv.Nodes.Clear();
            tv.Sorted = false;
            if (checkbox)
            {
                tv.CheckBoxes = true;
            }
            Hashtable hashtable = new Hashtable();
            foreach (string str in map.Meta.TagTypes)
            {
                hashtable.Add(str, tv.Nodes.Count);
                tv.Nodes.Add(str);
            }
            for (int i = 0; i < map.Index_Header.Meta_Count; i++)
            {
                object obj2 = hashtable[map.Meta[i].TagType];
                TreeNode node = new TreeNode(map.FileName[i].Name);
                node.Checked = checkbox;
                tv.Nodes[(int) obj2].Nodes.Add(node);
            }
            tv.Sorted = true;
        }

        private TreeNode FindNode(TreeNode root, string path)
        {
            for (int i = 0; i < root.Nodes.Count; i++)
            {
                if (((string) root.Nodes[i].Tag) == path)
                {
                    return root.Nodes[i];
                }
                if (path.StartsWith((string) root.Nodes[i].Tag))
                {
                    return this.FindNode(root.Nodes[i], path);
                }
            }
            return root;
        }

        private TreeNode FolderNode(string text, string path)
        {
            TreeNode node = new TreeNode(text);
            node.Tag = path;
            return node;
        }

        public enum MetaView
        {
            FolderView,
            TagTypeView
        }
    }
}

