﻿namespace core.H1
{
    using core.TagInterface;
    using System;

    public class coll : TagBlockLayout
    {
        public TagReference area_damage_effect = new TagReference("Area Damage Effect", Map.HaloVersionEnum.HaloCE);
        public RealFloat area_damage_effect_threshold = new RealFloat("Area Damage Effect Threshold");
        public TagReference body_damage_effect = new TagReference("Body Damage Effect", Map.HaloVersionEnum.HaloCE);
        public RealFloat body_damage_effect_threshold = new RealFloat("Body Damage Effect Threshold");
        public TagReference body_depleted_effect = new TagReference("Body Depleted Effect", Map.HaloVersionEnum.HaloCE);
        public TagReference body_destroyed_effect = new TagReference("Body Destroyed Effect", Map.HaloVersionEnum.HaloCE);
        public RealFloat body_destroyed_effect_threshold = new RealFloat("Body Destroyed Effect Threshold");
        public RealFloat body_system_shock = new RealFloat("Body System Shock");
        public RealFraction failing_shield_leak_fraction = new RealFraction("Failing Shield Leak Fraction");
        public core.TagInterface.Flags flags = new core.TagInterface.Flags("Flags", core.TagInterface.Flags.BitmaskTypeEnum.Long);
        public RealFraction friendly_damage_resistance = new RealFraction("Friendly Damage Resistance");
        public TagBlockIndex indirect_damage_material = new TagBlockIndex("Indirect Damage Material", TagBlockIndex.TagBlockIndexType.Word);
        public static readonly coll Layout = new coll();
        public TagReference localized_damage_effect = new TagReference("Localized Damage Effect", Map.HaloVersionEnum.HaloCE);
        public TagBlock materials = new TagBlock("Materials", Material.Layout, Map.HaloVersionEnum.HaloCE);
        public RealFloat maximum_body_vitality = new RealFloat("Maximum Body Vitality");
        public RealFloat maximum_shield_vitality = new RealFloat("Maximum Shield Vitality");
        public RealFloat minimum_stun_damage = new RealFloat("Minimum Stun Damage");
        public TagBlock modifiers = new TagBlock("Modifiers", Modifier.Layout, Map.HaloVersionEnum.HaloCE);
        public TagBlock nodes = new TagBlock("Nodes", Node.Layout, Map.HaloVersionEnum.HaloCE);
        public Padding padding1 = new Padding("Padding1", 0x34);
        public Padding padding2 = new Padding("Padding2", 40);
        public Padding padding3 = new Padding("Padding3", 0x18);
        public Padding padding4 = new Padding("Padding4", 0x10);
        public Padding padding5 = new Padding("Padding5", 0x70);
        public Padding padding6 = new Padding("Padding6", 0x7c);
        public Padding padding7 = new Padding("Padding7", 0x10);
        public RealBounds pathfinding_box_x_bounds = new RealBounds("Pathfinding Box X Bounds");
        public RealBounds pathfinding_box_y_bounds = new RealBounds("Pathfinding Box Y Bounds");
        public RealBounds pathfinding_box_z_bounds = new RealBounds("Pathfinding Box Z Bounds");
        public TagBlock pathfinding_spheres = new TagBlock("Pathfinding Spheres", Pathfinding_Sphere.Layout, Map.HaloVersionEnum.HaloCE);
        public RealFloat recharge_time = new RealFloat("Recharge Time");
        public TagBlock regions = new TagBlock("Regions", Region.Layout, Map.HaloVersionEnum.HaloCE);
        public TagReference shield_damaged_effect = new TagReference("Shield Damaged Effect", Map.HaloVersionEnum.HaloCE);
        public RealFloat shield_damaged_threshold = new RealFloat("Shield Damaged Threshold");
        public TagReference shield_depleted_effect = new TagReference("Shield Damaged Effect", Map.HaloVersionEnum.HaloCE);
        public core.TagInterface.Enumerator shield_failure_function = new core.TagInterface.Enumerator("Shield Failure Function", core.TagInterface.Enumerator.TagEnumeratorIndexType.Word);
        public RealFraction shield_failure_threshold = new RealFraction("Shield Failure Threshold");
        public core.TagInterface.Enumerator shield_material_type = new core.TagInterface.Enumerator("Shield Material Type", core.TagInterface.Enumerator.TagEnumeratorIndexType.Word);
        public TagReference shield_recharging_effect = new TagReference("Shield Recharging Effect", Map.HaloVersionEnum.HaloCE);
        public RealFloat stun_time = new RealFloat("Stun Time");
        public ShortInteger unknown1 = new ShortInteger("unknown1");
        public ShortInteger unknown2 = new ShortInteger("unknown2");
        public ShortInteger unknown3 = new ShortInteger("unknown2");

        public coll()
        {
            base.Add(this.flags);
            base.Add(this.indirect_damage_material);
            base.Add(this.unknown1);
            base.Add(this.maximum_body_vitality);
            base.Add(this.body_system_shock);
            base.Add(this.padding1);
            base.Add(this.friendly_damage_resistance);
            base.Add(this.padding2);
            base.Add(this.localized_damage_effect);
            base.Add(this.area_damage_effect_threshold);
            base.Add(this.area_damage_effect);
            base.Add(this.body_damage_effect_threshold);
            base.Add(this.body_damage_effect);
            base.Add(this.body_depleted_effect);
            base.Add(this.body_destroyed_effect_threshold);
            base.Add(this.body_destroyed_effect);
            base.Add(this.maximum_shield_vitality);
            base.Add(this.unknown2);
            base.Add(this.shield_material_type);
            base.Add(this.padding3);
            base.Add(this.shield_failure_function);
            base.Add(this.unknown3);
            base.Add(this.shield_failure_threshold);
            base.Add(this.failing_shield_leak_fraction);
            base.Add(this.padding4);
            base.Add(this.minimum_stun_damage);
            base.Add(this.stun_time);
            base.Add(this.recharge_time);
            base.Add(this.padding5);
            base.Add(this.shield_damaged_threshold);
            base.Add(this.shield_damaged_effect);
            base.Add(this.shield_depleted_effect);
            base.Add(this.shield_recharging_effect);
            base.Add(this.padding6);
            base.Add(this.materials);
            base.Add(this.regions);
            base.Add(this.modifiers);
            base.Add(this.padding7);
            base.Add(this.pathfinding_box_x_bounds);
            base.Add(this.pathfinding_box_y_bounds);
            base.Add(this.pathfinding_box_z_bounds);
            base.Add(this.pathfinding_spheres);
            base.Add(this.nodes);
        }

        public class Material : TagBlockLayout
        {
            public RealFloat body_damage_multiplier = new RealFloat("Body Damage Multiplier");
            public core.TagInterface.Flags flags = new core.TagInterface.Flags("Flags", core.TagInterface.Flags.BitmaskTypeEnum.Long);
            public static readonly coll.Material Layout = new coll.Material();
            public core.TagInterface.Enumerator material_type = new core.TagInterface.Enumerator("Material Type", core.TagInterface.Enumerator.TagEnumeratorIndexType.Word);
            public core.TagInterface.String name = new core.TagInterface.String("Name", 0x20);
            public Padding padding = new Padding("Padding", 2);
            public Padding padding2 = new Padding("Padding", 12);
            private Padding padding3 = new Padding("Padding", 8);
            public RealFloat shield_damage_multiplier = new RealFloat("Shield Damage Multiplier");
            public RealFraction shield_leak_percentage = new RealFraction("Shield Leak Percentage");

            public Material()
            {
                base.Add(this.name);
                base.Add(this.flags);
                base.Add(this.material_type);
                base.Add(this.padding);
                base.Add(this.shield_leak_percentage);
                base.Add(this.shield_damage_multiplier);
                base.Add(this.padding2);
                base.Add(this.body_damage_multiplier);
                base.Add(this.padding3);
            }
        }

        public class Modifier : TagBlockLayout
        {
            public static readonly coll.Modifier Layout = new coll.Modifier();
        }

        public class Node : TagBlockLayout
        {
            public TagBlock bsp = new TagBlock("BSP", SBSP.BSP.Layout, Map.HaloVersionEnum.HaloCE);
            public TagBlockIndex child_node = new TagBlockIndex("Child Node", TagBlockIndex.TagBlockIndexType.Word);
            public static readonly coll.Node Layout = new coll.Node();
            public core.TagInterface.String name = new core.TagInterface.String("Name", 0x20);
            public Padding padding = new Padding("Padding", 10);
            public TagBlockIndex parent_node = new TagBlockIndex("Parent Node", TagBlockIndex.TagBlockIndexType.Word);
            public TagBlockIndex region = new TagBlockIndex("Region", TagBlockIndex.TagBlockIndexType.Word);
            public TagBlockIndex sibling_node = new TagBlockIndex("Sibling Node", TagBlockIndex.TagBlockIndexType.Word);
            public ShortInteger unknown1 = new ShortInteger("Unknown1");

            public Node()
            {
                base.Add(this.name);
                base.Add(this.region);
                base.Add(this.parent_node);
                base.Add(this.sibling_node);
                base.Add(this.child_node);
                base.Add(this.padding);
                base.Add(this.unknown1);
                base.Add(this.bsp);
            }
        }

        public class Pathfinding_Sphere : TagBlockLayout
        {
            public RealPoint3D center = new RealPoint3D("Center");
            public static readonly coll.Pathfinding_Sphere Layout = new coll.Pathfinding_Sphere();
            public TagBlockIndex node = new TagBlockIndex("Node", TagBlockIndex.TagBlockIndexType.Long);
            public Padding padding = new Padding("Padding", 12);
            public RealFloat radius = new RealFloat("Radius");

            public Pathfinding_Sphere()
            {
                base.Add(this.node);
                base.Add(this.padding);
                base.Add(this.center);
                base.Add(this.radius);
            }
        }

        public class Region : TagBlockLayout
        {
            public RealFloat damage_threshold = new RealFloat("Damage Threshold");
            public TagReference destroyed_effect = new TagReference("Destroyed Effect", Map.HaloVersionEnum.HaloCE);
            public core.TagInterface.Flags flags = new core.TagInterface.Flags("Flags", core.TagInterface.Flags.BitmaskTypeEnum.Long);
            public static readonly coll.Region Layout = new coll.Region();
            public core.TagInterface.String name = new core.TagInterface.String("Name", 0x20);
            public Padding padding1 = new Padding("Padding", 4);
            public Padding padding2 = new Padding("Padding", 12);
            public TagBlock permutations = new TagBlock("Permutations", Permutation.Layout, Map.HaloVersionEnum.HaloCE);

            public Region()
            {
                base.Add(this.name);
                base.Add(this.flags);
                base.Add(this.padding1);
                base.Add(this.damage_threshold);
                base.Add(this.padding2);
                base.Add(this.destroyed_effect);
                base.Add(this.permutations);
            }

            public class Permutation : TagBlockLayout
            {
                public static readonly coll.Region.Permutation Layout = new coll.Region.Permutation();
                public core.TagInterface.String name = new core.TagInterface.String("Name", 0x20);

                public Permutation()
                {
                    base.Add(this.name);
                }
            }
        }
    }
}

