﻿namespace core.H1
{
    using core.TagInterface;
    using System;

    public class mod2 : TagBlockLayout
    {
        public RealFloat base_map_u_scale = new RealFloat("Base Map U-Scale");
        public RealFloat base_map_v_scale = new RealFloat("Base Map V-Scale");
        public core.TagInterface.Flags flags = new core.TagInterface.Flags("Flags", core.TagInterface.Flags.BitmaskTypeEnum.Long);
        public TagBlock geometries = new TagBlock("Geometry", Geometry.Layout, Map.HaloVersionEnum.HaloCE);
        public RealFloat high_detail_cutoff = new RealFloat("High Detail Cutoff");
        public ShortInteger high_detail_node_count = new ShortInteger("High Detail Node Count");
        public static readonly mod2 Layout = new mod2();
        public RealFloat low_detail_cutoff = new RealFloat("Low Detail Cutoff");
        public ShortInteger low_detail_node_count = new ShortInteger("Low Detail Node Count");
        public TagBlock markers = new TagBlock("Markers", Marker.Layout, Map.HaloVersionEnum.HaloCE);
        public RealFloat medium_detail_cutoff = new RealFloat("Medium Detail Cutoff");
        public ShortInteger medium_detail_node_count = new ShortInteger("Medium Detail Node Count");
        public LongInteger node_list_checksum = new LongInteger("Node List Checksum");
        public TagBlock nodes = new TagBlock("Nodes", Node.Layout, Map.HaloVersionEnum.HaloCE);
        public Padding padding1 = new Padding("Padding 1", 0x74);
        public TagBlock regions = new TagBlock("Regions", Region.Layout, Map.HaloVersionEnum.HaloCE);
        public TagBlock shaders = new TagBlock("model_shader_reference_blocks", model_shader_reference_block.Layout, Map.HaloVersionEnum.HaloCE);
        public RealFloat super_high_detail_cutoff = new RealFloat("Super-High Detail Cutoff");
        public ShortInteger super_high_detail_node_count = new ShortInteger("Super-High Detail Node Count");
        public RealFloat super_low_cutoff = new RealFloat("Super-Low Cutoff");
        public ShortInteger super_low_node_count = new ShortInteger("Super-Low Node Count");
        public RealFloat unknown1 = new RealFloat("Unknown 1");
        public RealFloat unknown2 = new RealFloat("Unknown 2");
        public ShortInteger unknown3 = new ShortInteger("Unknown 3");

        public mod2()
        {
            base.Add(this.flags);
            base.Add(this.node_list_checksum);
            base.Add(this.super_low_cutoff);
            base.Add(this.low_detail_cutoff);
            base.Add(this.medium_detail_cutoff);
            base.Add(this.high_detail_cutoff);
            base.Add(this.super_high_detail_cutoff);
            base.Add(this.super_low_node_count);
            base.Add(this.low_detail_node_count);
            base.Add(this.medium_detail_node_count);
            base.Add(this.high_detail_node_count);
            base.Add(this.super_high_detail_node_count);
            base.Add(this.unknown3);
            base.Add(this.base_map_u_scale);
            base.Add(this.base_map_v_scale);
            base.Add(this.unknown1);
            base.Add(this.unknown2);
            base.Add(this.padding1);
            base.Add(this.markers);
            base.Add(this.nodes);
            base.Add(this.regions);
            base.Add(this.geometries);
        }

        public model_shader_reference_block GetShader(int element)
        {
            return (this.shaders.Chunks[element] as model_shader_reference_block);
        }

        public class Geometry : TagBlockLayout
        {
            public RealPoint3D Centroid = new RealPoint3D("Centroid");
            public ShortInteger CentroidPrimaryNode = new ShortInteger("CentroidPrimaryNode");
            public RealFraction CentroidPrimaryWeight = new RealFraction("CentroidPrimaryWeight");
            public ShortInteger CentroidSecondaryNode = new ShortInteger("CentroidSecondaryNode");
            public RealFraction CentroidSecondaryWeight = new RealFraction("CentroidSecondaryWeight");
            public TagBlock CompressedVertices = new TagBlock("CompressedVertices", model_vertex_compressed_block.Layout, Map.HaloVersionEnum.HaloCE);
            public core.TagInterface.Flags Flags = new core.TagInterface.Flags("Flags", core.TagInterface.Flags.BitmaskTypeEnum.Long);
            public static readonly mod2.Geometry Layout = new mod2.Geometry();
            public ByteInteger NextFilthyPartIndex = new ByteInteger("NextFilthyPartIndex");
            public Padding padding1 = new Padding(0x40);
            public ByteInteger PrevFilthyPartIndex = new ByteInteger("PrevFilthyPartIndex");
            public TagBlockIndex ShaderIndex = new TagBlockIndex("Shader Index", TagBlockIndex.TagBlockIndexType.Word);
            public TagBlock Triangles = new TagBlock("Triangles", model_triangle_block.Layout, Map.HaloVersionEnum.HaloCE);
            public TagBlock UncompressedVertices = new TagBlock("UncompressedVertices", model_vertex_uncompressed_block.Layout, Map.HaloVersionEnum.HaloCE);

            public Geometry()
            {
                base.Add(this.Flags);
                base.Add(this.ShaderIndex);
                base.Add(this.PrevFilthyPartIndex);
                base.Add(this.NextFilthyPartIndex);
                base.Add(this.CentroidPrimaryNode);
                base.Add(this.CentroidSecondaryNode);
                base.Add(this.CentroidPrimaryWeight);
                base.Add(this.CentroidSecondaryWeight);
                base.Add(this.Centroid);
                base.Add(this.UncompressedVertices);
                base.Add(this.CompressedVertices);
                base.Add(this.Triangles);
                base.Add(this.padding1);
            }

            public class model_triangle_block : TagBlockLayout
            {
                public static readonly mod2.Geometry.model_triangle_block Layout = new mod2.Geometry.model_triangle_block();
                public ShortInteger[] VertexIndex = new ShortInteger[3];

                public model_triangle_block()
                {
                    this.VertexIndex[0] = new ShortInteger("Vertex Index 0");
                    this.VertexIndex[1] = new ShortInteger("Vertex Index 1");
                    this.VertexIndex[2] = new ShortInteger("Vertex Index 2");
                    base.Add(this.VertexIndex[0]);
                    base.Add(this.VertexIndex[1]);
                    base.Add(this.VertexIndex[2]);
                }
            }

            public class model_vertex_compressed_block : TagBlockLayout
            {
                public LongInteger Binormal = new LongInteger("Binormal");
                public static readonly mod2.Geometry.model_vertex_compressed_block Layout = new mod2.Geometry.model_vertex_compressed_block();
                public ByteInteger[] NodeIndex = new ByteInteger[2];
                public ShortInteger[] NodeWeight = new ShortInteger[1];
                public LongInteger Normal = new LongInteger("Normal");
                public RealPoint3D Position = new RealPoint3D("Position");
                public LongInteger Tangent = new LongInteger("Tangent");
                public ShortInteger TextureCoordU = new ShortInteger("Texture Coordinate U");
                public ShortInteger TextureCoordV = new ShortInteger("Texture Coordinate V");

                public model_vertex_compressed_block()
                {
                    this.NodeIndex[0] = new ByteInteger("NodeIndex 0");
                    this.NodeIndex[1] = new ByteInteger("NodeIndex 1");
                    this.NodeWeight[0] = new ShortInteger("NodeWeight");
                    base.Add(this.Position);
                    base.Add(this.Normal);
                    base.Add(this.Binormal);
                    base.Add(this.Tangent);
                    base.Add(this.TextureCoordU);
                    base.Add(this.TextureCoordV);
                    base.Add(this.NodeIndex[0]);
                    base.Add(this.NodeIndex[1]);
                    base.Add(this.NodeWeight[0]);
                }
            }

            public class model_vertex_uncompressed_block : TagBlockLayout
            {
                public RealVector3D Binormal = new RealVector3D("Binormal");
                public static readonly mod2.Geometry.model_vertex_uncompressed_block Layout = new mod2.Geometry.model_vertex_uncompressed_block();
                public ShortInteger[] NodeIndex = new ShortInteger[2];
                public RealFloat[] NodeWeight = new RealFloat[2];
                public RealVector3D Normal = new RealVector3D("Normal");
                public RealPoint3D Position = new RealPoint3D("Position");
                public RealVector3D Tangent = new RealVector3D("Tangent");
                public RealPoint2D TextureCoords = new RealPoint2D("TextureCoords");

                public model_vertex_uncompressed_block()
                {
                    this.NodeIndex[0] = new ShortInteger("NodeIndex 0");
                    this.NodeIndex[1] = new ShortInteger("NodeIndex 1");
                    this.NodeWeight[0] = new RealFloat("NodeWeight 0");
                    this.NodeWeight[1] = new RealFloat("NodeWeight 1");
                    base.Add(this.Position);
                    base.Add(this.Normal);
                    base.Add(this.Binormal);
                    base.Add(this.Tangent);
                    base.Add(this.TextureCoords);
                    base.Add(this.NodeIndex[0]);
                    base.Add(this.NodeIndex[1]);
                    base.Add(this.NodeWeight[0]);
                    base.Add(this.NodeWeight[1]);
                }
            }
        }

        public class Marker : TagBlockLayout
        {
            public TagBlock instances = new TagBlock("Instaces", Instance.Layout, Map.HaloVersionEnum.HaloCE);
            public static readonly mod2.Marker Layout = new mod2.Marker();
            public ShortInteger magicid = new ShortInteger("Magic Identifier");
            public core.TagInterface.String name = new core.TagInterface.String("Node Name", 0x20);
            public Padding pad1 = new Padding(0x12);

            public Marker()
            {
                base.Add(this.name);
                base.Add(this.magicid);
                base.Add(this.pad1);
                base.Add(this.instances);
            }

            public class Instance : TagBlockLayout
            {
                public static readonly mod2.Marker.Instance Layout = new mod2.Marker.Instance();
                public ShortInteger nodeid = new ShortInteger("Node Index");
                public ByteInteger permutationindex = new ByteInteger("Permutation Index");
                public RealQuaternion quaternion = new RealQuaternion("Quaternion");
                public ByteInteger regionindex = new ByteInteger("Region Index");
                public RealPoint3D translation = new RealPoint3D("Translation");

                public Instance()
                {
                    base.Add(this.regionindex);
                    base.Add(this.permutationindex);
                    base.Add(this.nodeid);
                    base.Add(this.translation);
                    base.Add(this.quaternion);
                }
            }
        }

        public class model_shader_reference_block : TagBlockLayout
        {
            public static readonly mod2.model_shader_reference_block Layout = new mod2.model_shader_reference_block();
            public Padding padding1 = new Padding(14);
            public ShortInteger Permutation = new ShortInteger("Permutation");
            public TagReference Shader = new TagReference("Shader", Map.HaloVersionEnum.HaloCE);

            public model_shader_reference_block()
            {
                base.Add(this.Shader);
                base.Add(this.Permutation);
                base.Add(this.padding1);
            }
        }

        public class Node : TagBlockLayout
        {
            public ShortInteger child = new ShortInteger("Child");
            public RealQuaternion default_rotation = new RealQuaternion("Default Rotation");
            public RealPoint3D default_translation = new RealPoint3D("Default Translation");
            public static readonly mod2.Node Layout = new mod2.Node();
            public core.TagInterface.String name = new core.TagInterface.String("Node Name", 0x20);
            public RealFloat node_distance_from_parent = new RealFloat("Node Distance From Parent");
            public Padding padding1 = new Padding("Padding 1", 0x20);
            public ShortInteger parent = new ShortInteger("Parent");
            public ShortInteger sibling = new ShortInteger("Sibling");
            public ShortInteger unknown1 = new ShortInteger("Unknown1");
            public Padding unknown2 = new Padding("Unknown Floats", 0x34);

            public Node()
            {
                base.Add(this.name);
                base.Add(this.sibling);
                base.Add(this.child);
                base.Add(this.parent);
                base.Add(this.unknown1);
                base.Add(this.default_translation);
                base.Add(this.default_rotation);
                base.Add(this.node_distance_from_parent);
                base.Add(this.padding1);
                base.Add(this.unknown2);
            }
        }

        public class Region : TagBlockLayout
        {
            public static readonly mod2.Region Layout = new mod2.Region();
            public core.TagInterface.String name = new core.TagInterface.String("Name", 0x20);
            public Padding padding1 = new Padding(0x20);
            public TagBlock permutations = new TagBlock("Permutations", Region_Permutation.Layout, Map.HaloVersionEnum.HaloCE);

            public Region()
            {
                base.Add(this.name);
                base.Add(this.padding1);
                base.Add(this.permutations);
            }

            public class Region_Permutation : TagBlockLayout
            {
                public core.TagInterface.Flags flags = new core.TagInterface.Flags("Flags", core.TagInterface.Flags.BitmaskTypeEnum.Long);
                public TagBlockIndex high = new TagBlockIndex("High", TagBlockIndex.TagBlockIndexType.Word);
                public static readonly mod2.Region.Region_Permutation Layout = new mod2.Region.Region_Permutation();
                public TagBlockIndex low = new TagBlockIndex("Low", TagBlockIndex.TagBlockIndexType.Word);
                public TagBlock markers = new TagBlock("Region_Permutation_Marker", Region_Permutation_Marker.Layout, Map.HaloVersionEnum.HaloCE);
                public TagBlockIndex medium = new TagBlockIndex("Medium", TagBlockIndex.TagBlockIndexType.Word);
                public core.TagInterface.String name = new core.TagInterface.String("Name", 0x20);
                public Padding padding1 = new Padding(0x1c);
                public Padding padding2 = new Padding(2);
                public TagBlockIndex super_high = new TagBlockIndex("Super High", TagBlockIndex.TagBlockIndexType.Word);
                public TagBlockIndex super_low = new TagBlockIndex("Super Low", TagBlockIndex.TagBlockIndexType.Word);

                public Region_Permutation()
                {
                    base.Add(this.name);
                    base.Add(this.flags);
                    base.Add(this.padding1);
                    base.Add(this.super_low);
                    base.Add(this.low);
                    base.Add(this.medium);
                    base.Add(this.high);
                    base.Add(this.super_high);
                    base.Add(this.padding2);
                    base.Add(this.markers);
                }

                public class Region_Permutation_Marker : TagBlockLayout
                {
                    public static readonly mod2.Region.Region_Permutation.Region_Permutation_Marker Layout = new mod2.Region.Region_Permutation.Region_Permutation_Marker();
                    public core.TagInterface.String name = new core.TagInterface.String("Name", 0x20);
                    public TagBlockIndex nodeindex = new TagBlockIndex("Node", TagBlockIndex.TagBlockIndexType.Word);
                    public Padding padding1 = new Padding(2);
                    public Padding padding2 = new Padding(0x10);
                    public RealQuaternion rotation = new RealQuaternion("Rotation");
                    public RealPoint3D translation = new RealPoint3D("Translation");

                    public Region_Permutation_Marker()
                    {
                        base.Add(this.name);
                        base.Add(this.nodeindex);
                        base.Add(this.padding1);
                        base.Add(this.translation);
                        base.Add(this.rotation);
                        base.Add(this.padding2);
                    }
                }
            }
        }
    }
}

