﻿namespace core.H1.tagconverter
{
    using core;
    using core.H1;
    using core.H2;
    using core.TagInterface;
    using System;

    public class BSPConvert
    {
        public static void Convert(Map h1map, Map h2map)
        {
            int num;
            uint num2;
            CompiledTagInterface interface2 = new CompiledTagInterface(h1map.SBSP.sbsp[0].tagnumber, h1map);
            CompiledTagInterface interface3 = new CompiledTagInterface(h2map.SBSP.sbsp[0].tagnumber, h2map);
            core.H1.SBSP chunk = (core.H1.SBSP) interface2.Header.GetChunk(0);
            core.H1.SBSP.BSP bsp = (core.H1.SBSP.BSP) chunk.bsp.GetChunk(0);
            core.H2.SBSP sbsp2 = (core.H2.SBSP) interface3.Header.GetChunk(0);
            core.H2.SBSP.BSP bsp2 = (core.H2.SBSP.BSP) sbsp2.collision_bsp.GetChunk(0);
            bsp2.bsp_3d_nodes.CreateChunks(bsp.bsp_3d_nodes.ChunkCount);
            for (num = 0; num < bsp.bsp_3d_nodes.ChunkCount; num++)
            {
                core.H1.SBSP.BSP.BSP3DNode node = (core.H1.SBSP.BSP.BSP3DNode) bsp.bsp_3d_nodes.GetChunk(num);
                core.H2.SBSP.BSP.BSP3DNode node2 = (core.H2.SBSP.BSP.BSP3DNode) bsp2.bsp_3d_nodes.GetChunk(num);
                node2.plane_index.Value = (short) node.plane_index.Value;
                node2.backchild.Value = node.backchild.Value;
                node2.unknown1.Value = (byte) node.unknown1.Value;
                node2.frontchild.Value = node.frontchild.Value;
                node2.unknown2.Value = node.unknown2.Value;
            }
            bsp2.bsp_planes.CreateChunks(bsp.bsp_planes.ChunkCount);
            for (num = 0; num < bsp.bsp_planes.ChunkCount; num++)
            {
                core.H1.SBSP.BSP.BSP_Plane plane = (core.H1.SBSP.BSP.BSP_Plane) bsp.bsp_planes.GetChunk(num);
                core.H2.SBSP.BSP.BSP_Plane plane2 = (core.H2.SBSP.BSP.BSP_Plane) bsp2.bsp_planes.GetChunk(num);
                plane2.plane = (RealPlane3D) plane.plane.Clone();
            }
            bsp2.bsp_leaves.CreateChunks(bsp.bsp_leaves.ChunkCount);
            for (num = 0; num < bsp.bsp_leaves.ChunkCount; num++)
            {
                core.H1.SBSP.BSP.Leaf leaf = (core.H1.SBSP.BSP.Leaf) bsp.bsp_leaves.GetChunk(num);
                core.H2.SBSP.BSP.Leaf leaf2 = (core.H2.SBSP.BSP.Leaf) bsp2.bsp_leaves.GetChunk(num);
                leaf2.flags.Value = (byte) leaf.flags.Value;
                leaf2.bsp2drefcount.Value = (byte) leaf.bsp2drefcount.Value;
                leaf2.bsp2drefindex.Value = (short) leaf.bsp2drefindex.Value;
            }
            bsp2.bsp_2d_references.CreateChunks(bsp.bsp_2d_references.ChunkCount);
            for (num = 0; num < bsp.bsp_2d_references.ChunkCount; num++)
            {
                core.H1.SBSP.BSP.BSP_2D_Reference reference = (core.H1.SBSP.BSP.BSP_2D_Reference) bsp.bsp_2d_references.GetChunk(num);
                core.H2.SBSP.BSP.BSP_2D_Reference reference2 = (core.H2.SBSP.BSP.BSP_2D_Reference) bsp2.bsp_2d_references.GetChunk(num);
                reference2.plane_index.Value = (short) reference.plane_index.Value;
                num2 = (uint) reference.bsp_2d_node_index.Value;
                if ((num2 & 0x80000000) != 0)
                {
                    num2 &= 0x7fff;
                    num2 |= 0x8000;
                }
                reference2.bsp_2d_node_index.Value = (short) num2;
            }
            bsp2.bsp_2d_nodes.CreateChunks(bsp.bsp_2d_nodes.ChunkCount);
            for (num = 0; num < bsp.bsp_2d_nodes.ChunkCount; num++)
            {
                core.H1.SBSP.BSP.BSP_2D_Node node3 = (core.H1.SBSP.BSP.BSP_2D_Node) bsp.bsp_2d_nodes.GetChunk(num);
                core.H2.SBSP.BSP.BSP_2D_Node node4 = (core.H2.SBSP.BSP.BSP_2D_Node) bsp2.bsp_2d_nodes.GetChunk(num);
                node4.plane.CopyFrom(node3.plane);
                num2 = (uint) node3.leftchild.Value;
                if ((num2 & 0x80000000) != 0)
                {
                    num2 &= 0x7fff;
                    num2 |= 0x8000;
                }
                uint num3 = (uint) node3.rightchild.Value;
                if ((num3 & 0x80000000) != 0)
                {
                    num3 &= 0x7fff;
                    num3 |= 0x8000;
                }
                node4.leftchild.Value = (short) num2;
                node4.rightchild.Value = (short) num3;
            }
            bsp2.bsp_surfaces.CreateChunks(bsp.bsp_surfaces.ChunkCount);
            for (num = 0; num < bsp.bsp_surfaces.ChunkCount; num++)
            {
                core.H1.SBSP.BSP.BSP_Surface surface = (core.H1.SBSP.BSP.BSP_Surface) bsp.bsp_surfaces.GetChunk(num);
                core.H2.SBSP.BSP.BSP_Surface surface2 = (core.H2.SBSP.BSP.BSP_Surface) bsp2.bsp_surfaces.GetChunk(num);
                surface2.plane_index.Value = (short) surface.plane_index.Value;
                surface2.first_edge.Value = (short) surface.first_edge.Value;
                surface2.flags.Value = surface.flags.Value;
                surface2.breakablesurface_index.Value = surface.breakablesurface_index.Value;
                surface2.collision_material_index.Value = surface.collision_material_index.Value;
            }
            bsp2.bsp_edges.CreateChunks(bsp.bsp_edges.ChunkCount);
            for (num = 0; num < bsp.bsp_edges.ChunkCount; num++)
            {
                core.H1.SBSP.BSP.Edge edge = (core.H1.SBSP.BSP.Edge) bsp.bsp_edges.GetChunk(num);
                core.H2.SBSP.BSP.Edge edge2 = (core.H2.SBSP.BSP.Edge) bsp2.bsp_edges.GetChunk(num);
                edge2.StartVertex.Value = (short) edge.StartVertex.Value;
                edge2.EndVertex.Value = (short) edge.EndVertex.Value;
                edge2.ForwardEdge.Value = (short) edge.ForwardEdge.Value;
                edge2.ReverseEdge.Value = (short) edge.ReverseEdge.Value;
                edge2.LeftSurface.Value = (short) edge.LeftSurface.Value;
                edge2.RightSurface.Value = (short) edge.RightSurface.Value;
            }
            bsp2.bsp_vertices.CreateChunks(bsp.bsp_vertices.ChunkCount);
            for (num = 0; num < bsp.bsp_vertices.ChunkCount; num++)
            {
                core.H1.SBSP.BSP.Vertice vertice = (core.H1.SBSP.BSP.Vertice) bsp.bsp_vertices.GetChunk(num);
                core.H2.SBSP.BSP.Vertice vertice2 = (core.H2.SBSP.BSP.Vertice) bsp2.bsp_vertices.GetChunk(num);
                vertice2.vertice = (RealPoint3D) vertice.vertice.Clone();
                vertice2.firstedge.Value = vertice.firstedge.Value;
            }
            h2map.io.Open();
            sbsp2.collision_bsp.WriteChunks(ref h2map.io.Out, interface3.Mode);
            sbsp2.vehicle_ceiling = chunk.vehicle_ceiling;
            sbsp2.vehicle_floor = chunk.vehicle_floor;
            sbsp2.vehicle_ceiling.SeekToObjectMapOffset(ref h2map.io.Out);
            sbsp2.vehicle_ceiling.Write(ref h2map.io.Out);
            sbsp2.vehicle_floor.Write(ref h2map.io.Out);
            h2map.io.Close();
        }
    }
}

