﻿namespace core.H2
{
    using core.TagInterface;
    using System;

    public class DECR : TagBlockLayout
    {
        public TagBlock Faces = new TagBlock("Faces", Faces_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public static readonly DECR Layout = new DECR();
        public TagBlock Object_Types = new TagBlock("Object Types", Object_Types_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 8);
        public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 0x10);
        public TagBlock Shaders = new TagBlock("Shaders", Shaders_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public RealFloat Unknown = new RealFloat("Unknown");
        public RealFloat Unknown_0 = new RealFloat("Unknown");
        public TagBlock Variation = new TagBlock("Variation", Variation_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Visual_Model = new TagBlock("Visual Model", Visual_Model_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public Raw_Tag_Block Visual_Raw = new Raw_Tag_Block("Visual Raw", Map.HaloVersionEnum.Halo2, Data.RawDataTypes.H2_DECR, new TagBlockLayout());

        public DECR()
        {
            base.Add(this.Shaders);
            base.Add(this.Unknown);
            base.Add(this.Unknown_0);
            base.Add(this.Variation);
            base.Add(this.Object_Types);
            base.Add(this.Visual_Model);
            base.Add(this.Faces);
            base.Add(this.Padding);
            base.Add(this.Visual_Raw);
            base.Add(this.Padding_0);
        }

        public class Faces_Layout : TagBlockLayout
        {
            public static readonly DECR.Faces_Layout Layout = new DECR.Faces_Layout();
            public ShortInteger Verticie_Index__Number_ = new ShortInteger("Verticie Index #");

            public Faces_Layout()
            {
                base.Add(this.Verticie_Index__Number_);
            }
        }

        public class Object_Types_Layout : TagBlockLayout
        {
            public static readonly DECR.Object_Types_Layout Layout = new DECR.Object_Types_Layout();
            public StringID Name = new StringID("Name");
            public LongInteger Unknown = new LongInteger("Unknown");

            public Object_Types_Layout()
            {
                base.Add(this.Name);
                base.Add(this.Unknown);
            }
        }

        public class Shaders_Layout : TagBlockLayout
        {
            public static readonly DECR.Shaders_Layout Layout = new DECR.Shaders_Layout();
            public HaloTagType shad = new HaloTagType("shad");
            public TagIdent shad_0 = new TagIdent("shad");

            public Shaders_Layout()
            {
                base.Add(this.shad);
                base.Add(this.shad_0);
            }
        }

        public class Variation_Layout : TagBlockLayout
        {
            public TagBlock Appearance = new TagBlock("Appearance", Appearance_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public static readonly DECR.Variation_Layout Layout = new DECR.Variation_Layout();
            public StringID Type = new StringID("Type");
            public LongInteger Unknown = new LongInteger("Unknown");
            public RealFloat Unknown_0 = new RealFloat("Unknown");

            public Variation_Layout()
            {
                base.Add(this.Type);
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Appearance);
            }

            public class Appearance_Layout : TagBlockLayout
            {
                public static readonly DECR.Variation_Layout.Appearance_Layout Layout = new DECR.Variation_Layout.Appearance_Layout();
                public RealFloat Scale_1 = new RealFloat("Scale 1");
                public RealFloat Scale_2 = new RealFloat("Scale 2");
                public StringID Style = new StringID("Style");
                public LongInteger Unknown = new LongInteger("Unknown");
                public LongInteger Unknown_0 = new LongInteger("Unknown");
                public LongInteger Unknown_1 = new LongInteger("Unknown");
                public LongInteger Unknown_2 = new LongInteger("Unknown");
                public RealFloat Unknown_3 = new RealFloat("Unknown");
                public RealFloat Unknown_4 = new RealFloat("Unknown");
                public RealFloat Unknown_5 = new RealFloat("Unknown");

                public Appearance_Layout()
                {
                    base.Add(this.Style);
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                    base.Add(this.Scale_1);
                    base.Add(this.Scale_2);
                    base.Add(this.Unknown_1);
                    base.Add(this.Unknown_2);
                    base.Add(this.Unknown_3);
                    base.Add(this.Unknown_4);
                    base.Add(this.Unknown_5);
                }
            }
        }

        public class Visual_Model_Layout : TagBlockLayout
        {
            public static readonly DECR.Visual_Model_Layout Layout = new DECR.Visual_Model_Layout();
            public RealFloat U = new RealFloat("U");
            public RealFloat Unknown = new RealFloat("Unknown");
            public RealFloat Unknown_0 = new RealFloat("Unknown");
            public RealFloat Unknown_1 = new RealFloat("Unknown");
            public RealFloat Unknown_2 = new RealFloat("Unknown");
            public RealFloat Unknown_3 = new RealFloat("Unknown");
            public RealFloat Unknown_4 = new RealFloat("Unknown");
            public RealFloat Unknown_5 = new RealFloat("Unknown");
            public RealFloat Unknown_6 = new RealFloat("Unknown");
            public RealFloat Unknown_7 = new RealFloat("Unknown");
            public RealFloat V = new RealFloat("V");
            public RealFloat X = new RealFloat("X");
            public RealFloat Y = new RealFloat("Y");
            public RealFloat Z = new RealFloat("Z");

            public Visual_Model_Layout()
            {
                base.Add(this.X);
                base.Add(this.Y);
                base.Add(this.Z);
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
                base.Add(this.Unknown_7);
                base.Add(this.U);
                base.Add(this.V);
            }
        }
    }
}

