﻿namespace core.H2
{
    using core.TagInterface;
    using System;

    public class Predicted_Scenario_Resources : TagBlockLayout
    {
        public TagBlock control_pallete = new TagBlock("", scnr.Control_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock control_placement = new TagBlock("", scnr.Control_Placement_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock death_zones = new TagBlock("", scnr.Trigger_Volumes_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock decal_pallete = new TagBlock("decal_pallete", scnr.Decal_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock decal_placement = new TagBlock("decal_placement", scnr.Decal_Placement_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock decorators = new TagBlock("decorators", scnr.Decorator_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock device_groups = new TagBlock("", scnr.Device_Groups_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock kill_zones = new TagBlock("", scnr.Scenario_Kill_Triggers_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public static readonly Predicted_Scenario_Resources Layout = new Predicted_Scenario_Resources();
        public TagBlock light_pallete = new TagBlock("", scnr.Light_Volumes_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock light_placement = new TagBlock("", scnr.Light_Volumes_Placement_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock looping_sounds = new TagBlock("", scnr.Background_Sound_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock machine_pallete = new TagBlock("", scnr.Machine_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock machine_placement = new TagBlock("", scnr.Machine_Placement_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock obstacle_pallete = new TagBlock("", scnr.Obstacle_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock obstacle_placement = new TagBlock("", scnr.Obstacle_Placement_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock scenery_pallete = new TagBlock("", scnr.Scenery_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock scenery_placement = new TagBlock("", scnr.Scenery_Placement_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock sky_indexes = new TagBlock("", Sky_Cluster_Index.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock sky_pallete = new TagBlock("", scnr.Sky_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock sound_scenery_palette = new TagBlock("", scnr.Sound_Scenery_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock sound_scenery_placement = new TagBlock("", scnr.Sound_Scenery_Placement_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock vehicle_pallete = new TagBlock("", scnr.Vehicle_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock vehicle_placement = new TagBlock("", scnr.Vehicle_Placement_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock weapon_pallete = new TagBlock("", scnr.Weapon_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock weapon_placement = new TagBlock("", scnr.Weapon_Placement_Layout.Layout, Map.HaloVersionEnum.Halo2);

        public Predicted_Scenario_Resources()
        {
            base.Add(this.obstacle_pallete);
            base.Add(this.obstacle_placement);
            base.Add(this.light_pallete);
            base.Add(this.light_placement);
            base.Add(this.scenery_pallete);
            base.Add(this.scenery_placement);
            base.Add(this.machine_pallete);
            base.Add(this.machine_placement);
            base.Add(this.control_pallete);
            base.Add(this.control_placement);
            base.Add(this.device_groups);
            base.Add(this.decal_pallete);
            base.Add(this.decal_placement);
            base.Add(this.sky_pallete);
            base.Add(this.sky_indexes);
            base.Add(this.sound_scenery_palette);
            base.Add(this.sound_scenery_placement);
            base.Add(this.looping_sounds);
            base.Add(this.decorators);
            base.Add(this.vehicle_pallete);
            base.Add(this.vehicle_placement);
            base.Add(this.death_zones);
            base.Add(this.kill_zones);
            base.Add(this.weapon_pallete);
            base.Add(this.weapon_placement);
        }

        public class Sky_Cluster_Index : TagBlockLayout
        {
            public ByteInteger Index = new ByteInteger("index");
            public static readonly Predicted_Scenario_Resources.Sky_Cluster_Index Layout = new Predicted_Scenario_Resources.Sky_Cluster_Index();

            public Sky_Cluster_Index()
            {
                base.Add(this.Index);
            }
        }
    }
}

