﻿namespace core.H2
{
    using core.TagInterface;
    using System;

    public class SBSP : TagBlockLayout
    {
        public TagBlock collision_bsp = new TagBlock("BSP Collision", BSP.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock collision_materials = new TagBlock("Collision Materials", Collision_Material.Layout, Map.HaloVersionEnum.Halo2);
        public static readonly SBSP Layout = new SBSP();
        public TagBlock leaves = new TagBlock("Leaves", Leaf.Layout, Map.HaloVersionEnum.Halo2, 8);
        public TagBlock surface_references = new TagBlock("Surface References", Leaf_Surface.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock markers = new TagBlock("Markers", Markers.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock background_sound_palette = new TagBlock("Background Sound Palette", Background_Sound_Palette.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock cluster_portals = new TagBlock("Cluster Portals", Portal.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock cluster_data = new TagBlock("Cluster Data", PVS.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock water_definitions = new TagBlock("Water Definitions", SBSP_Water.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock bsp_permutations = new TagBlock("BSP Permutations", Scenery_Cluster.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock instanced_geometry_instances = new TagBlock("Instanced Geometry Instances", Scenery_Placement.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock sound_environment_palette = new TagBlock("Sound Environment Palette", Sound_Environment_Palette.Layout, Map.HaloVersionEnum.Halo2);
        public Padding temppadding = new Padding("TempPadding", 0x1c);
        public Padding temppadding1 = new Padding("TempPadding1", 4);
        public Padding temppadding2 = new Padding("TempPadding2", 4);
        public Padding temppadding3 = new Padding(0x18);
        public Padding temppadding44 = new Padding(8);
        public Padding temppadding444 = new Padding(0x2c);
        public Padding temppadding4x = new Padding(8);
        public Padding temppadding5 = new Padding(0x70);
        public Padding temppadding6 = new Padding(8);
        public Padding temppadding7 = new Padding(0x1c);
        public TagBlock fog_planes = new TagBlock("Fog Planes", Fog_Planes.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock decorators = new TagBlock("Decorators", Decorators.Layout, Map.HaloVersionEnum.Halo2, 4);
        public TagBlock sound_data = new TagBlock("Sound Data", Sound_Data.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock mopp_code_2 = new TagBlock("Mopp Code", Mopp_Code_2.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock breakable_surface_key_table = new TagBlock("Breakable Surface Key Table", Breakable_Surface_Key_Table.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock runtime_decals = new TagBlock("Runtime Decals", Runtime_Decals.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock environment_object_palette = new TagBlock("Environment Object Palette", Environment_Object_Palette.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock environment_objects = new TagBlock("Environment Objects", Environment_Objects.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock conveyor_surfaces = new TagBlock("Conveyor Surfaces", Conveyor_Surfaces.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock breakable_surfaces = new TagBlock("Breakable Surfaces", Breakable_Surfaces.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock unknown_tag_block16 = new TagBlock("unknown16", Unknown_Block_16.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock sky_owner_cluster = new TagBlock("Sky Owner Custer", Sky_Owner_Cluster.Layout, Map.HaloVersionEnum.Halo2, 4);
        public TagBlock ambience_sound_clusters = new TagBlock("Ambience Sound Clusters", Sound_Clusters.Layout, Map.HaloVersionEnum.Halo2, 4);
        public TagBlock reverb_sound_clusters = new TagBlock("Reverb Sound Clusters", Sound_Clusters.Layout, Map.HaloVersionEnum.Halo2, 4);
        public TagBlock unknown_tag_block4 = new TagBlock("unknown4", Unknown_Block_4.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock mopp_code_1 = new TagBlock("Mopp Code", Mopp_Code_1.Layout, Map.HaloVersionEnum.Halo2, 0x10);
        public TagBlock portal_device_mapping = new TagBlock("Portal Device Mapping", Portal_Device_Mapping.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock audibility = new TagBlock("Audibility", Audibility.Layout, Map.HaloVersionEnum.Halo2, 4);
        public TagBlock object_fake_lightprobes = new TagBlock("Object Fake Lightprobes", Object_Fake_Lightprobes.Layout, Map.HaloVersionEnum.Halo2, 4);
        public TagBlock transparent_planes = new TagBlock("Transparent Planes", Transparent_Planes.Layout, Map.HaloVersionEnum.Halo2, 4);
        public RealFloat vehicle_ceiling = new RealFloat("Vehicle Ceiling");
        public RealFloat vehicle_floor = new RealFloat("Vehicle Floor");
        public TagBlock detail_objects = new TagBlock("Detail Objects", Detail_Objects.Layout, Map.HaloVersionEnum.Halo2, 4);
        public TagBlock materials = new TagBlock("Materials", Materials.Layout, Map.HaloVersionEnum.Halo2, 4);
        public TagBlock weather_palette = new TagBlock("Weather Palette", Weather_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock weather_polyhedral = new TagBlock("Weather Polyhedral", Weather_Polyhedral_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public RealBounds x_bounds = new RealBounds("World Bounds X");
        public RealBounds y_bounds = new RealBounds("World Bounds Y");
        public RealBounds z_bounds = new RealBounds("World Bounds Z");

        public SBSP()
        {
            base.Add(this.temppadding);
            base.Add(this.collision_materials);
            base.Add(this.collision_bsp);
            base.Add(this.temppadding1);
            base.Add(this.vehicle_ceiling);
            base.Add(this.vehicle_floor);
            base.Add(this.temppadding2);
            base.Add(this.leaves);
            base.Add(this.x_bounds);
            base.Add(this.y_bounds);
            base.Add(this.z_bounds);
            base.Add(this.surface_references);
            base.Add(this.cluster_data);
            base.Add(this.cluster_portals);
            base.Add(this.fog_planes);
            base.Add(this.temppadding3);
            base.Add(this.weather_palette);
            base.Add(this.weather_polyhedral);
            base.Add(this.sound_data);
            base.Add(this.detail_objects);
            base.Add(this.materials);
            base.Add(this.sky_owner_cluster);
            base.Add(this.conveyor_surfaces);
            base.Add(this.breakable_surfaces);
            base.Add(this.unknown_tag_block16);
            base.Add(this.temppadding4x);
            base.Add(this.background_sound_palette);
            base.Add(this.sound_environment_palette);
            base.Add(this.temppadding44);
            base.Add(this.markers);
            base.Add(this.runtime_decals);
            base.Add(this.environment_object_palette);
            base.Add(this.environment_objects);
            base.Add(this.temppadding444);
            base.Add(this.bsp_permutations);
            base.Add(this.instanced_geometry_instances);
            base.Add(this.ambience_sound_clusters);
            base.Add(this.reverb_sound_clusters);
            base.Add(this.transparent_planes);
            base.Add(this.temppadding5);
            base.Add(this.unknown_tag_block4);
            base.Add(this.temppadding6);
            base.Add(this.mopp_code_1);
            base.Add(this.temppadding7);
            base.Add(this.mopp_code_2);
            base.Add(this.breakable_surface_key_table);
            base.Add(this.water_definitions);
            base.Add(this.portal_device_mapping);
            base.Add(this.audibility);
            base.Add(this.object_fake_lightprobes);
            base.Add(this.decorators);
        }

        public class BSP : TagBlockLayout
        {
            public TagBlock bsp_2d_nodes = new TagBlock("BSP_2D_Nodes", BSP_2D_Node.Layout, Map.HaloVersionEnum.Halo2, 0x10);
            public TagBlock bsp_2d_references = new TagBlock("BSP_2D_References", BSP_2D_Reference.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock bsp_3d_nodes = new TagBlock("BSP_3D_Nodes", BSP3DNode.Layout, Map.HaloVersionEnum.Halo2, 8);
            public TagBlock bsp_edges = new TagBlock("BSP_Edges", Edge.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock bsp_leaves = new TagBlock("BSP_Leaves", Leaf.Layout, Map.HaloVersionEnum.Halo2, 0x10);
            public TagBlock bsp_planes = new TagBlock("BSP_Planes", BSP_Plane.Layout, Map.HaloVersionEnum.Halo2, 0x10);
            public TagBlock bsp_surfaces = new TagBlock("BSP_Surfaces", BSP_Surface.Layout, Map.HaloVersionEnum.Halo2, 8);
            public TagBlock bsp_vertices = new TagBlock("BSP_Vertices", Vertice.Layout, Map.HaloVersionEnum.Halo2, 0x10);
            public static readonly SBSP.BSP Layout = new SBSP.BSP();

            public BSP()
            {
                base.Add(this.bsp_3d_nodes);
                base.Add(this.bsp_planes);
                base.Add(this.bsp_leaves);
                base.Add(this.bsp_2d_references);
                base.Add(this.bsp_2d_nodes);
                base.Add(this.bsp_surfaces);
                base.Add(this.bsp_edges);
                base.Add(this.bsp_vertices);
            }

            public class BSP_2D_Node : TagBlockLayout
            {
                public static readonly SBSP.BSP.BSP_2D_Node Layout = new SBSP.BSP.BSP_2D_Node();
                public ShortInteger leftchild = new ShortInteger("Left Child");
                public RealPlane2D plane = new RealPlane2D("Plane");
                public ShortInteger rightchild = new ShortInteger("Right Child");

                public BSP_2D_Node()
                {
                    base.Add(this.plane);
                    base.Add(this.leftchild);
                    base.Add(this.rightchild);
                }
            }

            public class BSP_2D_Reference : TagBlockLayout
            {
                public ShortInteger bsp_2d_node_index = new ShortInteger("BSP_2D_Node Index");
                public static readonly SBSP.BSP.BSP_2D_Reference Layout = new SBSP.BSP.BSP_2D_Reference();
                public ShortInteger plane_index = new ShortInteger("BSP_Plane Index");

                public BSP_2D_Reference()
                {
                    base.Add(this.plane_index);
                    base.Add(this.bsp_2d_node_index);
                }
            }

            public class BSP_Plane : TagBlockLayout
            {
                public static readonly SBSP.BSP.BSP_Plane Layout = new SBSP.BSP.BSP_Plane();
                public RealPlane3D plane = new RealPlane3D("BSP_Plane");

                public BSP_Plane()
                {
                    base.Add(this.plane);
                }
            }

            public class BSP_Surface : TagBlockLayout
            {
                public ByteInteger breakablesurface_index = new ByteInteger("Breakable Surface Index");
                public ShortInteger collision_material_index = new ShortInteger("Collision Material Index");
                public ShortInteger first_edge = new ShortInteger("First Edge");
                public core.TagInterface.Flags flags = new core.TagInterface.Flags("Flags", core.TagInterface.Flags.BitmaskTypeEnum.Byte);
                public static readonly SBSP.BSP.BSP_Surface Layout = new SBSP.BSP.BSP_Surface();
                public ShortInteger plane_index = new ShortInteger("Plane Index");

                public BSP_Surface()
                {
                    base.Add(this.plane_index);
                    base.Add(this.first_edge);
                    base.Add(this.flags);
                    base.Add(this.breakablesurface_index);
                    base.Add(this.collision_material_index);
                }
            }

            public class BSP3DNode : TagBlockLayout
            {
                public ShortInteger backchild = new ShortInteger("Back Child");
                public ShortInteger frontchild = new ShortInteger("Front Child");
                public static readonly SBSP.BSP.BSP3DNode Layout = new SBSP.BSP.BSP3DNode();
                public ShortInteger plane_index = new ShortInteger("BSP_Plane Index");
                public ByteInteger unknown1 = new ByteInteger("Unknown 1");
                public ByteInteger unknown2 = new ByteInteger("Unknown 2");

                public BSP3DNode()
                {
                    base.Add(this.plane_index);
                    base.Add(this.backchild);
                    base.Add(this.unknown1);
                    base.Add(this.frontchild);
                    base.Add(this.unknown2);
                }
            }

            public class Edge : TagBlockLayout
            {
                public ShortInteger EndVertex = new ShortInteger("End Vertex");
                public ShortInteger ForwardEdge = new ShortInteger("Forward Edge");
                public static readonly SBSP.BSP.Edge Layout = new SBSP.BSP.Edge();
                public ShortInteger LeftSurface = new ShortInteger("Left Surface");
                public ShortInteger ReverseEdge = new ShortInteger("Reverse Edge");
                public ShortInteger RightSurface = new ShortInteger("Right Surface");
                public ShortInteger StartVertex = new ShortInteger("Start Vertex");

                public Edge()
                {
                    base.Add(this.StartVertex);
                    base.Add(this.EndVertex);
                    base.Add(this.ForwardEdge);
                    base.Add(this.ReverseEdge);
                    base.Add(this.LeftSurface);
                    base.Add(this.RightSurface);
                }
            }

            public class Leaf : TagBlockLayout
            {
                public ByteInteger bsp2drefcount = new ByteInteger("BSP_2D_Reference Count");
                public ShortInteger bsp2drefindex = new ShortInteger("BSP_2D_Reference Start Index");
                public core.TagInterface.Flags flags = new core.TagInterface.Flags("Flags", core.TagInterface.Flags.BitmaskTypeEnum.Byte);
                public static readonly SBSP.BSP.Leaf Layout = new SBSP.BSP.Leaf();

                public Leaf()
                {
                    base.Add(this.flags);
                    base.Add(this.bsp2drefcount);
                    base.Add(this.bsp2drefindex);
                }
            }

            public class Vertice : TagBlockLayout
            {
                public LongInteger firstedge = new LongInteger("First Edge");
                public static readonly SBSP.BSP.Vertice Layout = new SBSP.BSP.Vertice();
                public RealPoint3D vertice = new RealPoint3D("Vertice");

                public Vertice()
                {
                    base.Add(this.vertice);
                    base.Add(this.firstedge);
                }
            }
        }

        public class Detail_Objects : TagBlockLayout
        {
            public TagBlock bvh = new TagBlock("BVH", BVH.Layout, Map.HaloVersionEnum.Halo2, 0x10);
            public Padding crap = new Padding(8);
            public static readonly SBSP.Detail_Objects Layout = new SBSP.Detail_Objects();
            public RealBounds model_bounds_x = new RealBounds("model_bounds_x");
            public RealBounds model_bounds_y = new RealBounds("model_bounds_y");
            public RealBounds model_bounds_z = new RealBounds("model_bounds_z");
            public TagBlock portals = new TagBlock("Cluster Portals", Cluster_Portal.Layout, Map.HaloVersionEnum.Halo2, 4);
            public TagBlock predicted_resources = new TagBlock("Predicted Resources", Predicted_Resource.Layout, Map.HaloVersionEnum.Halo2, 4);
            public Raw_Tag_Block rawdata = new Raw_Tag_Block("Raw Data", Map.HaloVersionEnum.Halo2, Data.RawDataTypes.H2_sbsp_visualmesh, SBSP_Visual_Raw_Header.Layout);
            public ByteInteger sky_index = new ByteInteger("Sky Index");
            public ShortInteger Sub_Cluster_count = new ShortInteger("Sub-Cluster Count");
            public ShortInteger Sub_Parts_count = new ShortInteger("number of subparts that make up the subclusters");
            public Padding temppadding1 = new Padding("TempPadding1", 4);
            public Padding temppadding2 = new Padding("TempPadding2 unknowns", 0x10);
            public Padding temppadding3 = new Padding(8);
            public ShortInteger Tri_count = new ShortInteger("Triangle Count");
            public ShortInteger Tri_count2 = new ShortInteger("equal to or a bit less than Triangle count");
            public ShortInteger Tri_count3 = new ShortInteger("equal to or a bit less than Triangle count");
            public TagBlock unknown_tagblock_1 = new TagBlock("unknown tagblock", Cluster_Unknown_1.Layout, Map.HaloVersionEnum.Halo2, 4);
            public ShortInteger unknown1 = new ShortInteger("unknown1");
            public ShortInteger unknown11 = new ShortInteger("unknown11");
            public ShortInteger unknown12 = new ShortInteger("unknown12");
            public ShortInteger unknown13 = new ShortInteger("unknown13");
            public ShortInteger unknown14 = new ShortInteger("unknown14");
            public RealFloat unknown15 = new RealFloat("unknown15");
            public ShortInteger unknown2 = new ShortInteger("unknown2");
            public ByteInteger unknown4 = new ByteInteger("unknown4");
            public ByteInteger unknown5 = new ByteInteger("unknown5");
            public ByteInteger unknown6 = new ByteInteger("unknown6");
            public ShortInteger unknown7 = new ShortInteger("unknown7");
            public ShortInteger unknown8 = new ShortInteger("unknown8");
            public ShortInteger unknown9 = new ShortInteger("unknown9");
            public LongInteger unused = new LongInteger("unused?");
            public ShortInteger unused_zeros1 = new ShortInteger("unused zeros1 in my notes");
            public ShortInteger Vert_count = new ShortInteger("Vertex Count");
            public ShortInteger Vert_count2 = new ShortInteger("equal to or a bit less than Vertex Count");
            public ShortInteger weather_index = new ShortInteger("Weather Index");

            public Detail_Objects()
            {
                base.Add(this.Vert_count);
                base.Add(this.Tri_count);
                base.Add(this.Sub_Cluster_count);
                base.Add(this.Tri_count2);
                base.Add(this.unknown1);
                base.Add(this.unused_zeros1);
                base.Add(this.Vert_count2);
                base.Add(this.temppadding1);
                base.Add(this.Tri_count3);
                base.Add(this.temppadding2);
                base.Add(this.Sub_Parts_count);
                base.Add(this.unknown2);
                base.Add(this.rawdata);
                base.Add(this.temppadding3);
                base.Add(this.model_bounds_x);
                base.Add(this.model_bounds_y);
                base.Add(this.model_bounds_z);
                base.Add(this.unknown4);
                base.Add(this.unknown5);
                base.Add(this.sky_index);
                base.Add(this.unknown6);
                base.Add(this.unknown7);
                base.Add(this.unknown8);
                base.Add(this.unknown9);
                base.Add(this.weather_index);
                base.Add(this.unknown11);
                base.Add(this.unknown12);
                base.Add(this.unknown13);
                base.Add(this.unknown14);
                base.Add(this.unused);
                base.Add(this.predicted_resources);
                base.Add(this.portals);
                base.Add(this.unknown15);
                base.Add(this.unknown_tagblock_1);
                base.Add(this.crap);
                base.Add(this.bvh);
            }

            public class BVH : TagBlockLayout
            {
                public static readonly SBSP.Detail_Objects.BVH Layout = new SBSP.Detail_Objects.BVH();
                public ByteInteger unk1 = new ByteInteger("unknown");

                public BVH()
                {
                    base.Add(this.unk1);
                }
            }

            public class Cluster_Portal : TagBlockLayout
            {
                public static readonly SBSP.Detail_Objects.Cluster_Portal Layout = new SBSP.Detail_Objects.Cluster_Portal();
                public ShortInteger portal = new ShortInteger("portal");

                public Cluster_Portal()
                {
                    base.Add(this.portal);
                }
            }

            public class Cluster_Unknown_1 : TagBlockLayout
            {
                public static readonly SBSP.Detail_Objects.Cluster_Unknown_1 Layout = new SBSP.Detail_Objects.Cluster_Unknown_1();
                public ShortInteger unk1 = new ShortInteger("unknown");

                public Cluster_Unknown_1()
                {
                    base.Add(this.unk1);
                }
            }

            public class Predicted_Resource : TagBlockLayout
            {
                public static readonly SBSP.Detail_Objects.Predicted_Resource Layout = new SBSP.Detail_Objects.Predicted_Resource();
                public TagIdent tagident = new TagIdent("Tag Ident");
                public ShortInteger unknown1 = new ShortInteger("unknown1");
                public ShortInteger unknown2 = new ShortInteger("unknown2");

                public Predicted_Resource()
                {
                    base.Add(this.unknown1);
                    base.Add(this.unknown2);
                    base.Add(this.tagident);
                }
            }

            public class SBSP_Visual_Raw_Header : TagBlockLayout
            {
                public TagBlock bvh = new TagBlock("BVH", Raw_Tag_Block.BVH.Layout, Map.HaloVersionEnum.Halo2);
                public TagBlock indices = new TagBlock("Indices", Raw_Tag_Block.Indice.Layout, Map.HaloVersionEnum.Halo2);
                public static readonly SBSP.Detail_Objects.SBSP_Visual_Raw_Header Layout = new SBSP.Detail_Objects.SBSP_Visual_Raw_Header();
                public TagBlock mesh_bvh_order = new TagBlock("Mesh BVH Order", Raw_Tag_Block.Mesh_BVH_Order.Layout, Map.HaloVersionEnum.Halo2);
                public Padding padding1 = new Padding(0x10);
                public Padding padding2 = new Padding(4);
                public TagBlock sub_cluster_data = new TagBlock("Sub-Clusters Data", Raw_Tag_Block.Sub_Cluster_Data.Layout, Map.HaloVersionEnum.Halo2);
                public TagBlock sub_clusters = new TagBlock("Sub-Clusters", Raw_Tag_Block.Sub_Cluster.Layout, Map.HaloVersionEnum.Halo2);
                public TagBlock vertices = new TagBlock("Vertex Declaration", Raw_Tag_Block.Vertex_Declaration.Layout, Map.HaloVersionEnum.Halo2);

                public SBSP_Visual_Raw_Header()
                {
                    base.Add(this.sub_clusters);
                    base.Add(this.sub_cluster_data);
                    base.Add(this.padding1);
                    base.Add(this.indices);
                    base.Add(this.bvh);
                    base.Add(this.mesh_bvh_order);
                    base.Add(this.vertices);
                    base.Add(this.padding2);
                }
            }
        }

        public class Collision_Material : TagBlockLayout
        {
            public static readonly SBSP.Collision_Material Layout = new SBSP.Collision_Material();
            public ShortInteger moving_surface_index = new ShortInteger("Moving Surface Index");
            public TagReference shader = new TagReference("Shader", Map.HaloVersionEnum.Halo2);
            public ShortInteger unknown = new ShortInteger("unknown");
            public TagReference unused = new TagReference("unused", Map.HaloVersionEnum.Halo2);

            public Collision_Material()
            {
                base.Add(this.unused);
                base.Add(this.unknown);
                base.Add(this.moving_surface_index);
                base.Add(this.shader);
            }
        }

        public class Leaf : TagBlockLayout
        {
            public ShortInteger cluster = new ShortInteger("Cluster Index");
            public static readonly SBSP.Leaf Layout = new SBSP.Leaf();
            public ShortInteger leaf_surface_count = new ShortInteger("leaf surface count");
            public ShortInteger leaf_surface_start = new ShortInteger("leaf surface start in index");
            public ShortInteger unused = new ShortInteger("unused in my notes");

            public Leaf()
            {
                base.Add(this.cluster);
                base.Add(this.leaf_surface_start);
                base.Add(this.leaf_surface_count);
                base.Add(this.unused);
            }
        }

        public class Leaf_Surface : TagBlockLayout
        {
            public ShortInteger cluster_face = new ShortInteger("cluster face");
            public ShortInteger cluster_face_3X = new ShortInteger("cluster face x 3");
            public static readonly SBSP.Leaf_Surface Layout = new SBSP.Leaf_Surface();
            public ShortInteger node = new ShortInteger("bsp3dnode refrence");
            public ShortInteger unused = new ShortInteger("unused in my notes");

            public Leaf_Surface()
            {
                base.Add(this.cluster_face_3X);
                base.Add(this.cluster_face);
                base.Add(this.node);
                base.Add(this.unused);
            }
        }

        public class Markers : TagBlockLayout
        {
            public static readonly SBSP.Markers Layout = new SBSP.Markers();
            public Padding unknown = new Padding(60);

            public Markers()
            {
                base.Add(this.unknown);
            }
        }

        public class Background_Sound_Palette : TagBlockLayout
        {
            public TagReference ident = new TagReference("Ident", Map.HaloVersionEnum.Halo2);
            public TagReference ident2 = new TagReference("Ident2", Map.HaloVersionEnum.Halo2);
            public static readonly SBSP.Background_Sound_Palette Layout = new SBSP.Background_Sound_Palette();
            public core.TagInterface.String name = new core.TagInterface.String("Name", 0x20);
            public Padding unknown = new Padding(0x34);

            public Background_Sound_Palette()
            {
                base.Add(this.name);
                base.Add(this.ident);
                base.Add(this.ident2);
                base.Add(this.unknown);
            }
        }

        public class Portal : TagBlockLayout
        {
            public ShortInteger Back_Cluster = new ShortInteger("Back Cluster");
            public ShortInteger Front_Cluster = new ShortInteger("Front Cluster");
            public static readonly SBSP.Portal Layout = new SBSP.Portal();
            public ShortInteger Plane = new ShortInteger("Plane index number");
            public TagBlock portal_vertices = new TagBlock("Portal_Vertices", Vertice.Layout, Map.HaloVersionEnum.Halo2);
            public RealFloat radius = new RealFloat("portal bounding sphere radius");
            public ShortInteger unused_zeros1 = new ShortInteger("unused zeros1 in my notes");
            public LongInteger unused_zeros2 = new LongInteger("unused zeros2 in my notes");
            public RealPoint3D vertice = new RealPoint3D("center of portal bounding sphere");

            public Portal()
            {
                base.Add(this.Front_Cluster);
                base.Add(this.Back_Cluster);
                base.Add(this.Plane);
                base.Add(this.unused_zeros1);
                base.Add(this.vertice);
                base.Add(this.radius);
                base.Add(this.unused_zeros2);
                base.Add(this.portal_vertices);
            }

            public class Vertice : TagBlockLayout
            {
                public static readonly SBSP.Portal.Vertice Layout = new SBSP.Portal.Vertice();
                public RealPoint3D vertice = new RealPoint3D("Vertice");

                public Vertice()
                {
                    base.Add(this.vertice);
                }
            }
        }

        public class PVS : TagBlockLayout
        {
            public static readonly SBSP.PVS Layout = new SBSP.PVS();
            public ByteInteger PVS_Chunk = new ByteInteger("PVS Chunk");

            public PVS()
            {
                base.Add(this.PVS_Chunk);
            }
        }

        public class SBSP_Water : TagBlockLayout
        {
            public static readonly SBSP.SBSP_Water Layout = new SBSP.SBSP_Water();
            public Raw_Tag_Block rawdata = new Raw_Tag_Block("Raw Data", Map.HaloVersionEnum.Halo2, Data.RawDataTypes.H2_sbsp_water, new TagBlockLayout());
            public Padding unknown = new Padding(120);
            public Padding unknownx = new Padding(8);
            public TagReference water_shader = new TagReference("Water Shader", Map.HaloVersionEnum.Halo2);

            public SBSP_Water()
            {
                base.Add(this.water_shader);
                base.Add(this.unknownx);
                base.Add(this.rawdata);
                base.Add(this.unknown);
            }
        }

        public class Scenery_Cluster : TagBlockLayout
        {
            public TagBlock bsp_2d_nodes = new TagBlock("BSP_2D_Nodes", SBSP.BSP.BSP_2D_Node.Layout, Map.HaloVersionEnum.Halo2, 0x10);
            public TagBlock bsp_2d_references = new TagBlock("BSP_2D_References", SBSP.BSP.BSP_2D_Reference.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock bsp_3d_nodes = new TagBlock("BSP_3D_Nodes", SBSP.BSP.BSP3DNode.Layout, Map.HaloVersionEnum.Halo2, 8);
            public TagBlock bsp_edges = new TagBlock("BSP_Edges", SBSP.BSP.Edge.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock bsp_leaves = new TagBlock("BSP_Leaves", SBSP.BSP.Leaf.Layout, Map.HaloVersionEnum.Halo2, 0x10);
            public TagBlock bsp_planes = new TagBlock("BSP_Planes", SBSP.BSP.BSP_Plane.Layout, Map.HaloVersionEnum.Halo2, 0x10);
            public TagBlock bsp_surfaces = new TagBlock("BSP_Surfaces", SBSP.BSP.BSP_Surface.Layout, Map.HaloVersionEnum.Halo2, 8);
            public TagBlock bsp_vertices = new TagBlock("BSP_Vertices", SBSP.BSP.Vertice.Layout, Map.HaloVersionEnum.Halo2, 0x10);
            public static readonly SBSP.Scenery_Cluster Layout = new SBSP.Scenery_Cluster();
            public Raw_Tag_Block rawdata = new Raw_Tag_Block("Raw Data", Map.HaloVersionEnum.Halo2, Data.RawDataTypes.H2_sbsp_visualmesh, SBSP_Visual_Raw_Header.Layout);
            public ShortInteger Sub_Cluster_count = new ShortInteger("Sub-Cluster Count");
            public Padding temppadding1 = new Padding("TempPadding1", 4);
            public Padding temppadding2 = new Padding("TempPadding2 unknowns", 4);
            public Padding temppadding22 = new Padding("TempPadding2 unknowns", 8);
            public Padding temppadding3 = new Padding(0x24);
            public ShortInteger Tri_count = new ShortInteger("Triangle Count");
            public ShortInteger Tri_count2 = new ShortInteger("equal to or a bit less than Triangle count");
            public ShortInteger Tri_count3 = new ShortInteger("equal to or a bit less than Triangle count");
            public TagBlock unknown_tagblock_1 = new TagBlock("unknown tagblock1", Scenery_Cluster_Unknown1.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock unknown_tagblock_2 = new TagBlock("unknown tagblock2", Scenery_Cluster_Unknown2.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock unknown_tagblock_3 = new TagBlock("unknown tagblock3", Scenery_Cluster_Unknown2.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock unknown_tagblock_4 = new TagBlock("unknown tagblock4", Scenery_Cluster_Unknown4.Layout, Map.HaloVersionEnum.Halo2);
            public ShortInteger unknown1 = new ShortInteger("unknown1");
            public ShortInteger unused_zeros1 = new ShortInteger("unused zeros1 in my notes");
            public ShortInteger Vert_count = new ShortInteger("Vertex Count");
            public ShortInteger Vert_count2 = new ShortInteger("equal to or a bit less than Vertex Count");

            public Scenery_Cluster()
            {
                base.Add(this.Vert_count);
                base.Add(this.Tri_count);
                base.Add(this.Sub_Cluster_count);
                base.Add(this.Tri_count2);
                base.Add(this.unknown1);
                base.Add(this.unused_zeros1);
                base.Add(this.Vert_count2);
                base.Add(this.temppadding1);
                base.Add(this.Tri_count3);
                base.Add(this.temppadding2);
                base.Add(this.unknown_tagblock_4);
                base.Add(this.temppadding22);
                base.Add(this.rawdata);
                base.Add(this.temppadding3);
                base.Add(this.bsp_3d_nodes);
                base.Add(this.bsp_planes);
                base.Add(this.bsp_leaves);
                base.Add(this.bsp_2d_references);
                base.Add(this.bsp_2d_nodes);
                base.Add(this.bsp_surfaces);
                base.Add(this.bsp_edges);
                base.Add(this.bsp_vertices);
                base.Add(this.unknown_tagblock_1);
                base.Add(this.unknown_tagblock_2);
                base.Add(this.unknown_tagblock_3);
            }

            public class Cluster_Portal : TagBlockLayout
            {
                public static readonly SBSP.Scenery_Cluster.Cluster_Portal Layout = new SBSP.Scenery_Cluster.Cluster_Portal();
                public ShortInteger portal = new ShortInteger("portal");

                public Cluster_Portal()
                {
                    base.Add(this.portal);
                }
            }

            public class Cluster_Unknown_1 : TagBlockLayout
            {
                public static readonly SBSP.Scenery_Cluster.Cluster_Unknown_1 Layout = new SBSP.Scenery_Cluster.Cluster_Unknown_1();
                public ShortInteger unk1 = new ShortInteger("unknown");

                public Cluster_Unknown_1()
                {
                    base.Add(this.unk1);
                }
            }

            public class Predicted_Resource : TagBlockLayout
            {
                public static readonly SBSP.Scenery_Cluster.Predicted_Resource Layout = new SBSP.Scenery_Cluster.Predicted_Resource();
                public TagIdent tagident = new TagIdent("Tag Ident");
                public ShortInteger unknown1 = new ShortInteger("unknown1");
                public ShortInteger unknown2 = new ShortInteger("unknown2");

                public Predicted_Resource()
                {
                    base.Add(this.unknown1);
                    base.Add(this.unknown2);
                    base.Add(this.tagident);
                }
            }

            public class SBSP_Visual_Raw_Header : TagBlockLayout
            {
                public TagBlock bvh = new TagBlock("BVH", Raw_Tag_Block.BVH.Layout, Map.HaloVersionEnum.Halo2);
                public TagBlock indices = new TagBlock("Indices", Raw_Tag_Block.Indice.Layout, Map.HaloVersionEnum.Halo2);
                public static readonly SBSP.Scenery_Cluster.SBSP_Visual_Raw_Header Layout = new SBSP.Scenery_Cluster.SBSP_Visual_Raw_Header();
                public TagBlock mesh_bvh_order = new TagBlock("Mesh BVH Order", Raw_Tag_Block.Mesh_BVH_Order.Layout, Map.HaloVersionEnum.Halo2);
                public Padding padding1 = new Padding(0x10);
                public Padding padding2 = new Padding(4);
                public TagBlock sub_cluster_data = new TagBlock("Sub-Clusters Data", Raw_Tag_Block.Sub_Cluster_Data.Layout, Map.HaloVersionEnum.Halo2);
                public TagBlock sub_clusters = new TagBlock("Sub-Clusters", Raw_Tag_Block.Sub_Cluster.Layout, Map.HaloVersionEnum.Halo2);
                public TagBlock vertices = new TagBlock("Vertex Declaration", Raw_Tag_Block.Vertex_Declaration.Layout, Map.HaloVersionEnum.Halo2);

                public SBSP_Visual_Raw_Header()
                {
                    base.Add(this.sub_clusters);
                    base.Add(this.sub_cluster_data);
                    base.Add(this.padding1);
                    base.Add(this.indices);
                    base.Add(this.bvh);
                    base.Add(this.mesh_bvh_order);
                    base.Add(this.vertices);
                    base.Add(this.padding2);
                }
            }

            public class Scenery_Cluster_Unknown1 : TagBlockLayout
            {
                public TagBlock bvh = new TagBlock("BVH", SBSP.Detail_Objects.BVH.Layout, Map.HaloVersionEnum.Halo2);
                public static readonly SBSP.Scenery_Cluster.Scenery_Cluster_Unknown1 Layout = new SBSP.Scenery_Cluster.Scenery_Cluster_Unknown1();
                public Padding padding1 = new Padding(100);
                public Padding padding2 = new Padding(4);

                public Scenery_Cluster_Unknown1()
                {
                    base.Add(this.padding1);
                    base.Add(this.bvh);
                    base.Add(this.padding2);
                }
            }

            public class Scenery_Cluster_Unknown2 : TagBlockLayout
            {
                public static readonly SBSP.Scenery_Cluster.Scenery_Cluster_Unknown2 Layout = new SBSP.Scenery_Cluster.Scenery_Cluster_Unknown2();
                public Padding padding1 = new Padding(8);

                public Scenery_Cluster_Unknown2()
                {
                    base.Add(this.padding1);
                }
            }

            public class Scenery_Cluster_Unknown4 : TagBlockLayout
            {
                public static readonly SBSP.Scenery_Cluster.Scenery_Cluster_Unknown4 Layout = new SBSP.Scenery_Cluster.Scenery_Cluster_Unknown4();
                public Padding padding1 = new Padding(0x38);

                public Scenery_Cluster_Unknown4()
                {
                    base.Add(this.padding1);
                }
            }
        }

        public class Scenery_Placement : TagBlockLayout
        {
            public static readonly SBSP.Scenery_Placement Layout = new SBSP.Scenery_Placement();
            public StringID name = new StringID("Name");
            public Padding padding1 = new Padding(80);
            public Padding padding2 = new Padding(4);

            public Scenery_Placement()
            {
                base.Add(this.padding1);
                base.Add(this.name);
                base.Add(this.padding2);
            }
        }

        public class Sound_Environment_Palette : TagBlockLayout
        {
            public TagReference ident = new TagReference("Ident", Map.HaloVersionEnum.Halo2);
            public static readonly SBSP.Sound_Environment_Palette Layout = new SBSP.Sound_Environment_Palette();
            public core.TagInterface.String name = new core.TagInterface.String("Name", 0x20);
            public Padding unknown = new Padding(0x20);

            public Sound_Environment_Palette()
            {
                base.Add(this.name);
                base.Add(this.ident);
                base.Add(this.unknown);
            }
        }

        public class Sound_Data : TagBlockLayout
        {
            public static readonly SBSP.Sound_Data Layout = new SBSP.Sound_Data();
            public Padding unknown = new Padding("unknown", 0x24);

            public Sound_Data()
            {
                base.Add(this.unknown);
            }
        }

        public class Mopp_Code_2 : TagBlockLayout
        {
            public static readonly SBSP.Mopp_Code_2 Layout = new SBSP.Mopp_Code_2();
            public ByteInteger unknown = new ByteInteger("unknown");

            public Mopp_Code_2()
            {
                base.Add(this.unknown);
            }
        }

        public class Breakable_Surface_Key_Table : TagBlockLayout
        {
            public static readonly SBSP.Breakable_Surface_Key_Table Layout = new SBSP.Breakable_Surface_Key_Table();
            public Padding unknown = new Padding(0x20);

            public Breakable_Surface_Key_Table()
            {
                base.Add(this.unknown);
            }
        }

        public class Conveyor_Surfaces : TagBlockLayout
        {
            public static readonly SBSP.Conveyor_Surfaces Layout = new SBSP.Conveyor_Surfaces();
            public RealFloat ui = new RealFloat("U i");
            public RealFloat uj = new RealFloat("U j");
            public RealFloat uk = new RealFloat("U k");
            public RealFloat vi = new RealFloat("V i");
            public RealFloat vj = new RealFloat("V j");
            public RealFloat vk = new RealFloat("V k");

            public Conveyor_Surfaces()
            {
                base.Add(this.ui);
                base.Add(this.uj);
                base.Add(this.uk);
                base.Add(this.vi);
                base.Add(this.vj);
                base.Add(this.vk);
            }
        }

        public class Breakable_Surfaces : TagBlockLayout
        {
            public static readonly SBSP.Breakable_Surfaces Layout = new SBSP.Breakable_Surfaces();
            public ShortInteger instanced_geometry_instance = new ShortInteger("Instanced Geometry Instance");
            public ShortInteger breakable_surface_index = new ShortInteger("Breakable Surface Index");
            public RealFloat centroid_x = new RealFloat("Centroid X");
            public RealFloat centroid_y = new RealFloat("Centroid Y");
            public RealFloat centroid_z = new RealFloat("Centroid Z");
            public RealFloat radius = new RealFloat("Radius");
            public LongInteger collision_surface_index = new LongInteger("Collision Surface Index");

            public Breakable_Surfaces()
            {
                base.Add(this.instanced_geometry_instance);
                base.Add(this.breakable_surface_index);
                base.Add(this.centroid_x);
                base.Add(this.centroid_y);
                base.Add(this.centroid_z);
                base.Add(this.radius);
                base.Add(this.collision_surface_index);
            }
        }

        public class Unknown_Block_16 : TagBlockLayout
        {
            public static readonly SBSP.Unknown_Block_16 Layout = new SBSP.Unknown_Block_16();
            public Padding padding1 = new Padding(8);
            public Padding padding2 = new Padding(0x24);
            public TagBlock unknown_1 = new TagBlock("Unknown_Block_16_Unknown_Block_1", Unknown_Block_16_Unknown_Block_1.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock unknown_2 = new TagBlock("Unknown_Block_16_Unknown_Block_2", Unknown_Block_16_Unknown_Block_2.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock unknown_3 = new TagBlock("Unknown_Block_16_Unknown_Block_3", Unknown_Block_16_Unknown_Block_3.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock unknown_4 = new TagBlock("Unknown_Block_16_Unknown_Block_4", Unknown_Block_16_Unknown_Block_4.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock unknown_5 = new TagBlock("Unknown_Block_16_Unknown_Block_5", Unknown_Block_16_Unknown_Block_5.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock unknown_6 = new TagBlock("Unknown_Block_16_Unknown_Block_6", Unknown_Block_16_Unknown_Block_6.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock unknown_7 = new TagBlock("Unknown_Block_16_Unknown_Block_7", Unknown_Block_16_Unknown_Block_7.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock unknown_8 = new TagBlock("Unknown_Block_16_Unknown_Block_8", Unknown_Block_16_Unknown_Block_8.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock unknown_9 = new TagBlock("Unknown_Block_16_Unknown_Block_9", Unknown_Block_16_Unknown_Block_9.Layout, Map.HaloVersionEnum.Halo2);

            public Unknown_Block_16()
            {
                base.Add(this.unknown_1);
                base.Add(this.unknown_2);
                base.Add(this.unknown_3);
                base.Add(this.unknown_4);
                base.Add(this.padding1);
                base.Add(this.unknown_5);
                base.Add(this.unknown_6);
                base.Add(this.unknown_7);
                base.Add(this.unknown_8);
                base.Add(this.padding2);
                base.Add(this.unknown_9);
            }

            public class Unknown_Block_16_Unknown_Block_1 : TagBlockLayout
            {
                public static readonly SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_1 Layout = new SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_1();
                public Padding padding1 = new Padding(8);

                public Unknown_Block_16_Unknown_Block_1()
                {
                    base.Add(this.padding1);
                }
            }

            public class Unknown_Block_16_Unknown_Block_2 : TagBlockLayout
            {
                public static readonly SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_2 Layout = new SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_2();
                public Padding padding1 = new Padding(0x10);

                public Unknown_Block_16_Unknown_Block_2()
                {
                    base.Add(this.padding1);
                }
            }

            public class Unknown_Block_16_Unknown_Block_3 : TagBlockLayout
            {
                public static readonly SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_3 Layout = new SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_3();
                public Padding padding1 = new Padding(4);

                public Unknown_Block_16_Unknown_Block_3()
                {
                    base.Add(this.padding1);
                }
            }

            public class Unknown_Block_16_Unknown_Block_4 : TagBlockLayout
            {
                public static readonly SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_4 Layout = new SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_4();
                public Padding padding1 = new Padding(8);
                public RealPoint3D unkown1 = new RealPoint3D("Uknown");

                public Unknown_Block_16_Unknown_Block_4()
                {
                    base.Add(this.unkown1);
                    base.Add(this.padding1);
                }
            }

            public class Unknown_Block_16_Unknown_Block_5 : TagBlockLayout
            {
                public static readonly SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_5 Layout = new SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_5();
                public RealPoint3D unkown = new RealPoint3D("Unkown");

                public Unknown_Block_16_Unknown_Block_5()
                {
                    base.Add(this.unkown);
                }
            }

            public class Unknown_Block_16_Unknown_Block_6 : TagBlockLayout
            {
                public static readonly SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_6 Layout = new SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_6();
                public Padding padding1 = new Padding(12);
                public TagBlock unknown_1 = new TagBlock("Unknown_Block_16_Unknown_Block_6_Unknown_Block_1", Unknown_Block_16_Unknown_Block_6_Unknown_Block_1.Layout, Map.HaloVersionEnum.Halo2);
                public TagBlock unknown_2 = new TagBlock("Unknown_Block_16_Unknown_Block_6_Unknown_Block_2", Unknown_Block_16_Unknown_Block_6_Unknown_Block_2.Layout, Map.HaloVersionEnum.Halo2);

                public Unknown_Block_16_Unknown_Block_6()
                {
                    base.Add(this.padding1);
                    base.Add(this.unknown_1);
                    base.Add(this.unknown_2);
                }

                public class Unknown_Block_16_Unknown_Block_6_Unknown_Block_1 : TagBlockLayout
                {
                    public static readonly SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_6.Unknown_Block_16_Unknown_Block_6_Unknown_Block_1 Layout = new SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_6.Unknown_Block_16_Unknown_Block_6_Unknown_Block_1();
                    public Padding padding1 = new Padding(0x10);

                    public Unknown_Block_16_Unknown_Block_6_Unknown_Block_1()
                    {
                        base.Add(this.padding1);
                    }
                }

                public class Unknown_Block_16_Unknown_Block_6_Unknown_Block_2 : TagBlockLayout
                {
                    public static readonly SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_6.Unknown_Block_16_Unknown_Block_6_Unknown_Block_2 Layout = new SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_6.Unknown_Block_16_Unknown_Block_6_Unknown_Block_2();
                    public Padding padding1 = new Padding(4);

                    public Unknown_Block_16_Unknown_Block_6_Unknown_Block_2()
                    {
                        base.Add(this.padding1);
                    }
                }
            }

            public class Unknown_Block_16_Unknown_Block_7 : TagBlockLayout
            {
                public static readonly SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_7 Layout = new SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_7();
                public Padding padding1 = new Padding(20);

                public Unknown_Block_16_Unknown_Block_7()
                {
                    base.Add(this.padding1);
                }
            }

            public class Unknown_Block_16_Unknown_Block_8 : TagBlockLayout
            {
                public static readonly SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_8 Layout = new SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_8();
                public Padding padding1 = new Padding(4);

                public Unknown_Block_16_Unknown_Block_8()
                {
                    base.Add(this.padding1);
                }
            }

            public class Unknown_Block_16_Unknown_Block_9 : TagBlockLayout
            {
                public static readonly SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_9 Layout = new SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_9();
                public Padding padding1 = new Padding(0x10);
                public Padding padding2 = new Padding(8);
                public TagBlock unknown_1 = new TagBlock("Unknown_Block_16_Unknown_Block_9_Unknown_Block_1", Unknown_Block_16_Unknown_Block_9_Unknown_Block_1.Layout, Map.HaloVersionEnum.Halo2);
                public TagBlock unknown_2 = new TagBlock("Unknown_Block_16_Unknown_Block_9_Unknown_Block_2", Unknown_Block_16_Unknown_Block_9_Unknown_Block_2.Layout, Map.HaloVersionEnum.Halo2);
                public TagBlock unknown_3 = new TagBlock("Unknown_Block_16_Unknown_Block_9_Unknown_Block_3", Unknown_Block_16_Unknown_Block_9_Unknown_Block_3.Layout, Map.HaloVersionEnum.Halo2);
                public TagBlock unknown_4 = new TagBlock("Unknown_Block_16_Unknown_Block_9_Unknown_Block_4", Unknown_Block_16_Unknown_Block_9_Unknown_Block_4.Layout, Map.HaloVersionEnum.Halo2);
                public TagBlock unknown_5 = new TagBlock("Unknown_Block_16_Unknown_Block_9_Unknown_Block_5", Unknown_Block_16_Unknown_Block_9_Unknown_Block_5.Layout, Map.HaloVersionEnum.Halo2);
                public TagBlock unknown_6 = new TagBlock("Unknown_Block_16_Unknown_Block_9_Unknown_Block_6", Unknown_Block_16_Unknown_Block_9_Unknown_Block_6.Layout, Map.HaloVersionEnum.Halo2);

                public Unknown_Block_16_Unknown_Block_9()
                {
                    base.Add(this.padding1);
                    base.Add(this.unknown_3);
                    base.Add(this.unknown_1);
                    base.Add(this.padding2);
                    base.Add(this.unknown_2);
                    base.Add(this.unknown_4);
                    base.Add(this.unknown_6);
                    base.Add(this.unknown_5);
                }

                public class Unknown_Block_16_Unknown_Block_9_Unknown_Block_1 : TagBlockLayout
                {
                    public static readonly SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_9.Unknown_Block_16_Unknown_Block_9_Unknown_Block_1 Layout = new SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_9.Unknown_Block_16_Unknown_Block_9_Unknown_Block_1();
                    public Padding padding1 = new Padding(0x44);

                    public Unknown_Block_16_Unknown_Block_9_Unknown_Block_1()
                    {
                        base.Add(this.padding1);
                    }
                }

                public class Unknown_Block_16_Unknown_Block_9_Unknown_Block_2 : TagBlockLayout
                {
                    public static readonly SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_9.Unknown_Block_16_Unknown_Block_9_Unknown_Block_2 Layout = new SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_9.Unknown_Block_16_Unknown_Block_9_Unknown_Block_2();
                    public Padding padding1 = new Padding(8);

                    public Unknown_Block_16_Unknown_Block_9_Unknown_Block_2()
                    {
                        base.Add(this.padding1);
                    }
                }

                public class Unknown_Block_16_Unknown_Block_9_Unknown_Block_3 : TagBlockLayout
                {
                    public static readonly SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_9.Unknown_Block_16_Unknown_Block_9_Unknown_Block_3 Layout = new SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_9.Unknown_Block_16_Unknown_Block_9_Unknown_Block_3();
                    public Padding padding1 = new Padding(0x24);

                    public Unknown_Block_16_Unknown_Block_9_Unknown_Block_3()
                    {
                        base.Add(this.padding1);
                    }
                }

                public class Unknown_Block_16_Unknown_Block_9_Unknown_Block_4 : TagBlockLayout
                {
                    public static readonly SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_9.Unknown_Block_16_Unknown_Block_9_Unknown_Block_4 Layout = new SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_9.Unknown_Block_16_Unknown_Block_9_Unknown_Block_4();
                    public Padding padding1 = new Padding(4);

                    public Unknown_Block_16_Unknown_Block_9_Unknown_Block_4()
                    {
                        base.Add(this.padding1);
                    }
                }

                public class Unknown_Block_16_Unknown_Block_9_Unknown_Block_5 : TagBlockLayout
                {
                    public static readonly SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_9.Unknown_Block_16_Unknown_Block_9_Unknown_Block_5 Layout = new SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_9.Unknown_Block_16_Unknown_Block_9_Unknown_Block_5();
                    public TagBlock unknown_1 = new TagBlock("Unknown_Block_16_Unknown_Block_9_Unknown_Block_5_Unknown_Block_1", Unknown_Block_16_Unknown_Block_9_Unknown_Block_5_Unknown_Block_1.Layout, Map.HaloVersionEnum.Halo2);

                    public Unknown_Block_16_Unknown_Block_9_Unknown_Block_5()
                    {
                        base.Add(this.unknown_1);
                    }

                    public class Unknown_Block_16_Unknown_Block_9_Unknown_Block_5_Unknown_Block_1 : TagBlockLayout
                    {
                        public static readonly SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_9.Unknown_Block_16_Unknown_Block_9_Unknown_Block_5.Unknown_Block_16_Unknown_Block_9_Unknown_Block_5_Unknown_Block_1 Layout = new SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_9.Unknown_Block_16_Unknown_Block_9_Unknown_Block_5.Unknown_Block_16_Unknown_Block_9_Unknown_Block_5_Unknown_Block_1();
                        public Padding padding1 = new Padding(12);

                        public Unknown_Block_16_Unknown_Block_9_Unknown_Block_5_Unknown_Block_1()
                        {
                            base.Add(this.padding1);
                        }
                    }
                }

                public class Unknown_Block_16_Unknown_Block_9_Unknown_Block_6 : TagBlockLayout
                {
                    public static readonly SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_9.Unknown_Block_16_Unknown_Block_9_Unknown_Block_6 Layout = new SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_9.Unknown_Block_16_Unknown_Block_9_Unknown_Block_6();
                    public Padding padding1 = new Padding(4);
                    public TagBlock unknown_1 = new TagBlock("Unknown_Block_16_Unknown_Block_9_Unknown_Block_6_Unknown_Block_1-maybe vertices", Unknown_Block_16_Unknown_Block_9_Unknown_Block_6_Unknown_Block_1.Layout, Map.HaloVersionEnum.Halo2);

                    public Unknown_Block_16_Unknown_Block_9_Unknown_Block_6()
                    {
                        base.Add(this.padding1);
                        base.Add(this.unknown_1);
                    }

                    public class Unknown_Block_16_Unknown_Block_9_Unknown_Block_6_Unknown_Block_1 : TagBlockLayout
                    {
                        public static readonly SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_9.Unknown_Block_16_Unknown_Block_9_Unknown_Block_6.Unknown_Block_16_Unknown_Block_9_Unknown_Block_6_Unknown_Block_1 Layout = new SBSP.Unknown_Block_16.Unknown_Block_16_Unknown_Block_9.Unknown_Block_16_Unknown_Block_9_Unknown_Block_6.Unknown_Block_16_Unknown_Block_9_Unknown_Block_6_Unknown_Block_1();
                        public Padding padding1 = new Padding(0x20);

                        public Unknown_Block_16_Unknown_Block_9_Unknown_Block_6_Unknown_Block_1()
                        {
                            base.Add(this.padding1);
                        }
                    }
                }
            }
        }

        public class Sky_Owner_Cluster : TagBlockLayout
        {
            public static readonly SBSP.Sky_Owner_Cluster Layout = new SBSP.Sky_Owner_Cluster();
            public ShortInteger unknown = new ShortInteger("unknown");

            public Sky_Owner_Cluster()
            {
                base.Add(this.unknown);
            }
        }

        public class Sound_Clusters : TagBlockLayout
        {
            public static readonly SBSP.Sound_Clusters Layout = new SBSP.Sound_Clusters();
            public ShortInteger unknown = new ShortInteger("unknown");
            public ShortInteger unknown2 = new ShortInteger("unknown");
            public TagBlock unknownblock1 = new TagBlock("Unknown_Block_3_Unknown_Block_1", Unknown_Block_3_Unknown_Block_1.Layout, Map.HaloVersionEnum.Halo2, 4);
            public TagBlock unknownblock2 = new TagBlock("Unknown_Block_3_Unknown_Block_2", Unknown_Block_3_Unknown_Block_2.Layout, Map.HaloVersionEnum.Halo2, 4);

            public Sound_Clusters()
            {
                base.Add(this.unknown);
                base.Add(this.unknown2);
                base.Add(this.unknownblock1);
                base.Add(this.unknownblock2);
            }

            public class Unknown_Block_3_Unknown_Block_1 : TagBlockLayout
            {
                public static readonly SBSP.Sound_Clusters.Unknown_Block_3_Unknown_Block_1 Layout = new SBSP.Sound_Clusters.Unknown_Block_3_Unknown_Block_1();
                public ShortInteger unknown = new ShortInteger("unknown");

                public Unknown_Block_3_Unknown_Block_1()
                {
                    base.Add(this.unknown);
                }
            }

            public class Unknown_Block_3_Unknown_Block_2 : TagBlockLayout
            {
                public static readonly SBSP.Sound_Clusters.Unknown_Block_3_Unknown_Block_2 Layout = new SBSP.Sound_Clusters.Unknown_Block_3_Unknown_Block_2();
                public ShortInteger unknown = new ShortInteger("unknown");

                public Unknown_Block_3_Unknown_Block_2()
                {
                    base.Add(this.unknown);
                }
            }
        }

        public class Unknown_Block_4 : TagBlockLayout
        {
            public static readonly SBSP.Unknown_Block_4 Layout = new SBSP.Unknown_Block_4();
            public Padding padding = new Padding(0x40);
            public TagBlock unknown_block1 = new TagBlock("Unknown_Block4_Unknown_Block_1", Unknown_Block4_Unknown_Block_1.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock unknown_block2 = new TagBlock("Unknown_Block4_Unknown_Block_2", Unknown_Block4_Unknown_Block_2.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock unknown_block3 = new TagBlock("Unknown_Block4_Unknown_Block_3", Unknown_Block4_Unknown_Block_3.Layout, Map.HaloVersionEnum.Halo2);

            public Unknown_Block_4()
            {
                base.Add(this.padding);
                base.Add(this.unknown_block1);
                base.Add(this.unknown_block2);
                base.Add(this.unknown_block3);
            }

            public class Unknown_Block4_Unknown_Block_1 : TagBlockLayout
            {
                public static readonly SBSP.Unknown_Block_4.Unknown_Block4_Unknown_Block_1 Layout = new SBSP.Unknown_Block_4.Unknown_Block4_Unknown_Block_1();
                public Padding padding = new Padding(8);
                public Padding unknown = new Padding(40);
                public TagBlock unknown_block1 = new TagBlock("Unknown_Block4_Unknown_Block_1_Unknown_Block_1", Unknown_Block4_Unknown_Block_1_Unknown_Block_1.Layout, Map.HaloVersionEnum.Halo2);
                public TagBlock unknown_block2 = new TagBlock("Unknown_Block4_Unknown_Block_1_Unknown_Block_2", Unknown_Block4_Unknown_Block_1_Unknown_Block_2.Layout, Map.HaloVersionEnum.Halo2);
                public TagBlock unknown_block3 = new TagBlock("Unknown_Block4_Unknown_Block_1_Unknown_Block_2", Unknown_Block4_Unknown_Block_1_Unknown_Block_2.Layout, Map.HaloVersionEnum.Halo2);

                public Unknown_Block4_Unknown_Block_1()
                {
                    base.Add(this.unknown);
                    base.Add(this.unknown_block1);
                    base.Add(this.unknown_block2);
                    base.Add(this.padding);
                    base.Add(this.unknown_block3);
                }

                public class Unknown_Block4_Unknown_Block_1_Unknown_Block_1 : TagBlockLayout
                {
                    public static readonly SBSP.Unknown_Block_4.Unknown_Block4_Unknown_Block_1.Unknown_Block4_Unknown_Block_1_Unknown_Block_1 Layout = new SBSP.Unknown_Block_4.Unknown_Block4_Unknown_Block_1.Unknown_Block4_Unknown_Block_1_Unknown_Block_1();
                    public Padding unknown = new Padding(4);

                    public Unknown_Block4_Unknown_Block_1_Unknown_Block_1()
                    {
                        base.Add(this.unknown);
                    }
                }

                public class Unknown_Block4_Unknown_Block_1_Unknown_Block_2 : TagBlockLayout
                {
                    public static readonly SBSP.Unknown_Block_4.Unknown_Block4_Unknown_Block_1.Unknown_Block4_Unknown_Block_1_Unknown_Block_2 Layout = new SBSP.Unknown_Block_4.Unknown_Block4_Unknown_Block_1.Unknown_Block4_Unknown_Block_1_Unknown_Block_2();
                    public Padding unknown = new Padding(4);

                    public Unknown_Block4_Unknown_Block_1_Unknown_Block_2()
                    {
                        base.Add(this.unknown);
                    }
                }
            }

            public class Unknown_Block4_Unknown_Block_2 : TagBlockLayout
            {
                public static readonly SBSP.Unknown_Block_4.Unknown_Block4_Unknown_Block_2 Layout = new SBSP.Unknown_Block_4.Unknown_Block4_Unknown_Block_2();
                public Padding unknown = new Padding(0x1c);
                public TagBlock unknown_block1 = new TagBlock("Unknown_Block4_Unknown_Block_2_Unknown_Block_1", Unknown_Block4_Unknown_Block_2_Unknown_Block_1.Layout, Map.HaloVersionEnum.Halo2);
                public TagBlock unknown_block2 = new TagBlock("Unknown_Block4_Unknown_Block_2_Unknown_Block_1", Unknown_Block4_Unknown_Block_2_Unknown_Block_2.Layout, Map.HaloVersionEnum.Halo2);
                public TagBlock unknown_block3 = new TagBlock("Unknown_Block4_Unknown_Block_2_Unknown_Block_1", Unknown_Block4_Unknown_Block_2_Unknown_Block_3.Layout, Map.HaloVersionEnum.Halo2);
                public LongInteger unknown1 = new LongInteger("unknown");

                public Unknown_Block4_Unknown_Block_2()
                {
                    base.Add(this.unknown);
                    base.Add(this.unknown1);
                    base.Add(this.unknown_block1);
                    base.Add(this.unknown_block2);
                    base.Add(this.unknown_block3);
                }

                public class Unknown_Block4_Unknown_Block_2_Unknown_Block_1 : TagBlockLayout
                {
                    public static readonly SBSP.Unknown_Block_4.Unknown_Block4_Unknown_Block_2.Unknown_Block4_Unknown_Block_2_Unknown_Block_1 Layout = new SBSP.Unknown_Block_4.Unknown_Block4_Unknown_Block_2.Unknown_Block4_Unknown_Block_2_Unknown_Block_1();
                    public LongInteger unknown1 = new LongInteger("unknown");
                    public LongInteger unknown2 = new LongInteger("unknown");
                    public RealFloat unknown3 = new RealFloat("unknown");
                    public RealFloat unknown4 = new RealFloat("unknown");
                    public RealFloat unknown5 = new RealFloat("unknown");
                    public RealFloat unknown6 = new RealFloat("unknown");
                    public RealFloat unknown7 = new RealFloat("unknown");
                    public RealFloat unknown8 = new RealFloat("unknown");

                    public Unknown_Block4_Unknown_Block_2_Unknown_Block_1()
                    {
                        base.Add(this.unknown1);
                        base.Add(this.unknown2);
                        base.Add(this.unknown3);
                        base.Add(this.unknown4);
                        base.Add(this.unknown5);
                        base.Add(this.unknown6);
                        base.Add(this.unknown7);
                        base.Add(this.unknown8);
                    }
                }

                public class Unknown_Block4_Unknown_Block_2_Unknown_Block_2 : TagBlockLayout
                {
                    public static readonly SBSP.Unknown_Block_4.Unknown_Block4_Unknown_Block_2.Unknown_Block4_Unknown_Block_2_Unknown_Block_2 Layout = new SBSP.Unknown_Block_4.Unknown_Block4_Unknown_Block_2.Unknown_Block4_Unknown_Block_2_Unknown_Block_2();
                    public LongInteger unknown1 = new LongInteger("unknown");

                    public Unknown_Block4_Unknown_Block_2_Unknown_Block_2()
                    {
                        base.Add(this.unknown1);
                    }
                }

                public class Unknown_Block4_Unknown_Block_2_Unknown_Block_3 : TagBlockLayout
                {
                    public static readonly SBSP.Unknown_Block_4.Unknown_Block4_Unknown_Block_2.Unknown_Block4_Unknown_Block_2_Unknown_Block_3 Layout = new SBSP.Unknown_Block_4.Unknown_Block4_Unknown_Block_2.Unknown_Block4_Unknown_Block_2_Unknown_Block_3();
                    public Padding unknown1 = new Padding(4);

                    public Unknown_Block4_Unknown_Block_2_Unknown_Block_3()
                    {
                        base.Add(this.unknown1);
                    }
                }
            }

            public class Unknown_Block4_Unknown_Block_3 : TagBlockLayout
            {
                public static readonly SBSP.Unknown_Block_4.Unknown_Block4_Unknown_Block_3 Layout = new SBSP.Unknown_Block_4.Unknown_Block4_Unknown_Block_3();
                public TagBlock unknown_block1 = new TagBlock("Unknown_Block4_Unknown_Block_3_Unknown_Block_1", Unknown_Block4_Unknown_Block_3_Unknown_Block_1.Layout, Map.HaloVersionEnum.Halo2);
                public TagBlock unknown_block2 = new TagBlock("Unknown_Block4_Unknown_Block_3_Unknown_Block_2", Unknown_Block4_Unknown_Block_3_Unknown_Block_2.Layout, Map.HaloVersionEnum.Halo2);
                public Padding unknown1 = new Padding(0x20);
                public Padding unknown2 = new Padding(8);
                public Padding unknown3 = new Padding(8);

                public Unknown_Block4_Unknown_Block_3()
                {
                    base.Add(this.unknown1);
                    base.Add(this.unknown_block1);
                    base.Add(this.unknown2);
                    base.Add(this.unknown_block2);
                    base.Add(this.unknown3);
                }

                public class Unknown_Block4_Unknown_Block_3_Unknown_Block_1 : TagBlockLayout
                {
                    public static readonly SBSP.Unknown_Block_4.Unknown_Block4_Unknown_Block_3.Unknown_Block4_Unknown_Block_3_Unknown_Block_1 Layout = new SBSP.Unknown_Block_4.Unknown_Block4_Unknown_Block_3.Unknown_Block4_Unknown_Block_3_Unknown_Block_1();
                    public ShortInteger unknown0 = new ShortInteger("unknown");
                    public ShortInteger unknown1 = new ShortInteger("unknown");
                    public LongInteger unknown2 = new LongInteger("unknown");
                    public RealFloat unknown3 = new RealFloat("unknown");
                    public RealFloat unknown4 = new RealFloat("unknown");
                    public RealFloat unknown5 = new RealFloat("unknown");
                    public RealFloat unknown6 = new RealFloat("unknown");
                    public RealFloat unknown7 = new RealFloat("unknown");
                    public RealFloat unknown8 = new RealFloat("unknown");

                    public Unknown_Block4_Unknown_Block_3_Unknown_Block_1()
                    {
                        base.Add(this.unknown0);
                        base.Add(this.unknown1);
                        base.Add(this.unknown2);
                        base.Add(this.unknown3);
                        base.Add(this.unknown4);
                        base.Add(this.unknown5);
                        base.Add(this.unknown6);
                        base.Add(this.unknown7);
                        base.Add(this.unknown8);
                    }
                }

                public class Unknown_Block4_Unknown_Block_3_Unknown_Block_2 : TagBlockLayout
                {
                    public static readonly SBSP.Unknown_Block_4.Unknown_Block4_Unknown_Block_3.Unknown_Block4_Unknown_Block_3_Unknown_Block_2 Layout = new SBSP.Unknown_Block_4.Unknown_Block4_Unknown_Block_3.Unknown_Block4_Unknown_Block_3_Unknown_Block_2();
                    public Padding unknown = new Padding(4);

                    public Unknown_Block4_Unknown_Block_3_Unknown_Block_2()
                    {
                        base.Add(this.unknown);
                    }
                }
            }
        }

        public class Mopp_Code_1 : TagBlockLayout
        {
            public static readonly SBSP.Mopp_Code_1 Layout = new SBSP.Mopp_Code_1();
            public ByteInteger unknown = new ByteInteger("unknown");

            public Mopp_Code_1()
            {
                base.Add(this.unknown);
            }
        }

        public class Portal_Device_Mapping : TagBlockLayout
        {
            public static readonly SBSP.Portal_Device_Mapping Layout = new SBSP.Portal_Device_Mapping();
            public TagBlock unknownblock1 = new TagBlock("Unknown_Block_6_Unknown_Block_1", Unknown_Block_6_Unknown_Block_1.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock unknownblock2 = new TagBlock("Unknown_Block_6_Unknown_Block_2", Unknown_Block_6_Unknown_Block_2.Layout, Map.HaloVersionEnum.Halo2);

            public Portal_Device_Mapping()
            {
                base.Add(this.unknownblock1);
                base.Add(this.unknownblock2);
            }

            public class Unknown_Block_6_Unknown_Block_1 : TagBlockLayout
            {
                public static readonly SBSP.Portal_Device_Mapping.Unknown_Block_6_Unknown_Block_1 Layout = new SBSP.Portal_Device_Mapping.Unknown_Block_6_Unknown_Block_1();
                public Padding unknown = new Padding(12);

                public Unknown_Block_6_Unknown_Block_1()
                {
                    base.Add(this.unknown);
                }
            }

            public class Unknown_Block_6_Unknown_Block_2 : TagBlockLayout
            {
                public static readonly SBSP.Portal_Device_Mapping.Unknown_Block_6_Unknown_Block_2 Layout = new SBSP.Portal_Device_Mapping.Unknown_Block_6_Unknown_Block_2();
                public Padding unknown = new Padding(2);

                public Unknown_Block_6_Unknown_Block_2()
                {
                    base.Add(this.unknown);
                }
            }
        }

        public class Audibility : TagBlockLayout
        {
            public static readonly SBSP.Audibility Layout = new SBSP.Audibility();
            public LongInteger unknown1 = new LongInteger("unknown1");
            public ShortInteger unknown2 = new ShortInteger("unknown2");
            public ShortInteger unknown3 = new ShortInteger("unknown3");
            public LongInteger unknown4 = new LongInteger("unknown4");
            public TagBlock unknownblock1 = new TagBlock("Unknown_Block_7_Unknown_Block_1", Unknown_Block_7_Unknown_Block_1.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock unknownblock2 = new TagBlock("Unknown_Block_7_Unknown_Block_2", Unknown_Block_7_Unknown_Block_2.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock unknownblock3 = new TagBlock("Unknown_Block_7_Unknown_Block_3", Unknown_Block_7_Unknown_Block_3.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock unknownblock4 = new TagBlock("Unknown_Block_7_Unknown_Block_4", Unknown_Block_7_Unknown_Block_4.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock unknownblock5 = new TagBlock("Unknown_Block_7_Unknown_Block_5", Unknown_Block_7_Unknown_Block_5.Layout, Map.HaloVersionEnum.Halo2, 4);

            public Audibility()
            {
                base.Add(this.unknown1);
                base.Add(this.unknown2);
                base.Add(this.unknown3);
                base.Add(this.unknown4);
                base.Add(this.unknownblock1);
                base.Add(this.unknownblock2);
                base.Add(this.unknownblock3);
                base.Add(this.unknownblock4);
                base.Add(this.unknownblock5);
            }

            public class Unknown_Block_7_Unknown_Block_1 : TagBlockLayout
            {
                public static readonly SBSP.Audibility.Unknown_Block_7_Unknown_Block_1 Layout = new SBSP.Audibility.Unknown_Block_7_Unknown_Block_1();
                public Padding unknown = new Padding(4);

                public Unknown_Block_7_Unknown_Block_1()
                {
                    base.Add(this.unknown);
                }
            }

            public class Unknown_Block_7_Unknown_Block_2 : TagBlockLayout
            {
                public static readonly SBSP.Audibility.Unknown_Block_7_Unknown_Block_2 Layout = new SBSP.Audibility.Unknown_Block_7_Unknown_Block_2();
                public Padding unknown = new Padding(4);

                public Unknown_Block_7_Unknown_Block_2()
                {
                    base.Add(this.unknown);
                }
            }

            public class Unknown_Block_7_Unknown_Block_3 : TagBlockLayout
            {
                public static readonly SBSP.Audibility.Unknown_Block_7_Unknown_Block_3 Layout = new SBSP.Audibility.Unknown_Block_7_Unknown_Block_3();
                public Padding unknown = new Padding(4);

                public Unknown_Block_7_Unknown_Block_3()
                {
                    base.Add(this.unknown);
                }
            }

            public class Unknown_Block_7_Unknown_Block_4 : TagBlockLayout
            {
                public static readonly SBSP.Audibility.Unknown_Block_7_Unknown_Block_4 Layout = new SBSP.Audibility.Unknown_Block_7_Unknown_Block_4();
                public Padding unknown = new Padding(1);

                public Unknown_Block_7_Unknown_Block_4()
                {
                    base.Add(this.unknown);
                }
            }

            public class Unknown_Block_7_Unknown_Block_5 : TagBlockLayout
            {
                public static readonly SBSP.Audibility.Unknown_Block_7_Unknown_Block_5 Layout = new SBSP.Audibility.Unknown_Block_7_Unknown_Block_5();
                public Padding unknown = new Padding(1);

                public Unknown_Block_7_Unknown_Block_5()
                {
                    base.Add(this.unknown);
                }
            }
        }

        public class Object_Fake_Lightprobes : TagBlockLayout
        {
            public static readonly SBSP.Object_Fake_Lightprobes Layout = new SBSP.Object_Fake_Lightprobes();
            public Padding padding1 = new Padding(0x5c);

            public Object_Fake_Lightprobes()
            {
                base.Add(this.padding1);
            }
        }

        public class Transparent_Planes : TagBlockLayout
        {
            public static readonly SBSP.Transparent_Planes Layout = new SBSP.Transparent_Planes();
            public Padding unknown = new Padding(20);

            public Transparent_Planes()
            {
                base.Add(this.unknown);
            }
        }

        public class Fog_Planes : TagBlockLayout
        {
            public static readonly SBSP.Fog_Planes Layout = new SBSP.Fog_Planes();
            public Padding unknown = new Padding("unknown", 0x18);

            public Fog_Planes()
            {
                base.Add(this.unknown);
            }
        }

        public class Decorators : TagBlockLayout
        {
            public static readonly SBSP.Decorators Layout = new SBSP.Decorators();
            public TagBlock raw_data_block = new TagBlock("Raw Data Tag Block", Raw_Data_Tag_Block.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock unknown_block = new TagBlock("unknown_Tag_Block1", unknown_Tag_Block1.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock unknown_block_2 = new TagBlock("unknown_Tag_Block2", unknown_Tag_Block2.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock unknown_block3 = new TagBlock("unknown_Tag_Block3", unknown_Tag_Block3.Layout, Map.HaloVersionEnum.Halo2);
            public RealFloat unknown1 = new RealFloat("unknown");
            public RealFloat unknown2 = new RealFloat("unknown");
            public RealFloat unknown3 = new RealFloat("unknown");
            public LongInteger unknown4 = new LongInteger("unknown");

            public Decorators()
            {
                base.Add(this.unknown1);
                base.Add(this.unknown2);
                base.Add(this.unknown3);
                base.Add(this.unknown4);
                base.Add(this.raw_data_block);
                base.Add(this.unknown_block_2);
                base.Add(this.unknown_block);
                base.Add(this.unknown_block3);
            }

            public class Raw_Data_Tag_Block : TagBlockLayout
            {
                public static readonly SBSP.Decorators.Raw_Data_Tag_Block Layout = new SBSP.Decorators.Raw_Data_Tag_Block();
                public Padding padding1 = new Padding(8);
                public Raw_Tag_Block rawdata = new Raw_Tag_Block("Raw Data", Map.HaloVersionEnum.Halo2, Data.RawDataTypes.H2_sbsp_visualmesh, new TagBlockLayout());

                public Raw_Data_Tag_Block()
                {
                    base.Add(this.rawdata);
                    base.Add(this.padding1);
                }
            }

            public class unknown_Tag_Block1 : TagBlockLayout
            {
                public static readonly SBSP.Decorators.unknown_Tag_Block1 Layout = new SBSP.Decorators.unknown_Tag_Block1();
                public Padding padding1 = new Padding(0x18);

                public unknown_Tag_Block1()
                {
                    base.Add(this.padding1);
                }
            }

            public class unknown_Tag_Block2 : TagBlockLayout
            {
                public static readonly SBSP.Decorators.unknown_Tag_Block2 Layout = new SBSP.Decorators.unknown_Tag_Block2();
                public Padding padding1 = new Padding(0x18);

                public unknown_Tag_Block2()
                {
                    base.Add(this.padding1);
                }
            }

            public class unknown_Tag_Block3 : TagBlockLayout
            {
                public static readonly SBSP.Decorators.unknown_Tag_Block3 Layout = new SBSP.Decorators.unknown_Tag_Block3();
                public Padding padding1 = new Padding(0x40);

                public unknown_Tag_Block3()
                {
                    base.Add(this.padding1);
                }
            }
        }

        public class Runtime_Decals : TagBlockLayout
        {
            public static readonly SBSP.Runtime_Decals Layout = new SBSP.Runtime_Decals();
            public Padding unknown = new Padding(0x10);

            public Runtime_Decals()
            {
                base.Add(this.unknown);
            }
        }

        public class Environment_Object_Palette : TagBlockLayout
        {
            public TagReference ident = new TagReference("Scenery", Map.HaloVersionEnum.Halo2);
            public TagReference ident2 = new TagReference("Model", Map.HaloVersionEnum.Halo2);
            public static readonly SBSP.Environment_Object_Palette Layout = new SBSP.Environment_Object_Palette();
            public Padding padding1 = new Padding(4);

            public Environment_Object_Palette()
            {
                base.Add(this.ident);
                base.Add(this.ident2);
                base.Add(this.padding1);
            }
        }

        public class Environment_Objects : TagBlockLayout
        {
            public static readonly SBSP.Environment_Objects Layout = new SBSP.Environment_Objects();
            public Padding padding1 = new Padding(0x68);

            public Environment_Objects()
            {
                base.Add(this.padding1);
            }
        }

        public class Materials : TagBlockLayout
        {
            public static readonly SBSP.Materials Layout = new SBSP.Materials();
            public Padding padding = new Padding(4);
            public TagReference shader = new TagReference("Shader", Map.HaloVersionEnum.Halo2);
            public TagBlock unknown_visual_shader_block = new TagBlock("Unknown_Visual_Shader_Block", Unknown_Visual_Shader_Block.Layout, Map.HaloVersionEnum.Halo2);
            public ByteInteger unknown1 = new ByteInteger("unknown");
            public Padding unknown2 = new Padding(3);
            public TagReference unused = new TagReference("unused", Map.HaloVersionEnum.Halo2);

            public Materials()
            {
                base.Add(this.unused);
                base.Add(this.shader);
                base.Add(this.unknown_visual_shader_block);
                base.Add(this.padding);
                base.Add(this.unknown1);
                base.Add(this.unknown2);
            }

            public class Unknown_Visual_Shader_Block : TagBlockLayout
            {
                public static readonly SBSP.Materials.Unknown_Visual_Shader_Block Layout = new SBSP.Materials.Unknown_Visual_Shader_Block();
                public Padding padding1 = new Padding(8);

                public Unknown_Visual_Shader_Block()
                {
                    base.Add(this.padding1);
                }
            }
        }

        public class Weather_Palette_Layout : TagBlockLayout
        {
            public static readonly SBSP.Weather_Palette_Layout Layout = new SBSP.Weather_Palette_Layout();
            public core.TagInterface.String type = new core.TagInterface.String("Type?", 0x20);
            public Padding unknown = new Padding("unknown", 0x24);
            public Padding unknown2 = new Padding("unknown", 0x34);
            public TagReference weather = new TagReference("Weather", Map.HaloVersionEnum.Halo2);
            public TagReference wind = new TagReference("Wind", Map.HaloVersionEnum.Halo2);

            public Weather_Palette_Layout()
            {
                base.Add(this.type);
                base.Add(this.weather);
                base.Add(this.unknown);
                base.Add(this.wind);
                base.Add(this.unknown2);
            }
        }

        public class Weather_Polyhedral_Layout : TagBlockLayout
        {
            public static readonly SBSP.Weather_Polyhedral_Layout Layout = new SBSP.Weather_Polyhedral_Layout();
            public RealPoint3D position = new RealPoint3D("Position");
            public RealFloat radius = new RealFloat("Radius");
            public TagBlock vertices = new TagBlock("Weather_Polyhedral_Vertices", Weather_Polyhedral_Vertice.Layout, Map.HaloVersionEnum.Halo2);

            public Weather_Polyhedral_Layout()
            {
                base.Add(this.position);
                base.Add(this.radius);
                base.Add(this.vertices);
            }

            public class Weather_Polyhedral_Vertice : TagBlockLayout
            {
                public static readonly SBSP.Weather_Polyhedral_Layout.Weather_Polyhedral_Vertice Layout = new SBSP.Weather_Polyhedral_Layout.Weather_Polyhedral_Vertice();
                public RealPlane3D plane = new RealPlane3D("Position");

                public Weather_Polyhedral_Vertice()
                {
                    base.Add(this.plane);
                }
            }
        }
    }
}

