﻿namespace core.H2
{
    using core;
    using core.TagInterface;
    using System;
    using System.Collections.Generic;

    public class Sound_Resource_Layout : TagBlockLayout
    {
        public static readonly Sound_Resource_Layout Layout = new Sound_Resource_Layout();
        public TagBlock Sound_Choices = new TagBlock("Sound Choices", ugh_.Sound_Choices44_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Sound_Names = new TagBlock("Sound Names", ugh_.Sound_Names25_Layout.Layout, Map.HaloVersionEnum.Halo2, 4);
        public TagBlock Sound_Permutations = new TagBlock("Sound Permutations", ugh_.Sound_Permutations35_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Sound_Raw_Data = new TagBlock("Sound Raw Data", ugh_.Sound_Raw_Data68_Layout.Layout, Map.HaloVersionEnum.Halo2, 4);
        public TagBlock Sound_unknown4thblock = new TagBlock("unknown4thblock", ugh_.Unknown28_Layout.Layout, Map.HaloVersionEnum.Halo2, 4);

        public Sound_Resource_Layout()
        {
            base.Add(this.Sound_Permutations);
            base.Add(this.Sound_Choices);
            base.Add(this.Sound_Raw_Data);
            base.Add(this.Sound_Names);
            base.Add(this.Sound_unknown4thblock);
        }

        public void LoadSoundDataFromUgh(Map map, snd_ snd, ugh_ ugh)
        {
            List<int> list = new List<int>();
            for (int i = 0; i < snd.Chunk_Count.Value; i++)
            {
                ugh_.Sound_Permutations35_Layout tagblocklayout = (ugh_.Sound_Permutations35_Layout) ugh.Sound_Permutations35.Chunks[snd.Index_to_5th.Value + i].Clone();
                int chunkCount = this.Sound_Choices.ChunkCount;
                if (tagblocklayout.indexto4thblock1.Value != -1)
                {
                    int index = list.IndexOf(tagblocklayout.indexto4thblock1.Value);
                    if (index == -1)
                    {
                        this.Sound_unknown4thblock.AddChunk(ugh.Unknown28.Chunks[tagblocklayout.indexto4thblock1.Value]);
                        list.Add(tagblocklayout.indexto4thblock1.Value);
                        tagblocklayout.indexto4thblock1.Value = (short) (list.Count - 1);
                    }
                    else
                    {
                        tagblocklayout.indexto4thblock1.Value = (short) index;
                    }
                }
                if (tagblocklayout.indexto4thblock2.Value != -1)
                {
                }
                if (tagblocklayout.indexto4thblock3.Value != -1)
                {
                }
                for (int j = 0; j < tagblocklayout.chunkCount.Value; j++)
                {
                    ugh_.Sound_Choices44_Layout layout2 = (ugh_.Sound_Choices44_Layout) ugh.Sound_Choices44.Chunks[tagblocklayout.Index.Value + j].Clone();
                    ugh_.Sound_Names25_Layout layout3 = (ugh_.Sound_Names25_Layout) ugh.Sound_Names25.Chunks[layout2.Name_Index.Value];
                    this.Sound_Names.AddChunk(layout3);
                    layout2.Name_Index.Value = (short) (this.Sound_Names.ChunkCount - 1);
                    int num5 = this.Sound_Raw_Data.ChunkCount;
                    for (int k = 0; k < layout2.chunkCount.Value; k++)
                    {
                        ugh_.Sound_Raw_Data68_Layout layout4 = (ugh_.Sound_Raw_Data68_Layout) ugh.Sound_Raw_Data68.Chunks[layout2.Index.Value + k].Clone();
                        Sound_Raw raw = layout4.Sound_Raw;
                        switch (raw.Raw_Offset.Map_Location)
                        {
                            case MapTypes.Internal:
                                map.io.In.SeekTo(raw.Raw_Offset.Data_Offset);
                                raw.Read_Raw(ref map.io.In);
                                break;

                            case MapTypes.MainMenu:
                                ProgramSettings.Main_Menu_IO.In.SeekTo(raw.Raw_Offset.Data_Offset);
                                raw.Read_Raw(ref ProgramSettings.Main_Menu_IO.In);
                                break;

                            case MapTypes.SPShared:
                                ProgramSettings.SP_Shared_IO.In.SeekTo(raw.Raw_Offset.Data_Offset);
                                raw.Read_Raw(ref ProgramSettings.SP_Shared_IO.In);
                                break;

                            case MapTypes.MPShared:
                                ProgramSettings.MP_Shared_IO.In.SeekTo(raw.Raw_Offset.Data_Offset);
                                raw.Read_Raw(ref ProgramSettings.MP_Shared_IO.In);
                                break;
                        }
                        this.Sound_Raw_Data.AddChunk(layout4);
                    }
                    layout2.Index.Value = (short) num5;
                    this.Sound_Choices.AddChunk(layout2);
                }
                tagblocklayout.Index.Value = (short) chunkCount;
                this.Sound_Permutations.AddChunk(tagblocklayout);
            }
        }
    }
}

