﻿namespace core.H2
{
    using core.TagInterface;
    using System;

    public class bitm : TagBlockLayout
    {
        public RealFloat Alpha_Bias = new RealFloat("Alpha Bias");
        public TagBlock Bitmap_Data = new TagBlock("Bitmap Data", Bitmap_Data_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public RealFloat Blur_Filter_Size = new RealFloat("Blur Filter Size");
        public RealFloat Bump_Height = new RealFloat("Bump Height");
        public ShortInteger Colour_Plate_Height = new ShortInteger("Colour Plate Height");
        public ShortInteger Colour_Plate_Width = new ShortInteger("Colour Plate Width");
        public LongInteger Compressed_Colour_Plate_Data = new LongInteger("Compressed Colour Plate Data");
        public RealFloat Detail_Fade_Factor = new RealFloat("Detail Fade Factor");
        public core.TagInterface.Enumerator Format = new core.TagInterface.Enumerator("Format", core.TagInterface.Enumerator.TagEnumeratorIndexType.Word);
        public core.TagInterface.Flags Format_0 = new core.TagInterface.Flags("Format", core.TagInterface.Flags.BitmaskTypeEnum.Word);
        public static readonly bitm Layout = new bitm();
        public ShortInteger MipMap_Count = new ShortInteger("MipMap Count");
        public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 12);
        public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 2);
        public RealFloat Sharpen_Amount = new RealFloat("Sharpen Amount");
        public ShortInteger Sprite_Budget_Count = new ShortInteger("Sprite Budget Count");
        public core.TagInterface.Enumerator Sprite_Budget_Size = new core.TagInterface.Enumerator("Sprite Budget Size", core.TagInterface.Enumerator.TagEnumeratorIndexType.Word);
        public ShortInteger Sprite_Spacing = new ShortInteger("Sprite Spacing");
        public ShortInteger Sprite_Usage = new ShortInteger("Sprite Usage");
        public TagBlock Squences = new TagBlock("Squences", Squences_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public core.TagInterface.Enumerator Type = new core.TagInterface.Enumerator("Type", core.TagInterface.Enumerator.TagEnumeratorIndexType.Word);
        public core.TagInterface.Enumerator Usage = new core.TagInterface.Enumerator("Usage", core.TagInterface.Enumerator.TagEnumeratorIndexType.Word);

        public bitm()
        {
            base.Add(this.Type);
            base.Add(this.Format);
            base.Add(this.Usage);
            base.Add(this.Format_0);
            base.Add(this.Detail_Fade_Factor);
            base.Add(this.Sharpen_Amount);
            base.Add(this.Bump_Height);
            base.Add(this.Sprite_Budget_Size);
            base.Add(this.Sprite_Budget_Count);
            base.Add(this.Colour_Plate_Width);
            base.Add(this.Colour_Plate_Height);
            base.Add(this.Compressed_Colour_Plate_Data);
            base.Add(this.Padding);
            base.Add(this.Blur_Filter_Size);
            base.Add(this.Alpha_Bias);
            base.Add(this.MipMap_Count);
            base.Add(this.Sprite_Usage);
            base.Add(this.Sprite_Spacing);
            base.Add(this.Padding_0);
            base.Add(this.Squences);
            base.Add(this.Bitmap_Data);
        }

        public class Bitmap_Data_Layout : TagBlockLayout
        {
            public ShortInteger Depth = new ShortInteger("Depth");
            public core.TagInterface.Flags Flags = new core.TagInterface.Flags("Flags", core.TagInterface.Flags.BitmaskTypeEnum.Word);
            public core.TagInterface.Flags Flags_CBZ_ = new core.TagInterface.Flags("Flags(CBZ)", core.TagInterface.Flags.BitmaskTypeEnum.Long);
            public ShortInteger Format = new ShortInteger("Format");
            public ShortInteger Height = new ShortInteger("Height");
            public TagIdent ID = new TagIdent("ID");
            public static readonly bitm.Bitmap_Data_Layout Layout = new bitm.Bitmap_Data_Layout();
            public ShortInteger MipMap_Count = new ShortInteger("MipMap Count");
            public Padding Padding_1 = new Padding("Padding", 8);
            public Padding Padding_2 = new Padding("Padding", 4);
            public Padding Padding_3 = new Padding("Padding", 4);
            public ShortInteger PixelOffset = new ShortInteger("PixelOffset");
            public Bitmap_Raw rawdata = new Bitmap_Raw("Bitmap Raw");
            public ShortInteger Reg_X = new ShortInteger("Reg X");
            public ShortInteger Reg_Y = new ShortInteger("Reg Y");
            public HaloTagType Tag = new HaloTagType("Tag");
            public ShortInteger Type = new ShortInteger("Type");
            public LongInteger Unknown_CBZ_ = new LongInteger("Unknown(CBZ)");
            public LongInteger Unknown_CBZ__0 = new LongInteger("Unknown(CBZ)");
            public LongInteger Unknown_CBZ__1 = new LongInteger("Unknown(CBZ)");
            public LongInteger Unknown_CBZ__2 = new LongInteger("Unknown(CBZ)");
            public ShortInteger Width = new ShortInteger("Width");
            public LongInteger Zero = new LongInteger("Zero");

            public Bitmap_Data_Layout()
            {
                base.Add(this.Tag);
                base.Add(this.Width);
                base.Add(this.Height);
                base.Add(this.Depth);
                base.Add(this.Type);
                base.Add(this.Format);
                base.Add(this.Flags);
                base.Add(this.Reg_X);
                base.Add(this.Reg_Y);
                base.Add(this.MipMap_Count);
                base.Add(this.PixelOffset);
                base.Add(this.Zero);
                base.Add(this.rawdata);
                base.Add(this.ID);
                base.Add(this.Padding_1);
                base.Add(this.Flags_CBZ_);
                base.Add(this.Padding_2);
                base.Add(this.Unknown_CBZ_);
                base.Add(this.Unknown_CBZ__0);
                base.Add(this.Unknown_CBZ__1);
                base.Add(this.Unknown_CBZ__2);
                base.Add(this.Padding_3);
            }

            public BitmapFormat Bitmap_Format
            {
                get
                {
                    return (BitmapFormat) this.Format.Value;
                }
            }

            public enum BitmapFormat
            {
                BITM_FORMAT_A1R5G5B5 = 8,
                BITM_FORMAT_A4R4G4B4 = 9,
                BITM_FORMAT_A8 = 0,
                BITM_FORMAT_A8R8G8B8 = 11,
                BITM_FORMAT_A8Y8 = 3,
                BITM_FORMAT_AY8 = 2,
                BITM_FORMAT_DXT1 = 14,
                BITM_FORMAT_DXT2AND3 = 15,
                BITM_FORMAT_DXT4AND5 = 0x10,
                BITM_FORMAT_P8 = 0x11,
                BITM_FORMAT_R5G6B5 = 6,
                BITM_FORMAT_X8R8G8B8 = 10,
                BITM_FORMAT_Y8 = 1,
                BITM_TYPE_2D = 0,
                BITM_TYPE_3D = 1,
                BITM_TYPE_CUBEMAP = 2,
                BITM_TYPE_LIGHTMAP = 0x12,
                BITM_TYPE_UNK = 0x16
            }
        }

        public enum BitmapUsage
        {
            Alpha_Blend = 0,
            Camo = 6,
            Default = 1,
            Height_Map = 2,
            Lightmap = 3,
            VectorMap = 4
        }

        public class Squences_Layout : TagBlockLayout
        {
            public ShortInteger Bitmap_Count = new ShortInteger("Bitmap Count");
            public ShortInteger First_Bitmap_Index = new ShortInteger("First Bitmap Index");
            public static readonly bitm.Squences_Layout Layout = new bitm.Squences_Layout();
            public core.TagInterface.String Name = new core.TagInterface.String("Name", 0x20);
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0x10);
            public TagBlock Sprites = new TagBlock("Sprites", Sprites_Layout.Layout, Map.HaloVersionEnum.Halo2);

            public Squences_Layout()
            {
                base.Add(this.Name);
                base.Add(this.First_Bitmap_Index);
                base.Add(this.Bitmap_Count);
                base.Add(this.Padding);
                base.Add(this.Sprites);
            }

            public class Sprites_Layout : TagBlockLayout
            {
                public LongInteger Bitmap_Index = new LongInteger("Bitmap Index");
                public RealFloat Bottom = new RealFloat("Bottom");
                public static readonly bitm.Squences_Layout.Sprites_Layout Layout = new bitm.Squences_Layout.Sprites_Layout();
                public RealFloat Left = new RealFloat("Left");
                public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
                public RealFloat Reg_Point_X = new RealFloat("Reg Point X");
                public RealFloat Reg_Point_Y = new RealFloat("Reg Point Y");
                public RealFloat Right = new RealFloat("Right");
                public RealFloat Top = new RealFloat("Top");

                public Sprites_Layout()
                {
                    base.Add(this.Bitmap_Index);
                    base.Add(this.Padding);
                    base.Add(this.Left);
                    base.Add(this.Right);
                    base.Add(this.Top);
                    base.Add(this.Bottom);
                    base.Add(this.Reg_Point_X);
                    base.Add(this.Reg_Point_Y);
                }
            }
        }
    }
}

