﻿namespace core.H2
{
    using core.TagInterface;
    using System;

    public class jmad : TagBlockLayout
    {
        public TagBlock Animation_Calls = new TagBlock("Animation Calls", Animation_Calls_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Animations = new TagBlock("Animations", Animations_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Bones = new TagBlock("Bones", Bones_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Effects = new TagBlock("Effects", Effects_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public static readonly jmad Layout = new jmad();
        public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0x18);
        public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 0x24);
        public TagBlock Sounds = new TagBlock("Sounds", Sounds_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public HaloTagType Unknown = new HaloTagType("Unknown");
        public TagIdent Unknown_0 = new TagIdent("Unknown");
        public LongInteger Unknown_1 = new LongInteger("Unknown");
        public LongInteger Unknown_10 = new LongInteger("Unknown");
        public TagBlock Unknown_11 = new TagBlock("Unknown", Unknown_11_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown_12 = new TagBlock("Unknown", Unknown_12_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown_2 = new TagBlock("Unknown", Unknown_2_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown_3 = new TagBlock("Unknown", Unknown_3_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown_4 = new TagBlock("Unknown", Unknown_4_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown_5 = new TagBlock("Unknown", Unknown_5_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public LongInteger Unknown_6 = new LongInteger("Unknown");
        public LongInteger Unknown_7 = new LongInteger("Unknown");
        public LongInteger Unknown_8 = new LongInteger("Unknown");
        public LongInteger Unknown_9 = new LongInteger("Unknown");
        public TagBlock Weapon_Associations = new TagBlock("Weapon Associations", Weapon_Associations_Layout.Layout, Map.HaloVersionEnum.Halo2);

        public jmad()
        {
            base.Add(this.Unknown);
            base.Add(this.Unknown_0);
            base.Add(this.Unknown_1);
            base.Add(this.Bones);
            base.Add(this.Sounds);
            base.Add(this.Effects);
            base.Add(this.Unknown_2);
            base.Add(this.Animations);
            base.Add(this.Animation_Calls);
            base.Add(this.Unknown_3);
            base.Add(this.Unknown_4);
            base.Add(this.Unknown_5);
            base.Add(this.Weapon_Associations);
            base.Add(this.Unknown_6);
            base.Add(this.Unknown_7);
            base.Add(this.Padding);
            base.Add(this.Unknown_8);
            base.Add(this.Unknown_9);
            base.Add(this.Unknown_10);
            base.Add(this.Padding_0);
            base.Add(this.Unknown_11);
            base.Add(this.Unknown_12);
        }

        public class Animation_Calls_Layout : TagBlockLayout
        {
            public static readonly jmad.Animation_Calls_Layout Layout = new jmad.Animation_Calls_Layout();
            public TagBlock Limb_Positioning = new TagBlock("Limb Positioning", Limb_Positioning_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public StringID Pose_Name = new StringID("Pose Name");
            public TagBlock Weapon_Class = new TagBlock("Weapon Class", Weapon_Class_Layout.Layout, Map.HaloVersionEnum.Halo2);

            public Animation_Calls_Layout()
            {
                base.Add(this.Pose_Name);
                base.Add(this.Weapon_Class);
                base.Add(this.Limb_Positioning);
            }

            public class Limb_Positioning_Layout : TagBlockLayout
            {
                public static readonly jmad.Animation_Calls_Layout.Limb_Positioning_Layout Layout = new jmad.Animation_Calls_Layout.Limb_Positioning_Layout();
                public StringID Local_Marker = new StringID("Local Marker");
                public StringID Remote_Marker = new StringID("Remote Marker");

                public Limb_Positioning_Layout()
                {
                    base.Add(this.Local_Marker);
                    base.Add(this.Remote_Marker);
                }
            }

            public class Weapon_Class_Layout : TagBlockLayout
            {
                public StringID Class_Name = new StringID("Class Name");
                public static readonly jmad.Animation_Calls_Layout.Weapon_Class_Layout Layout = new jmad.Animation_Calls_Layout.Weapon_Class_Layout();
                public TagBlock Limb_Positioning = new TagBlock("Limb Positioning", Limb_Positioning_Layout.Layout, Map.HaloVersionEnum.Halo2);
                public TagBlock Weapon = new TagBlock("Weapon", Weapon_Layout.Layout, Map.HaloVersionEnum.Halo2);

                public Weapon_Class_Layout()
                {
                    base.Add(this.Class_Name);
                    base.Add(this.Weapon);
                    base.Add(this.Limb_Positioning);
                }

                public class Limb_Positioning_Layout : TagBlockLayout
                {
                    public static readonly jmad.Animation_Calls_Layout.Weapon_Class_Layout.Limb_Positioning_Layout Layout = new jmad.Animation_Calls_Layout.Weapon_Class_Layout.Limb_Positioning_Layout();
                    public StringID Local_Marker = new StringID("Local Marker");
                    public StringID Remote_Marker = new StringID("Remote Marker");

                    public Limb_Positioning_Layout()
                    {
                        base.Add(this.Local_Marker);
                        base.Add(this.Remote_Marker);
                    }
                }

                public class Weapon_Layout : TagBlockLayout
                {
                    public TagBlock AI = new TagBlock("AI", AI_Layout.Layout, Map.HaloVersionEnum.Halo2);
                    public TagBlock Death_Damage = new TagBlock("Death/Damage", Death_Damage_Layout.Layout, Map.HaloVersionEnum.Halo2);
                    public TagBlock Full_Body_Animations = new TagBlock("Full Body Animations", Full_Body_Animations_Layout.Layout, Map.HaloVersionEnum.Halo2);
                    public TagBlock Half_Upper_Body_Animations = new TagBlock("Half/Upper Body Animations", Half_Upper_Body_Animations_Layout.Layout, Map.HaloVersionEnum.Halo2);
                    public static readonly jmad.Animation_Calls_Layout.Weapon_Class_Layout.Weapon_Layout Layout = new jmad.Animation_Calls_Layout.Weapon_Class_Layout.Weapon_Layout();
                    public TagBlock Unknown = new TagBlock("Unknown", Unknown_Layout.Layout, Map.HaloVersionEnum.Halo2);
                    public TagBlock Unknown_0 = new TagBlock("Unknown", Unknown_0_Layout.Layout, Map.HaloVersionEnum.Halo2);
                    public StringID Weapon_Short = new StringID("Weapon Short");

                    public Weapon_Layout()
                    {
                        base.Add(this.Weapon_Short);
                        base.Add(this.Full_Body_Animations);
                        base.Add(this.Half_Upper_Body_Animations);
                        base.Add(this.Death_Damage);
                        base.Add(this.AI);
                        base.Add(this.Unknown);
                        base.Add(this.Unknown_0);
                    }

                    public class AI_Layout : TagBlockLayout
                    {
                        public StringID Currently_Performing = new StringID("Currently Performing");
                        public StringID Currently_Performing_0 = new StringID("Currently Performing");
                        public static readonly jmad.Animation_Calls_Layout.Weapon_Class_Layout.Weapon_Layout.AI_Layout Layout = new jmad.Animation_Calls_Layout.Weapon_Class_Layout.Weapon_Layout.AI_Layout();
                        public TagBlock Options = new TagBlock("Options", Options_Layout.Layout, Map.HaloVersionEnum.Halo2);
                        public RealFloat Unknown = new RealFloat("Unknown");

                        public AI_Layout()
                        {
                            base.Add(this.Currently_Performing);
                            base.Add(this.Currently_Performing_0);
                            base.Add(this.Unknown);
                            base.Add(this.Options);
                        }

                        public class Options_Layout : TagBlockLayout
                        {
                            public StringID Animation_Name = new StringID("Animation Name");
                            public ShortInteger Chunk__Number_ = new ShortInteger("Chunk #");
                            public StringID Full_Name = new StringID("Full Name");
                            public static readonly jmad.Animation_Calls_Layout.Weapon_Class_Layout.Weapon_Layout.AI_Layout.Options_Layout Layout = new jmad.Animation_Calls_Layout.Weapon_Class_Layout.Weapon_Layout.AI_Layout.Options_Layout();
                            public StringID State_Name = new StringID("State Name");
                            public RealFloat Unknown = new RealFloat("Unknown");
                            public ShortInteger Unknown_0 = new ShortInteger("Unknown");

                            public Options_Layout()
                            {
                                base.Add(this.Full_Name);
                                base.Add(this.State_Name);
                                base.Add(this.Animation_Name);
                                base.Add(this.Unknown);
                                base.Add(this.Unknown_0);
                                base.Add(this.Chunk__Number_);
                            }
                        }
                    }

                    public class Death_Damage_Layout : TagBlockLayout
                    {
                        public StringID Condition = new StringID("Condition");
                        public static readonly jmad.Animation_Calls_Layout.Weapon_Class_Layout.Weapon_Layout.Death_Damage_Layout Layout = new jmad.Animation_Calls_Layout.Weapon_Class_Layout.Weapon_Layout.Death_Damage_Layout();
                        public TagBlock Values = new TagBlock("Values", Values_Layout.Layout, Map.HaloVersionEnum.Halo2);

                        public Death_Damage_Layout()
                        {
                            base.Add(this.Condition);
                            base.Add(this.Values);
                        }

                        public class Values_Layout : TagBlockLayout
                        {
                            public static readonly jmad.Animation_Calls_Layout.Weapon_Class_Layout.Weapon_Layout.Death_Damage_Layout.Values_Layout Layout = new jmad.Animation_Calls_Layout.Weapon_Class_Layout.Weapon_Layout.Death_Damage_Layout.Values_Layout();
                            public TagBlock Values = new TagBlock("Valuesx", Valuesx_Layout.Layout, Map.HaloVersionEnum.Halo2);

                            public Values_Layout()
                            {
                                base.Add(this.Values);
                            }

                            public class Valuesx_Layout : TagBlockLayout
                            {
                                public ShortInteger Chunk__Number_ = new ShortInteger("Chunk #");
                                public static readonly jmad.Animation_Calls_Layout.Weapon_Class_Layout.Weapon_Layout.Death_Damage_Layout.Values_Layout.Valuesx_Layout Layout = new jmad.Animation_Calls_Layout.Weapon_Class_Layout.Weapon_Layout.Death_Damage_Layout.Values_Layout.Valuesx_Layout();
                                public ShortInteger Unknown = new ShortInteger("Unknown");

                                public Valuesx_Layout()
                                {
                                    base.Add(this.Unknown);
                                    base.Add(this.Chunk__Number_);
                                }
                            }
                        }
                    }

                    public class Full_Body_Animations_Layout : TagBlockLayout
                    {
                        public StringID Condition = new StringID("Condition");
                        public static readonly jmad.Animation_Calls_Layout.Weapon_Class_Layout.Weapon_Layout.Full_Body_Animations_Layout Layout = new jmad.Animation_Calls_Layout.Weapon_Class_Layout.Weapon_Layout.Full_Body_Animations_Layout();
                        public ShortInteger Reflexive_5_Chunk__Number_ = new ShortInteger("Reflexive 5 Chunk #");
                        public ShortInteger Unknown = new ShortInteger("Unknown");

                        public Full_Body_Animations_Layout()
                        {
                            base.Add(this.Condition);
                            base.Add(this.Unknown);
                            base.Add(this.Reflexive_5_Chunk__Number_);
                        }
                    }

                    public class Half_Upper_Body_Animations_Layout : TagBlockLayout
                    {
                        public StringID Condition = new StringID("Condition");
                        public static readonly jmad.Animation_Calls_Layout.Weapon_Class_Layout.Weapon_Layout.Half_Upper_Body_Animations_Layout Layout = new jmad.Animation_Calls_Layout.Weapon_Class_Layout.Weapon_Layout.Half_Upper_Body_Animations_Layout();
                        public ShortInteger Reflexive_5_Chunk__Number_ = new ShortInteger("Reflexive 5 Chunk #");
                        public ShortInteger Unknown = new ShortInteger("Unknown");

                        public Half_Upper_Body_Animations_Layout()
                        {
                            base.Add(this.Condition);
                            base.Add(this.Unknown);
                            base.Add(this.Reflexive_5_Chunk__Number_);
                        }
                    }

                    public class Unknown_0_Layout : TagBlockLayout
                    {
                        public static readonly jmad.Animation_Calls_Layout.Weapon_Class_Layout.Weapon_Layout.Unknown_0_Layout Layout = new jmad.Animation_Calls_Layout.Weapon_Class_Layout.Weapon_Layout.Unknown_0_Layout();
                        public LongInteger Unknown = new LongInteger("Unknown");

                        public Unknown_0_Layout()
                        {
                            base.Add(this.Unknown);
                        }
                    }

                    public class Unknown_Layout : TagBlockLayout
                    {
                        public static readonly jmad.Animation_Calls_Layout.Weapon_Class_Layout.Weapon_Layout.Unknown_Layout Layout = new jmad.Animation_Calls_Layout.Weapon_Class_Layout.Weapon_Layout.Unknown_Layout();
                        public LongInteger Unknown = new LongInteger("Unknown");

                        public Unknown_Layout()
                        {
                            base.Add(this.Unknown);
                        }
                    }
                }
            }
        }

        public class Animations_Layout : TagBlockLayout
        {
            public ByteInteger _Number__of_Bones = new ByteInteger("# of Bones");
            public ShortInteger Animation_Raw_Something = new ShortInteger("Animation Raw Something");
            public ShortInteger Animation_Raw_Something_0 = new ShortInteger("Animation Raw Something");
            public core.TagInterface.Flags Doesnt_Repeat = new core.TagInterface.Flags("Doesn't Repeat", core.TagInterface.Flags.BitmaskTypeEnum.Word);
            public TagBlock Effects = new TagBlock("Effects", Effects_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public static readonly jmad.Animations_Layout Layout = new jmad.Animations_Layout();
            public ShortInteger Max_Cycle_Length__milliseconds_ = new ShortInteger("Max Cycle Length (milliseconds)");
            public StringID Name = new StringID("Name");
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 8);
            public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 4);
            public TagBlock Sounds = new TagBlock("Sounds", Sounds_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public ShortInteger Transition_Speed_Question_Mark_ = new ShortInteger("Transition Speed?");
            public LongInteger Unknown = new LongInteger("Unknown");
            public ShortInteger Unknown__Do_not_Change_ = new ShortInteger("Unknown (Do not Change)");
            public ByteInteger Unknown_0 = new ByteInteger("Unknown");
            public ByteInteger Unknown_1 = new ByteInteger("Unknown");
            public LongInteger Unknown_10 = new LongInteger("Unknown");
            public ShortInteger Unknown_11 = new ShortInteger("Unknown");
            public ShortInteger Unknown_12 = new ShortInteger("Unknown");
            public ShortInteger Unknown_13 = new ShortInteger("Unknown");
            public ByteInteger Unknown_14 = new ByteInteger("Unknown");
            public ByteInteger Unknown_15 = new ByteInteger("Unknown");
            public ByteInteger Unknown_16 = new ByteInteger("Unknown");
            public ByteInteger Unknown_17 = new ByteInteger("Unknown");
            public ShortInteger Unknown_18 = new ShortInteger("Unknown");
            public ByteInteger Unknown_19 = new ByteInteger("Unknown");
            public ShortInteger Unknown_2 = new ShortInteger("Unknown");
            public ByteInteger Unknown_20 = new ByteInteger("Unknown");
            public ShortInteger Unknown_21 = new ShortInteger("Unknown");
            public TagBlock Unknown_22 = new TagBlock("Unknown", Unknown_22_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unknown_23 = new TagBlock("Unknown", Unknown_23_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public ByteInteger Unknown_3 = new ByteInteger("Unknown");
            public ByteInteger Unknown_4 = new ByteInteger("Unknown");
            public ShortInteger Unknown_5 = new ShortInteger("Unknown");
            public ShortInteger Unknown_6 = new ShortInteger("Unknown");
            public ByteInteger Unknown_7 = new ByteInteger("Unknown");
            public ShortInteger Unknown_8 = new ShortInteger("Unknown");
            public RealFloat Unknown_9 = new RealFloat("Unknown");
            public ShortInteger Unused = new ShortInteger("Unused");

            public Animations_Layout()
            {
                base.Add(this.Name);
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
                base.Add(this.Unknown_7);
                base.Add(this._Number__of_Bones);
                base.Add(this.Max_Cycle_Length__milliseconds_);
                base.Add(this.Unknown__Do_not_Change_);
                base.Add(this.Transition_Speed_Question_Mark_);
                base.Add(this.Unknown_8);
                base.Add(this.Unknown_9);
                base.Add(this.Padding);
                base.Add(this.Unknown_10);
                base.Add(this.Animation_Raw_Something);
                base.Add(this.Unused);
                base.Add(this.Unknown_11);
                base.Add(this.Doesnt_Repeat);
                base.Add(this.Unknown_12);
                base.Add(this.Unknown_13);
                base.Add(this.Padding_0);
                base.Add(this.Unknown_14);
                base.Add(this.Unknown_15);
                base.Add(this.Unknown_16);
                base.Add(this.Unknown_17);
                base.Add(this.Unknown_18);
                base.Add(this.Animation_Raw_Something_0);
                base.Add(this.Padding_1);
                base.Add(this.Unknown_19);
                base.Add(this.Unknown_20);
                base.Add(this.Unknown_21);
                base.Add(this.Unknown_22);
                base.Add(this.Sounds);
                base.Add(this.Effects);
                base.Add(this.Unknown_23);
            }

            public class Effects_Layout : TagBlockLayout
            {
                public static readonly jmad.Animations_Layout.Effects_Layout Layout = new jmad.Animations_Layout.Effects_Layout();
                public ShortInteger Unknown = new ShortInteger("Unknown");
                public ShortInteger Unknown_0 = new ShortInteger("Unknown");

                public Effects_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                }
            }

            public class Sounds_Layout : TagBlockLayout
            {
                public ShortInteger Chunk__Number_ = new ShortInteger("Chunk #");
                public static readonly jmad.Animations_Layout.Sounds_Layout Layout = new jmad.Animations_Layout.Sounds_Layout();
                public ShortInteger Unknown = new ShortInteger("Unknown");
                public StringID Unknown_0 = new StringID("Unknown");

                public Sounds_Layout()
                {
                    base.Add(this.Chunk__Number_);
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                }
            }

            public class Unknown_22_Layout : TagBlockLayout
            {
                public static readonly jmad.Animations_Layout.Unknown_22_Layout Layout = new jmad.Animations_Layout.Unknown_22_Layout();
                public ShortInteger Unknown = new ShortInteger("Unknown");
                public ShortInteger Unknown_0 = new ShortInteger("Unknown");

                public Unknown_22_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                }
            }

            public class Unknown_23_Layout : TagBlockLayout
            {
                public static readonly jmad.Animations_Layout.Unknown_23_Layout Layout = new jmad.Animations_Layout.Unknown_23_Layout();
                public ShortInteger Unknown = new ShortInteger("Unknown");
                public ShortInteger Unknown_0 = new ShortInteger("Unknown");
                public LongInteger Unknown_1 = new LongInteger("Unknown");
                public LongInteger Unknown_2 = new LongInteger("Unknown");
                public RealFloat Unknown_3 = new RealFloat("Unknown");
                public RealFloat Unknown_4 = new RealFloat("Unknown");
                public RealFloat Unknown_5 = new RealFloat("Unknown");
                public RealFloat Unknown_6 = new RealFloat("Unknown");

                public Unknown_23_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                    base.Add(this.Unknown_1);
                    base.Add(this.Unknown_2);
                    base.Add(this.Unknown_3);
                    base.Add(this.Unknown_4);
                    base.Add(this.Unknown_5);
                    base.Add(this.Unknown_6);
                }
            }
        }

        public class Bones_Layout : TagBlockLayout
        {
            public static readonly jmad.Bones_Layout Layout = new jmad.Bones_Layout();
            public StringID Name = new StringID("Name");
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0x10);
            public ShortInteger Unknown = new ShortInteger("Unknown");
            public ShortInteger Unknown_0 = new ShortInteger("Unknown");
            public ShortInteger Unknown_1 = new ShortInteger("Unknown");
            public ShortInteger Unknown_2 = new ShortInteger("Unknown");
            public RealFloat Unknown_3 = new RealFloat("Unknown");

            public Bones_Layout()
            {
                base.Add(this.Name);
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Padding);
                base.Add(this.Unknown_3);
            }
        }

        public class Effects_Layout : TagBlockLayout
        {
            public HaloTagType Effect = new HaloTagType("Effect");
            public TagIdent Effect_0 = new TagIdent("Effect");
            public static readonly jmad.Effects_Layout Layout = new jmad.Effects_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);

            public Effects_Layout()
            {
                base.Add(this.Effect);
                base.Add(this.Effect_0);
                base.Add(this.Padding);
            }
        }

        public class Sounds_Layout : TagBlockLayout
        {
            public static readonly jmad.Sounds_Layout Layout = new jmad.Sounds_Layout();
            public HaloTagType Sound = new HaloTagType("Sound");
            public TagIdent Sound_0 = new TagIdent("Sound");
            public LongInteger Unknown = new LongInteger("Unknown");

            public Sounds_Layout()
            {
                base.Add(this.Sound);
                base.Add(this.Sound_0);
                base.Add(this.Unknown);
            }
        }

        public class Unknown_11_Layout : TagBlockLayout
        {
            public static readonly jmad.Unknown_11_Layout Layout = new jmad.Unknown_11_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public Animation_Raw Raw_Data = new Animation_Raw("Raw Data", Map.HaloVersionEnum.Halo2, Data.RawDataTypes.H2_jmad);
            public TagIdent Unknown = new TagIdent("Unknown");
            public LongInteger Unknown_0 = new LongInteger("Unknown");

            public Unknown_11_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Raw_Data);
                base.Add(this.Padding);
                base.Add(this.Unknown_0);
            }
        }

        public class Unknown_12_Layout : TagBlockLayout
        {
            public static readonly jmad.Unknown_12_Layout Layout = new jmad.Unknown_12_Layout();
            public LongInteger Unknown = new LongInteger("Unknown");
            public LongInteger Unknown_0 = new LongInteger("Unknown");
            public LongInteger Unknown_1 = new LongInteger("Unknown");
            public LongInteger Unknown_2 = new LongInteger("Unknown");
            public LongInteger Unknown_3 = new LongInteger("Unknown");
            public LongInteger Unknown_4 = new LongInteger("Unknown");

            public Unknown_12_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
            }
        }

        public class Unknown_2_Layout : TagBlockLayout
        {
            public static readonly jmad.Unknown_2_Layout Layout = new jmad.Unknown_2_Layout();
            public StringID Unknown = new StringID("Unknown");
            public RealFloat Unknown_0 = new RealFloat("Unknown");
            public RealFloat Unknown_1 = new RealFloat("Unknown");
            public ShortInteger Unknown_2 = new ShortInteger("Unknown");
            public ShortInteger Unknown_3 = new ShortInteger("Unknown");
            public RealFloat Unknown_4 = new RealFloat("Unknown");
            public RealFloat Unknown_5 = new RealFloat("Unknown");
            public ShortInteger Unknown_6 = new ShortInteger("Unknown");
            public ShortInteger Unknown_7 = new ShortInteger("Unknown");

            public Unknown_2_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
                base.Add(this.Unknown_7);
            }
        }

        public class Unknown_3_Layout : TagBlockLayout
        {
            public static readonly jmad.Unknown_3_Layout Layout = new jmad.Unknown_3_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public StringID Unknown = new StringID("Unknown");
            public LongInteger Unknown_0 = new LongInteger("Unknown");
            public StringID Unknown_1 = new StringID("Unknown");
            public RealFloat Unknown_2 = new RealFloat("Unknown");
            public RealFloat Unknown_3 = new RealFloat("Unknown");
            public RealFloat Unknown_4 = new RealFloat("Unknown");
            public StringID Unknown_5 = new StringID("Unknown");
            public RealFloat Unknown_6 = new RealFloat("Unknown");
            public RealFloat Unknown_7 = new RealFloat("Unknown");

            public Unknown_3_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_5);
                base.Add(this.Padding);
                base.Add(this.Unknown_6);
                base.Add(this.Unknown_7);
            }
        }

        public class Unknown_4_Layout : TagBlockLayout
        {
            public static readonly jmad.Unknown_4_Layout Layout = new jmad.Unknown_4_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 4);
            public StringID Unknown = new StringID("Unknown");
            public LongInteger Unknown_0 = new LongInteger("Unknown");
            public StringID Unknown_1 = new StringID("Unknown");

            public Unknown_4_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Padding);
                base.Add(this.Unknown_1);
                base.Add(this.Padding_0);
            }
        }

        public class Unknown_5_Layout : TagBlockLayout
        {
            public static readonly jmad.Unknown_5_Layout Layout = new jmad.Unknown_5_Layout();
            public HaloTagType Unknown = new HaloTagType("Unknown");
            public TagIdent Unknown_0 = new TagIdent("Unknown");
            public TagBlock Unknown_1 = new TagBlock("Unknown", Unknown_1_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unknown_2 = new TagBlock("Unknown", Unknown_2_Layout.Layout, Map.HaloVersionEnum.Halo2, 4);
            public RealFloat Unknown_3 = new RealFloat("Unknown");
            public LongInteger Unknown_4 = new LongInteger("Unknown");

            public Unknown_5_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
            }

            public class Unknown_1_Layout : TagBlockLayout
            {
                public static readonly jmad.Unknown_5_Layout.Unknown_1_Layout Layout = new jmad.Unknown_5_Layout.Unknown_1_Layout();
                public ShortInteger Unknown = new ShortInteger("Unknown");

                public Unknown_1_Layout()
                {
                    base.Add(this.Unknown);
                }
            }

            public class Unknown_2_Layout : TagBlockLayout
            {
                public static readonly jmad.Unknown_5_Layout.Unknown_2_Layout Layout = new jmad.Unknown_5_Layout.Unknown_2_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");

                public Unknown_2_Layout()
                {
                    base.Add(this.Unknown);
                }
            }
        }

        public class Weapon_Associations_Layout : TagBlockLayout
        {
            public StringID Class = new StringID("Class");
            public static readonly jmad.Weapon_Associations_Layout Layout = new jmad.Weapon_Associations_Layout();
            public StringID Short = new StringID("Short");

            public Weapon_Associations_Layout()
            {
                base.Add(this.Short);
                base.Add(this.Class);
            }
        }
    }
}

