﻿namespace core.H2
{
    using core.TagInterface;
    using System;

    public class ltmp : TagBlockLayout
    {
        public static readonly ltmp Layout = new ltmp();
        public Padding Padding_0 = new Padding("Padding", 0x80);
        public Padding Padding_1 = new Padding("Padding", 0x7c);
        public TagBlock Unknown17 = new TagBlock("Unknown17", Unknown17_Layout.Layout, Map.HaloVersionEnum.Halo2);

        public ltmp()
        {
            base.Add(this.Padding_0);
            base.Add(this.Unknown17);
            base.Add(this.Padding_1);
        }

        public class Unknown17_Layout : TagBlockLayout
        {
            public TagBlock BSP_Mesh_Palettes = new TagBlock("BSP Mesh Palettes", BSP_Mesh_Palettes_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock BSP_Mesh_Unknown = new TagBlock("BSP Mesh Unknown", BSP_Mesh_Unknown_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock BSP_Scenery_Palettes = new TagBlock("BSP Scenery Palettes", BSP_Scenery_Palettes_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock BSP_Scenery_Unknown = new TagBlock("BSP Scenery Unknown", BSP_Scenery_Unknown_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public static readonly ltmp.Unknown17_Layout Layout = new ltmp.Unknown17_Layout();
            public TagIdent lightmap_bitmap = new TagIdent("lightmap_bitmap");
            public TagBlock Lightmap_Palette = new TagBlock("Lightmap Palette", Lightmap_Palette_Layout.Layout, Map.HaloVersionEnum.Halo2, 0x40);
            public TagBlock lightmap_raw = new TagBlock("Lightmap Raw", Lightmap_Raw_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 8);
            public LongInteger Unknown = new LongInteger("Unknown");
            public LongInteger Unknown_0 = new LongInteger("Unknown");
            public HaloTagType Unknown_1 = new HaloTagType("Unknown");
            public TagBlock Unknown322 = new TagBlock("Unknown322", Unknown322_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unknown396 = new TagBlock("Unknown396", Unknown396_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unknown402 = new TagBlock("Unknown402", Unknown402_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unknown407 = new TagBlock("Unknown407", Unknown407_Layout.Layout, Map.HaloVersionEnum.Halo2);

            public Unknown17_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Lightmap_Palette);
                base.Add(this.Padding);
                base.Add(this.Unknown_1);
                base.Add(this.lightmap_bitmap);
                base.Add(this.BSP_Mesh_Unknown);
                base.Add(this.BSP_Mesh_Palettes);
                base.Add(this.BSP_Scenery_Unknown);
                base.Add(this.Unknown322);
                base.Add(this.lightmap_raw);
                base.Add(this.BSP_Scenery_Palettes);
                base.Add(this.Unknown396);
                base.Add(this.Unknown402);
                base.Add(this.Unknown407);
            }

            public class BSP_Mesh_Palettes_Layout : TagBlockLayout
            {
                public static readonly ltmp.Unknown17_Layout.BSP_Mesh_Palettes_Layout Layout = new ltmp.Unknown17_Layout.BSP_Mesh_Palettes_Layout();
                public ShortInteger Palette_Index = new ShortInteger("Palette Index");
                public ShortInteger Unknown = new ShortInteger("Unknown");

                public BSP_Mesh_Palettes_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Palette_Index);
                }
            }

            public class BSP_Mesh_Unknown_Layout : TagBlockLayout
            {
                public LongInteger Cluster_Raw_Header_Size = new LongInteger("Cluster Raw Header Size");
                public static readonly ltmp.Unknown17_Layout.BSP_Mesh_Unknown_Layout Layout = new ltmp.Unknown17_Layout.BSP_Mesh_Unknown_Layout();
                public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
                public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 4);
                public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 8);
                public core.TagInterface.Padding Padding_2 = new core.TagInterface.Padding("Padding", 4);
                public core.TagInterface.Padding Padding_3 = new core.TagInterface.Padding("Padding", 4);
                public core.TagInterface.Padding Padding_4 = new core.TagInterface.Padding("Padding", 4);
                public core.TagInterface.Padding Padding_5 = new core.TagInterface.Padding("Padding", 8);
                public LongInteger Size_Without_Header = new LongInteger("Size Without Header");
                public ShortInteger Unknown = new ShortInteger("Unknown");
                public ShortInteger Unknown_0 = new ShortInteger("Unknown");
                public ShortInteger Unknown_1 = new ShortInteger("Unknown");
                public ShortInteger Unknown_10 = new ShortInteger("Unknown");
                public ShortInteger Unknown_11 = new ShortInteger("Unknown");
                public ShortInteger Unknown_12 = new ShortInteger("Unknown");
                public ShortInteger Unknown_13 = new ShortInteger("Unknown");
                public ShortInteger Unknown_14 = new ShortInteger("Unknown");
                public ShortInteger Unknown_15 = new ShortInteger("Unknown");
                public ShortInteger Unknown_16 = new ShortInteger("Unknown");
                public ShortInteger Unknown_17 = new ShortInteger("Unknown");
                public ShortInteger Unknown_18 = new ShortInteger("Unknown");
                public ShortInteger Unknown_2 = new ShortInteger("Unknown");
                public ShortInteger Unknown_3 = new ShortInteger("Unknown");
                public ShortInteger Unknown_4 = new ShortInteger("Unknown");
                public ShortInteger Unknown_5 = new ShortInteger("Unknown");
                public ShortInteger Unknown_6 = new ShortInteger("Unknown");
                public ShortInteger Unknown_7 = new ShortInteger("Unknown");
                public ShortInteger Unknown_8 = new ShortInteger("Unknown");
                public ShortInteger Unknown_9 = new ShortInteger("Unknown");

                public BSP_Mesh_Unknown_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                    base.Add(this.Unknown_1);
                    base.Add(this.Unknown_2);
                    base.Add(this.Unknown_3);
                    base.Add(this.Unknown_4);
                    base.Add(this.Unknown_5);
                    base.Add(this.Unknown_6);
                    base.Add(this.Unknown_7);
                    base.Add(this.Unknown_8);
                    base.Add(this.Unknown_9);
                    base.Add(this.Unknown_10);
                    base.Add(this.Unknown_11);
                    base.Add(this.Unknown_12);
                    base.Add(this.Unknown_13);
                    base.Add(this.Unknown_14);
                    base.Add(this.Unknown_15);
                    base.Add(this.Unknown_16);
                    base.Add(this.Unknown_17);
                    base.Add(this.Unknown_18);
                    base.Add(this.Padding);
                    base.Add(this.Padding_0);
                    base.Add(this.Cluster_Raw_Header_Size);
                    base.Add(this.Size_Without_Header);
                    base.Add(this.Padding_1);
                    base.Add(this.Padding_2);
                    base.Add(this.Padding_3);
                    base.Add(this.Padding_4);
                    base.Add(this.Padding_5);
                }
            }

            public class BSP_Scenery_Palettes_Layout : TagBlockLayout
            {
                public static readonly ltmp.Unknown17_Layout.BSP_Scenery_Palettes_Layout Layout = new ltmp.Unknown17_Layout.BSP_Scenery_Palettes_Layout();
                public ShortInteger Pallette_Index = new ShortInteger("Pallette Index");
                public ShortInteger Unknown = new ShortInteger("Unknown");

                public BSP_Scenery_Palettes_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Pallette_Index);
                }
            }

            public class BSP_Scenery_Unknown_Layout : TagBlockLayout
            {
                public static readonly ltmp.Unknown17_Layout.BSP_Scenery_Unknown_Layout Layout = new ltmp.Unknown17_Layout.BSP_Scenery_Unknown_Layout();
                public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 12);
                public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 4);
                public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 4);
                public core.TagInterface.Padding Padding_2 = new core.TagInterface.Padding("Padding", 8);
                public core.TagInterface.Padding Padding_3 = new core.TagInterface.Padding("Padding", 4);
                public core.TagInterface.Padding Padding_4 = new core.TagInterface.Padding("Padding", 4);
                public core.TagInterface.Padding Padding_5 = new core.TagInterface.Padding("Padding", 4);
                public core.TagInterface.Padding Padding_6 = new core.TagInterface.Padding("Padding", 8);
                public LongInteger Unknown = new LongInteger("Unknown");
                public LongInteger Unknown_0 = new LongInteger("Unknown");
                public LongInteger Unknown_1 = new LongInteger("Unknown");
                public LongInteger Unknown_2 = new LongInteger("Unknown");
                public LongInteger Unknown_3 = new LongInteger("Unknown");
                public LongInteger Unknown_4 = new LongInteger("Unknown");
                public LongInteger Unknown_5 = new LongInteger("Unknown");
                public LongInteger Unknown_6 = new LongInteger("Unknown");
                public LongInteger Unknown_7 = new LongInteger("Unknown");

                public BSP_Scenery_Unknown_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                    base.Add(this.Unknown_1);
                    base.Add(this.Unknown_2);
                    base.Add(this.Unknown_3);
                    base.Add(this.Unknown_4);
                    base.Add(this.Padding);
                    base.Add(this.Unknown_5);
                    base.Add(this.Padding_0);
                    base.Add(this.Padding_1);
                    base.Add(this.Unknown_6);
                    base.Add(this.Unknown_7);
                    base.Add(this.Padding_2);
                    base.Add(this.Padding_3);
                    base.Add(this.Padding_4);
                    base.Add(this.Padding_5);
                    base.Add(this.Padding_6);
                }
            }

            public class Lightmap_Palette_Layout : TagBlockLayout
            {
                public RGBAColor[] Color = new RGBAColor[0x100];
                public static readonly ltmp.Unknown17_Layout.Lightmap_Palette_Layout Layout = new ltmp.Unknown17_Layout.Lightmap_Palette_Layout();

                public Lightmap_Palette_Layout()
                {
                    for (int i = 0; i < 0x100; i++)
                    {
                        this.Color[i] = new RGBAColor("Light Map Palette Color [" + i.ToString() + "]");
                        base.Add(this.Color[i]);
                    }
                }
            }

            public class Lightmap_Raw_Layout : TagBlockLayout
            {
                public static readonly ltmp.Unknown17_Layout.Lightmap_Raw_Layout Layout = new ltmp.Unknown17_Layout.Lightmap_Raw_Layout();
                public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 8);
                public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 8);
                public Raw_Tag_Block raw_data = new Raw_Tag_Block("Raw Data", Map.HaloVersionEnum.Halo2, Data.RawDataTypes.H2_sbsp_lightmap, new TagBlockLayout());
                public LongInteger Unknown = new LongInteger("Unknown");

                public Lightmap_Raw_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Padding);
                    base.Add(this.raw_data);
                    base.Add(this.Padding_1);
                }
            }

            public class Unknown322_Layout : TagBlockLayout
            {
                public static readonly ltmp.Unknown17_Layout.Unknown322_Layout Layout = new ltmp.Unknown17_Layout.Unknown322_Layout();
                public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
                public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 0x10);
                public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 8);
                public LongInteger Unknown = new LongInteger("Unknown");
                public LongInteger Unknown_0 = new LongInteger("Unknown");
                public RealFloat Unknown_1 = new RealFloat("Unknown");
                public LongInteger Unknown_10 = new LongInteger("Unknown");
                public RealFloat Unknown_11 = new RealFloat("Unknown");
                public LongInteger Unknown_12 = new LongInteger("Unknown");
                public LongInteger Unknown_13 = new LongInteger("Unknown");
                public LongInteger Unknown_14 = new LongInteger("Unknown");
                public LongInteger Unknown_15 = new LongInteger("Unknown");
                public LongInteger Unknown_16 = new LongInteger("Unknown");
                public LongInteger Unknown_17 = new LongInteger("Unknown");
                public LongInteger Unknown_18 = new LongInteger("Unknown");
                public LongInteger Unknown_19 = new LongInteger("Unknown");
                public RealFloat Unknown_2 = new RealFloat("Unknown");
                public RealFloat Unknown_20 = new RealFloat("Unknown");
                public LongInteger Unknown_21 = new LongInteger("Unknown");
                public LongInteger Unknown_22 = new LongInteger("Unknown");
                public LongInteger Unknown_23 = new LongInteger("Unknown");
                public LongInteger Unknown_24 = new LongInteger("Unknown");
                public LongInteger Unknown_25 = new LongInteger("Unknown");
                public LongInteger Unknown_26 = new LongInteger("Unknown");
                public LongInteger Unknown_27 = new LongInteger("Unknown");
                public LongInteger Unknown_28 = new LongInteger("Unknown");
                public LongInteger Unknown_29 = new LongInteger("Unknown");
                public LongInteger Unknown_3 = new LongInteger("Unknown");
                public LongInteger Unknown_30 = new LongInteger("Unknown");
                public LongInteger Unknown_31 = new LongInteger("Unknown");
                public RealFloat Unknown_32 = new RealFloat("Unknown");
                public RealFloat Unknown_33 = new RealFloat("Unknown");
                public RealFloat Unknown_34 = new RealFloat("Unknown");
                public LongInteger Unknown_35 = new LongInteger("Unknown");
                public LongInteger Unknown_36 = new LongInteger("Unknown");
                public LongInteger Unknown_37 = new LongInteger("Unknown");
                public RealFloat Unknown_38 = new RealFloat("Unknown");
                public RealFloat Unknown_39 = new RealFloat("Unknown");
                public LongInteger Unknown_4 = new LongInteger("Unknown");
                public RealFloat Unknown_40 = new RealFloat("Unknown");
                public LongInteger Unknown_41 = new LongInteger("Unknown");
                public RealFloat Unknown_42 = new RealFloat("Unknown");
                public RealFloat Unknown_43 = new RealFloat("Unknown");
                public RealFloat Unknown_44 = new RealFloat("Unknown");
                public RealFloat Unknown_45 = new RealFloat("Unknown");
                public RealFloat Unknown_46 = new RealFloat("Unknown");
                public LongInteger Unknown_5 = new LongInteger("Unknown");
                public LongInteger Unknown_6 = new LongInteger("Unknown");
                public LongInteger Unknown_7 = new LongInteger("Unknown");
                public LongInteger Unknown_8 = new LongInteger("Unknown");
                public LongInteger Unknown_9 = new LongInteger("Unknown");

                public Unknown322_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                    base.Add(this.Unknown_1);
                    base.Add(this.Unknown_2);
                    base.Add(this.Unknown_3);
                    base.Add(this.Unknown_4);
                    base.Add(this.Unknown_5);
                    base.Add(this.Unknown_6);
                    base.Add(this.Unknown_7);
                    base.Add(this.Unknown_8);
                    base.Add(this.Unknown_9);
                    base.Add(this.Unknown_10);
                    base.Add(this.Unknown_11);
                    base.Add(this.Unknown_12);
                    base.Add(this.Unknown_13);
                    base.Add(this.Unknown_14);
                    base.Add(this.Unknown_15);
                    base.Add(this.Unknown_16);
                    base.Add(this.Unknown_17);
                    base.Add(this.Unknown_18);
                    base.Add(this.Unknown_19);
                    base.Add(this.Unknown_20);
                    base.Add(this.Unknown_21);
                    base.Add(this.Unknown_22);
                    base.Add(this.Unknown_23);
                    base.Add(this.Unknown_24);
                    base.Add(this.Unknown_25);
                    base.Add(this.Unknown_26);
                    base.Add(this.Unknown_27);
                    base.Add(this.Unknown_28);
                    base.Add(this.Unknown_29);
                    base.Add(this.Unknown_30);
                    base.Add(this.Unknown_31);
                    base.Add(this.Unknown_32);
                    base.Add(this.Unknown_33);
                    base.Add(this.Unknown_34);
                    base.Add(this.Padding);
                    base.Add(this.Padding_0);
                    base.Add(this.Unknown_35);
                    base.Add(this.Unknown_36);
                    base.Add(this.Unknown_37);
                    base.Add(this.Unknown_38);
                    base.Add(this.Unknown_39);
                    base.Add(this.Unknown_40);
                    base.Add(this.Unknown_41);
                    base.Add(this.Unknown_42);
                    base.Add(this.Unknown_43);
                    base.Add(this.Unknown_44);
                    base.Add(this.Padding_1);
                    base.Add(this.Unknown_45);
                    base.Add(this.Unknown_46);
                }
            }

            public class Unknown396_Layout : TagBlockLayout
            {
                public static readonly ltmp.Unknown17_Layout.Unknown396_Layout Layout = new ltmp.Unknown17_Layout.Unknown396_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");
                public TagBlock Unknown398 = new TagBlock("Unknown398", Unknown398_Layout.Layout, Map.HaloVersionEnum.Halo2);

                public Unknown396_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown398);
                }

                public class Unknown398_Layout : TagBlockLayout
                {
                    public static readonly ltmp.Unknown17_Layout.Unknown396_Layout.Unknown398_Layout Layout = new ltmp.Unknown17_Layout.Unknown396_Layout.Unknown398_Layout();
                    public LongInteger Unknown = new LongInteger("Unknown");

                    public Unknown398_Layout()
                    {
                        base.Add(this.Unknown);
                    }
                }
            }

            public class Unknown402_Layout : TagBlockLayout
            {
                public static readonly ltmp.Unknown17_Layout.Unknown402_Layout Layout = new ltmp.Unknown17_Layout.Unknown402_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");
                public LongInteger Unknown_0 = new LongInteger("Unknown");
                public LongInteger Unknown_1 = new LongInteger("Unknown");

                public Unknown402_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                    base.Add(this.Unknown_1);
                }
            }

            public class Unknown407_Layout : TagBlockLayout
            {
                public static readonly ltmp.Unknown17_Layout.Unknown407_Layout Layout = new ltmp.Unknown17_Layout.Unknown407_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");
                public TagBlock Unknown409 = new TagBlock("Unknown409", Unknown409_Layout.Layout, Map.HaloVersionEnum.Halo2, 4);

                public Unknown407_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown409);
                }

                public class Unknown409_Layout : TagBlockLayout
                {
                    public static readonly ltmp.Unknown17_Layout.Unknown407_Layout.Unknown409_Layout Layout = new ltmp.Unknown17_Layout.Unknown407_Layout.Unknown409_Layout();
                    public ShortInteger Unknown = new ShortInteger("Unknown");

                    public Unknown409_Layout()
                    {
                        base.Add(this.Unknown);
                    }
                }
            }
        }
    }
}

