﻿namespace core.H2
{
    using core.TagInterface;
    using System;

    public class mode : TagBlockLayout
    {
        public TagBlock Bone = new TagBlock("Bone", Bone_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Bounding_Box = new TagBlock("Bounding Box", Bounding_Box_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public static readonly mode Layout = new mode();
        public TagBlock Marker = new TagBlock("Marker", Marker_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public StringID Model_Name = new StringID("Model Name");
        public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 8);
        public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 4);
        public core.TagInterface.Padding Padding_1 = new core.TagInterface.Padding("Padding", 8);
        public core.TagInterface.Padding Padding_2 = new core.TagInterface.Padding("Padding", 8);
        public TagBlock Part = new TagBlock("Part", Part_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Regions = new TagBlock("Region Layout", Region_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Shader = new TagBlock("Shader", Shader_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public LongInteger Unknown = new LongInteger("Unknown");
        public LongInteger Unknown_0 = new LongInteger("Unknown");
        public TagBlock Unknown_1 = new TagBlock("Unknown", Unknown_1_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public LongInteger Unknown_2 = new LongInteger("Unknown");
        public LongInteger Unknown_3 = new LongInteger("Unknown");
        public RealFloat Unknown_4 = new RealFloat("Unknown");
        public TagBlock Unknown_5 = new TagBlock("Unknown_5", Unknown_Raw_Data_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unknown_6 = new TagBlock("Unknown_6", Unknown_6_Layout.Layout, Map.HaloVersionEnum.Halo2);
        public TagBlock Unused = new TagBlock("Unused", Unused_Layout.Layout, Map.HaloVersionEnum.Halo2);

        public mode()
        {
            base.Add(this.Model_Name);
            base.Add(this.Unknown);
            base.Add(this.Unknown_0);
            base.Add(this.Padding);
            base.Add(this.Bounding_Box);
            base.Add(this.Regions);
            base.Add(this.Part);
            base.Add(this.Unused);
            base.Add(this.Unknown_1);
            base.Add(this.Unknown_2);
            base.Add(this.Unknown_3);
            base.Add(this.Padding_0);
            base.Add(this.Bone);
            base.Add(this.Padding_1);
            base.Add(this.Marker);
            base.Add(this.Shader);
            base.Add(this.Padding_2);
            base.Add(this.Unknown_4);
            base.Add(this.Unknown_5);
            base.Add(this.Unknown_6);
        }

        public class Bone_Layout : TagBlockLayout
        {
            public StringID Bone_Name = new StringID("Bone Name");
            public RealFloat Distance_from_Parent = new RealFloat("Distance from Parent");
            public ShortInteger First_Child__Index_ = new ShortInteger("First Child (Index)");
            public static readonly mode.Bone_Layout Layout = new mode.Bone_Layout();
            public ShortInteger Next_Sibling__Index_ = new ShortInteger("Next Sibling (Index)");
            public ShortInteger Parent__Index_ = new ShortInteger("Parent (Index)");
            public RealFloat Pitch = new RealFloat("Pitch");
            public RealFloat Roll = new RealFloat("Roll");
            public RealFloat single_bone_X = new RealFloat("single bone X");
            public RealFloat single_bone_Y = new RealFloat("single bone Y");
            public RealFloat single_bone_Z = new RealFloat("single bone Z");
            public ShortInteger Unknown = new ShortInteger("Unknown");
            public RealFloat Unknown_0 = new RealFloat("Unknown");
            public RealFloat Unknown_1 = new RealFloat("Unknown");
            public RealFloat Unknown_10 = new RealFloat("Unknown");
            public RealFloat Unknown_2 = new RealFloat("Unknown");
            public RealFloat Unknown_3 = new RealFloat("Unknown");
            public RealFloat Unknown_4 = new RealFloat("Unknown");
            public RealFloat Unknown_5 = new RealFloat("Unknown");
            public RealFloat Unknown_6 = new RealFloat("Unknown");
            public RealFloat Unknown_7 = new RealFloat("Unknown");
            public RealFloat Unknown_8 = new RealFloat("Unknown");
            public RealFloat Unknown_9 = new RealFloat("Unknown");
            public RealFloat X = new RealFloat("X");
            public RealFloat Y = new RealFloat("Y");
            public RealFloat Yaw = new RealFloat("Yaw");
            public RealFloat Z = new RealFloat("Z");

            public Bone_Layout()
            {
                base.Add(this.Bone_Name);
                base.Add(this.Parent__Index_);
                base.Add(this.First_Child__Index_);
                base.Add(this.Next_Sibling__Index_);
                base.Add(this.Unknown);
                base.Add(this.X);
                base.Add(this.Y);
                base.Add(this.Z);
                base.Add(this.Yaw);
                base.Add(this.Pitch);
                base.Add(this.Roll);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
                base.Add(this.Unknown_7);
                base.Add(this.Unknown_8);
                base.Add(this.Unknown_9);
                base.Add(this.Unknown_10);
                base.Add(this.single_bone_X);
                base.Add(this.single_bone_Y);
                base.Add(this.single_bone_Z);
                base.Add(this.Distance_from_Parent);
            }
        }

        public class Bounding_Box_Layout : TagBlockLayout
        {
            public Model_Bounds bounds = new Model_Bounds("Bounds");
            public static readonly mode.Bounding_Box_Layout Layout = new mode.Bounding_Box_Layout();
            public RealFloat Unknown = new RealFloat("Unknown");
            public RealFloat Unknown_0 = new RealFloat("Unknown");
            public RealFloat Unknown_1 = new RealFloat("Unknown");
            public RealFloat Unknown_2 = new RealFloat("Unknown");

            public Bounding_Box_Layout()
            {
                base.Add(this.bounds);
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
            }
        }

        public class Marker_Layout : TagBlockLayout
        {
            public TagBlock coordinates = new TagBlock("coordinates", coordinates_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public static readonly mode.Marker_Layout Layout = new mode.Marker_Layout();
            public StringID Marker_Name = new StringID("Marker Name");

            public Marker_Layout()
            {
                base.Add(this.Marker_Name);
                base.Add(this.coordinates);
            }

            public class coordinates_Layout : TagBlockLayout
            {
                public static readonly mode.Marker_Layout.coordinates_Layout Layout = new mode.Marker_Layout.coordinates_Layout();
                public RealFloat Pitch = new RealFloat("Pitch");
                public RealFloat Roll = new RealFloat("Roll");
                public LongInteger Unknown = new LongInteger("Unknown");
                public LongInteger Unknown_0 = new LongInteger("Unknown");
                public LongInteger Unknown_1 = new LongInteger("Unknown");
                public RealFloat x = new RealFloat("x");
                public RealFloat y__when_seen_from_back_ = new RealFloat("y (when seen from back)");
                public RealFloat Yaw = new RealFloat("Yaw");
                public RealFloat z = new RealFloat("z");

                public coordinates_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.y__when_seen_from_back_);
                    base.Add(this.x);
                    base.Add(this.z);
                    base.Add(this.Yaw);
                    base.Add(this.Pitch);
                    base.Add(this.Roll);
                    base.Add(this.Unknown_0);
                    base.Add(this.Unknown_1);
                }
            }
        }

        public class Part_Layout : TagBlockLayout
        {
            public ShortInteger Bone_Type = new ShortInteger("Bone Type");
            public ShortInteger Face_Count = new ShortInteger("Face_Count");
            public static readonly mode.Part_Layout Layout = new mode.Part_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 8);
            public core.TagInterface.Padding Padding_0 = new core.TagInterface.Padding("Padding", 8);
            public LongInteger Type = new LongInteger("Type");
            public LongInteger Unknown_0 = new LongInteger("Unknown");
            public LongInteger Unknown_1 = new LongInteger("Unknown");
            public LongInteger Unknown_2 = new LongInteger("Unknown");
            public ShortInteger Unknown_3 = new ShortInteger("Unknown");
            public LongInteger Unknown_4 = new LongInteger("Unknown");
            public LongInteger Unknown_5 = new LongInteger("Unknown");
            public LongInteger Unknown_6 = new LongInteger("Unknown");
            public LongInteger Unknown_7 = new LongInteger("Unknown");
            public ShortInteger Vertex_Count = new ShortInteger("Vertex Count");
            public Raw_Tag_Block Visual_Raw = new Raw_Tag_Block("Visual Raw", Map.HaloVersionEnum.Halo2, Data.RawDataTypes.H2_mode1, Model_Visual_Raw_Header.Layout);

            public Part_Layout()
            {
                base.Add(this.Type);
                base.Add(this.Vertex_Count);
                base.Add(this.Face_Count);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Bone_Type);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Padding);
                base.Add(this.Unknown_5);
                base.Add(this.Unknown_6);
                base.Add(this.Unknown_7);
                base.Add(this.Padding_0);
                base.Add(this.Visual_Raw);
            }

            public class Model_Visual_Raw_Header : TagBlockLayout
            {
                public TagBlock bvh = new TagBlock("BVH", Raw_Tag_Block.BVH.Layout, Map.HaloVersionEnum.Halo2);
                public TagBlock indices = new TagBlock("Indices", Raw_Tag_Block.Indice.Layout, Map.HaloVersionEnum.Halo2);
                public static readonly mode.Part_Layout.Model_Visual_Raw_Header Layout = new mode.Part_Layout.Model_Visual_Raw_Header();
                public TagBlock mesh_bvh_order = new TagBlock("Mesh BVH Order", Raw_Tag_Block.Mesh_BVH_Order.Layout, Map.HaloVersionEnum.Halo2);
                public Padding padding1 = new Padding(0x10);
                public Padding padding2 = new Padding(4);
                public Padding padding3 = new Padding(8);
                public Padding padding4 = new Padding(12);
                public TagBlock sub_cluster_data = new TagBlock("Sub-Clusters Data", Raw_Tag_Block.Sub_Cluster_Data.Layout, Map.HaloVersionEnum.Halo2);
                public TagBlock sub_clusters = new TagBlock("Sub-Clusters", Raw_Tag_Block.Sub_Cluster.Layout, Map.HaloVersionEnum.Halo2);
                public TagBlock unknown1 = new TagBlock("unknown1", Raw_Tag_Block.Unknown_1.Layout, Map.HaloVersionEnum.Halo2);
                public TagBlock unknown2 = new TagBlock("unknown2", Raw_Tag_Block.Unknown_2.Layout, Map.HaloVersionEnum.Halo2);
                public TagBlock unknown3 = new TagBlock("unknown3", Raw_Tag_Block.Unknown_3.Layout, Map.HaloVersionEnum.Halo2);
                public TagBlock vertices = new TagBlock("Vertex Declaration", Raw_Tag_Block.Vertex_Declaration.Layout, Map.HaloVersionEnum.Halo2);

                public Model_Visual_Raw_Header()
                {
                    base.Add(this.sub_clusters);
                    base.Add(this.sub_cluster_data);
                    base.Add(this.padding1);
                    base.Add(this.indices);
                    base.Add(this.bvh);
                    base.Add(this.mesh_bvh_order);
                    base.Add(this.vertices);
                    base.Add(this.padding2);
                    base.Add(this.unknown1);
                    base.Add(this.padding3);
                    base.Add(this.unknown2);
                    base.Add(this.unknown3);
                    base.Add(this.padding4);
                }
            }
        }

        public class Region_Layout : TagBlockLayout
        {
            public static readonly mode.Region_Layout Layout = new mode.Region_Layout();
            public StringID Part_Name = new StringID("Part Name");
            public TagBlock Permutation = new TagBlock("Permutation", Permutation_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public LongInteger Unknown = new LongInteger("Unknown");

            public Region_Layout()
            {
                base.Add(this.Part_Name);
                base.Add(this.Unknown);
                base.Add(this.Permutation);
            }

            public class Permutation_Layout : TagBlockLayout
            {
                public ShortInteger High_Piece__Index_ = new ShortInteger("High Piece (Index)");
                public ShortInteger Highest_Piece__Index_ = new ShortInteger("Highest Piece (Index)");
                public static readonly mode.Region_Layout.Permutation_Layout Layout = new mode.Region_Layout.Permutation_Layout();
                public ShortInteger Low_Piece__Index_ = new ShortInteger("Low Piece (Index)");
                public ShortInteger Lowest_Piece__Index_ = new ShortInteger("Lowest Piece (Index)");
                public ShortInteger Medium_High_Piece__Index_ = new ShortInteger("Medium-High Piece (Index)");
                public ShortInteger Medium_Low_Piece__Index_ = new ShortInteger("Medium-Low Piece (Index)");
                public StringID Permutation_Name = new StringID("Permutation Name");

                public Permutation_Layout()
                {
                    base.Add(this.Permutation_Name);
                    base.Add(this.Lowest_Piece__Index_);
                    base.Add(this.Low_Piece__Index_);
                    base.Add(this.Medium_Low_Piece__Index_);
                    base.Add(this.Medium_High_Piece__Index_);
                    base.Add(this.High_Piece__Index_);
                    base.Add(this.Highest_Piece__Index_);
                }
            }
        }

        public class Shader_Layout : TagBlockLayout
        {
            public static readonly mode.Shader_Layout Layout = new mode.Shader_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 8);
            public HaloTagType Shader = new HaloTagType("Shader");
            public TagIdent Shader_0 = new TagIdent("Shader");
            public TagBlock Unknown = new TagBlock("Unknown", Unknown_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public HaloTagType Unused = new HaloTagType("Unused");
            public TagIdent Unused_0 = new TagIdent("Unused");

            public Shader_Layout()
            {
                base.Add(this.Unused);
                base.Add(this.Unused_0);
                base.Add(this.Shader);
                base.Add(this.Shader_0);
                base.Add(this.Unknown);
                base.Add(this.Padding);
            }

            public class Unknown_Layout : TagBlockLayout
            {
                public static readonly mode.Shader_Layout.Unknown_Layout Layout = new mode.Shader_Layout.Unknown_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");
                public RealFloat Unknown_0 = new RealFloat("Unknown");

                public Unknown_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                }
            }
        }

        public class Unknown_1_Layout : TagBlockLayout
        {
            public static readonly mode.Unknown_1_Layout Layout = new mode.Unknown_1_Layout();
            public LongInteger Unknown = new LongInteger("Unknown");
            public TagBlock Unknown_0 = new TagBlock("Unknown", Unknown_0_Layout.Layout, Map.HaloVersionEnum.Halo2);

            public Unknown_1_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
            }

            public class Unknown_0_Layout : TagBlockLayout
            {
                public static readonly mode.Unknown_1_Layout.Unknown_0_Layout Layout = new mode.Unknown_1_Layout.Unknown_0_Layout();
                public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);
                public RealFloat Unknown = new RealFloat("Unknown");
                public RealFloat Unknown_0 = new RealFloat("Unknown");
                public RealFloat Unknown_1 = new RealFloat("Unknown");

                public Unknown_0_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                    base.Add(this.Unknown_1);
                    base.Add(this.Padding);
                }
            }
        }

        public class Unknown_6_Layout : TagBlockLayout
        {
            public static readonly mode.Unknown_6_Layout Layout = new mode.Unknown_6_Layout();
            public TagBlock Unknown = new TagBlock("Unknown_6_0", Unknown_Layout.Layout, Map.HaloVersionEnum.Halo2);

            public Unknown_6_Layout()
            {
                base.Add(this.Unknown);
            }

            public class Unknown_Layout : TagBlockLayout
            {
                public static readonly mode.Unknown_6_Layout.Unknown_Layout Layout = new mode.Unknown_6_Layout.Unknown_Layout();
                public TagBlock Unknown = new TagBlock("Unknown", Unknown_Layout_x.Layout, Map.HaloVersionEnum.Halo2);
                public TagBlock Unknown_0 = new TagBlock("Unknown", Unknown_0_Layout.Layout, Map.HaloVersionEnum.Halo2);

                public Unknown_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                }

                public class Unknown_0_Layout : TagBlockLayout
                {
                    public static readonly mode.Unknown_6_Layout.Unknown_Layout.Unknown_0_Layout Layout = new mode.Unknown_6_Layout.Unknown_Layout.Unknown_0_Layout();
                    public LongInteger Unknown = new LongInteger("Unknown");
                    public LongInteger Unknown_0 = new LongInteger("Unknown");

                    public Unknown_0_Layout()
                    {
                        base.Add(this.Unknown);
                        base.Add(this.Unknown_0);
                    }
                }

                public class Unknown_Layout_x : TagBlockLayout
                {
                    public static readonly mode.Unknown_6_Layout.Unknown_Layout.Unknown_Layout_x Layout = new mode.Unknown_6_Layout.Unknown_Layout.Unknown_Layout_x();
                    public LongInteger Unknown = new LongInteger("Unknown");
                    public LongInteger Unknown_0 = new LongInteger("Unknown");

                    public Unknown_Layout_x()
                    {
                        base.Add(this.Unknown);
                        base.Add(this.Unknown_0);
                    }
                }
            }
        }

        public class Unknown_Raw_Data_Layout : TagBlockLayout
        {
            public static readonly mode.Unknown_Raw_Data_Layout Layout = new mode.Unknown_Raw_Data_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 0x10);
            public LongInteger Unknown = new LongInteger("Unknown");
            public LongInteger Unknown_0 = new LongInteger("Unknown");
            public LongInteger Unknown_1 = new LongInteger("Unknown");
            public RealFloat Unknown_2 = new RealFloat("Unknown");
            public LongInteger Unknown_3 = new LongInteger("Unknown");
            public TagBlock Unknown_4 = new TagBlock("Unknown_Raw_Data_Unknown_4_Layout", Unknown_Raw_Data_Unknown_4_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public TagBlock Unknown_5 = new TagBlock("Unknown_Raw_Data_Unknown_5_Layout", Unknown_Raw_Data_Unknown_5_Layout.Layout, Map.HaloVersionEnum.Halo2);
            public Raw_Tag_Block Visual_Raw = new Raw_Tag_Block("Visual Raw", Map.HaloVersionEnum.Halo2, Data.RawDataTypes.H2_mode2, new TagBlockLayout());

            public Unknown_Raw_Data_Layout()
            {
                base.Add(this.Unknown);
                base.Add(this.Unknown_0);
                base.Add(this.Unknown_1);
                base.Add(this.Unknown_2);
                base.Add(this.Unknown_3);
                base.Add(this.Unknown_4);
                base.Add(this.Unknown_5);
                base.Add(this.Padding);
                base.Add(this.Visual_Raw);
            }

            public class Unknown_Raw_Data_Unknown_4_Layout : TagBlockLayout
            {
                public static readonly mode.Unknown_Raw_Data_Layout.Unknown_Raw_Data_Unknown_4_Layout Layout = new mode.Unknown_Raw_Data_Layout.Unknown_Raw_Data_Unknown_4_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");
                public TagBlock Unknown_0 = new TagBlock("Unknown_Raw_Data_Unknown_4_Unknown_0_Layout", Unknown_Raw_Data_Unknown_4_Unknown_0_Layout.Layout, Map.HaloVersionEnum.Halo2);

                public Unknown_Raw_Data_Unknown_4_Layout()
                {
                    base.Add(this.Unknown);
                    base.Add(this.Unknown_0);
                }

                public class Unknown_Raw_Data_Unknown_4_Unknown_0_Layout : TagBlockLayout
                {
                    public static readonly mode.Unknown_Raw_Data_Layout.Unknown_Raw_Data_Unknown_4_Layout.Unknown_Raw_Data_Unknown_4_Unknown_0_Layout Layout = new mode.Unknown_Raw_Data_Layout.Unknown_Raw_Data_Unknown_4_Layout.Unknown_Raw_Data_Unknown_4_Unknown_0_Layout();
                    public LongInteger Unknown = new LongInteger("Unknown");
                    public LongInteger Unknown_0 = new LongInteger("Unknown");

                    public Unknown_Raw_Data_Unknown_4_Unknown_0_Layout()
                    {
                        base.Add(this.Unknown);
                        base.Add(this.Unknown_0);
                    }
                }
            }

            public class Unknown_Raw_Data_Unknown_5_Layout : TagBlockLayout
            {
                public static readonly mode.Unknown_Raw_Data_Layout.Unknown_Raw_Data_Unknown_5_Layout Layout = new mode.Unknown_Raw_Data_Layout.Unknown_Raw_Data_Unknown_5_Layout();
                public LongInteger Unknown = new LongInteger("Unknown");

                public Unknown_Raw_Data_Unknown_5_Layout()
                {
                    base.Add(this.Unknown);
                }
            }
        }

        public class Unused_Layout : TagBlockLayout
        {
            public static readonly mode.Unused_Layout Layout = new mode.Unused_Layout();
            public core.TagInterface.Padding Padding = new core.TagInterface.Padding("Padding", 4);

            public Unused_Layout()
            {
                base.Add(this.Padding);
            }
        }
    }
}

