﻿namespace core
{
    using core.TagInterface;
    using System;
    using System.ComponentModel;
    using System.Drawing;
    using System.Windows.Forms;

    public class Layout_Control : UserControl
    {
        private Button button1;
        private IContainer components;
        private TextBox FilePathTextBox;
        private RadioButton HardCodedRadioButton;
        private Label label1;
        private Label label2;
        private Label label3;
        private TagDefinition tagdef;
        private TextBox TagExtensionTextBox;
        private TextBox TagTypeTextBox;
        private RadioButton XMLRadioButton;

        public Layout_Control()
        {
            this.components = null;
            this.tagdef = new TagDefinition();
            this.InitializeComponent();
        }

        public Layout_Control(TagDefinition tag_definition)
        {
            this.components = null;
            this.tagdef = new TagDefinition();
            this.InitializeComponent();
            this.Tag_Definition = tag_definition;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            OpenFileDialog dialog = new OpenFileDialog();
            dialog.DefaultExt = "ent";
            dialog.Filter = "*.ent (.ent Tag Layout)|*.ent";
            if (dialog.ShowDialog() != DialogResult.Cancel)
            {
                this.tagdef.FilePath = dialog.FileName;
                this.FilePathTextBox.Text = this.tagdef.FilePath;
                this.XMLRadioButton.Enabled = true;
            }
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing && (this.components != null))
            {
                this.components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void HardCodedRadioButton_CheckedChanged(object sender, EventArgs e)
        {
            this.tagdef.Mode = TagDefinition.TagMode.Hard_Coded;
        }

        private void InitializeComponent()
        {
            this.TagTypeTextBox = new TextBox();
            this.label1 = new Label();
            this.label2 = new Label();
            this.FilePathTextBox = new TextBox();
            this.XMLRadioButton = new RadioButton();
            this.HardCodedRadioButton = new RadioButton();
            this.label3 = new Label();
            this.TagExtensionTextBox = new TextBox();
            this.button1 = new Button();
            base.SuspendLayout();
            this.TagTypeTextBox.BorderStyle = BorderStyle.FixedSingle;
            this.TagTypeTextBox.Location = new Point(80, 2);
            this.TagTypeTextBox.MaxLength = 4;
            this.TagTypeTextBox.Name = "TagTypeTextBox";
            this.TagTypeTextBox.Size = new Size(0x35, 20);
            this.TagTypeTextBox.TabIndex = 0;
            this.label1.AutoSize = true;
            this.label1.Font = new Font("Arial", 9.75f, FontStyle.Regular, GraphicsUnit.Point, 0);
            this.label1.ForeColor = Color.DarkGray;
            this.label1.Location = new Point(3, 2);
            this.label1.Name = "label1";
            this.label1.Size = new Size(70, 0x10);
            this.label1.TabIndex = 1;
            this.label1.Text = "Tag Class:";
            this.label2.AutoSize = true;
            this.label2.Font = new Font("Arial", 9.75f, FontStyle.Regular, GraphicsUnit.Point, 0);
            this.label2.ForeColor = Color.DarkGray;
            this.label2.Location = new Point(3, 30);
            this.label2.Name = "label2";
            this.label2.Size = new Size(0x40, 0x10);
            this.label2.TabIndex = 2;
            this.label2.Text = "File Path:";
            this.FilePathTextBox.BorderStyle = BorderStyle.FixedSingle;
            this.FilePathTextBox.Location = new Point(80, 0x1d);
            this.FilePathTextBox.MaxLength = 4;
            this.FilePathTextBox.Name = "FilePathTextBox";
            this.FilePathTextBox.ReadOnly = true;
            this.FilePathTextBox.Size = new Size(0x114, 20);
            this.FilePathTextBox.TabIndex = 3;
            this.FilePathTextBox.Text = "<Not Set>";
            this.XMLRadioButton.AutoSize = true;
            this.XMLRadioButton.Checked = true;
            this.XMLRadioButton.FlatAppearance.BorderColor = Color.DarkGray;
            this.XMLRadioButton.FlatAppearance.BorderSize = 2;
            this.XMLRadioButton.FlatAppearance.CheckedBackColor = Color.Red;
            this.XMLRadioButton.Font = new Font("Arial", 9.75f, FontStyle.Regular, GraphicsUnit.Point, 0);
            this.XMLRadioButton.ForeColor = Color.DarkGray;
            this.XMLRadioButton.Location = new Point(0x90, 0x37);
            this.XMLRadioButton.Name = "XMLRadioButton";
            this.XMLRadioButton.Size = new Size(0x5e, 20);
            this.XMLRadioButton.TabIndex = 4;
            this.XMLRadioButton.TabStop = true;
            this.XMLRadioButton.Text = "XML Layout";
            this.XMLRadioButton.UseVisualStyleBackColor = true;
            this.XMLRadioButton.CheckedChanged += new EventHandler(this.XMLRadioButton_CheckedChanged);
            this.HardCodedRadioButton.AutoSize = true;
            this.HardCodedRadioButton.FlatAppearance.CheckedBackColor = Color.Red;
            this.HardCodedRadioButton.Font = new Font("Arial", 9.75f, FontStyle.Regular, GraphicsUnit.Point, 0);
            this.HardCodedRadioButton.ForeColor = Color.DarkGray;
            this.HardCodedRadioButton.Location = new Point(260, 0x37);
            this.HardCodedRadioButton.Name = "HardCodedRadioButton";
            this.HardCodedRadioButton.Size = new Size(0x89, 20);
            this.HardCodedRadioButton.TabIndex = 5;
            this.HardCodedRadioButton.Text = "Hard Coded Layout";
            this.HardCodedRadioButton.UseVisualStyleBackColor = true;
            this.HardCodedRadioButton.CheckedChanged += new EventHandler(this.HardCodedRadioButton_CheckedChanged);
            this.label3.AutoSize = true;
            this.label3.Font = new Font("Arial", 9.75f, FontStyle.Regular, GraphicsUnit.Point, 0);
            this.label3.ForeColor = Color.DarkGray;
            this.label3.Location = new Point(0x8d, 3);
            this.label3.Name = "label3";
            this.label3.Size = new Size(0x5f, 0x10);
            this.label3.TabIndex = 7;
            this.label3.Text = "Tag Extension:";
            this.TagExtensionTextBox.BorderStyle = BorderStyle.FixedSingle;
            this.TagExtensionTextBox.Location = new Point(0xf2, 3);
            this.TagExtensionTextBox.MaxLength = 4;
            this.TagExtensionTextBox.Name = "TagExtensionTextBox";
            this.TagExtensionTextBox.Size = new Size(0x9b, 20);
            this.TagExtensionTextBox.TabIndex = 6;
            this.button1.ForeColor = Color.Black;
            this.button1.Location = new Point(0x16a, 0x1d);
            this.button1.Name = "button1";
            this.button1.Size = new Size(0x23, 20);
            this.button1.TabIndex = 8;
            this.button1.Text = "...";
            this.button1.UseVisualStyleBackColor = true;
            this.button1.Click += new EventHandler(this.button1_Click);
            base.AutoScaleDimensions = new SizeF(6f, 13f);
            base.AutoScaleMode = AutoScaleMode.Font;
            this.BackColor = Color.DarkSlateGray;
            base.BorderStyle = BorderStyle.FixedSingle;
            base.Controls.Add(this.button1);
            base.Controls.Add(this.label3);
            base.Controls.Add(this.TagExtensionTextBox);
            base.Controls.Add(this.HardCodedRadioButton);
            base.Controls.Add(this.XMLRadioButton);
            base.Controls.Add(this.FilePathTextBox);
            base.Controls.Add(this.label2);
            base.Controls.Add(this.label1);
            base.Controls.Add(this.TagTypeTextBox);
            this.ForeColor = Color.Silver;
            base.Name = "Layout_Control";
            base.Size = new Size(400, 0x51);
            base.ResumeLayout(false);
            base.PerformLayout();
        }

        private void XMLRadioButton_CheckedChanged(object sender, EventArgs e)
        {
            this.tagdef.Mode = TagDefinition.TagMode.XML;
        }

        private TagDefinition Tag_Definition
        {
            get
            {
                return this.tagdef;
            }
            set
            {
                this.tagdef = value;
                this.TagTypeTextBox.Text = this.tagdef.TagType;
                this.TagExtensionTextBox.Text = this.tagdef.Extension;
                this.FilePathTextBox.Text = this.tagdef.FilePath;
                if (this.tagdef.Hard_Coded_Layout == null)
                {
                    this.HardCodedRadioButton.Enabled = false;
                }
                if (this.tagdef.XML_Layout == null)
                {
                    this.XMLRadioButton.Enabled = false;
                }
                switch (this.tagdef.Mode)
                {
                    case TagDefinition.TagMode.XML:
                        this.XMLRadioButton.Checked = true;
                        break;

                    case TagDefinition.TagMode.Hard_Coded:
                        this.HardCodedRadioButton.Checked = true;
                        break;
                }
            }
        }
    }
}

