﻿namespace core.TagInterface
{
    using core;
    using core.IO;
    using System;
    using System.ComponentModel;
    using System.IO;

    public class Animation_Raw : Data
    {
        protected RawDataOffset raw_offset;

        public Animation_Raw(string name, Map.HaloVersionEnum haloversion, Data.RawDataTypes rawdatatype) : base(name, haloversion, rawdatatype)
        {
            this.raw_offset = new RawDataOffset("Raw Offset");
            base.type = BaseObjectType.Animation_Raw;
        }

        public override BaseObject Clone()
        {
            Animation_Raw raw = new Animation_Raw(base.name, base.HaloVersion, base.rawdatatype);
            raw.ms = new MemoryStream(base.rawdatasize);
            if (base.ms != null)
            {
                raw.ms.Write(base.ms.ToArray(), 0, base.rawdatasize);
            }
            raw.rawdatasize = base.rawdatasize;
            raw.size = base.size;
            raw.raw_offset = (RawDataOffset) this.raw_offset.Clone();
            raw.SetMetaOffset(base.MetaOffset);
            raw.SetOffset(base.Offset);
            raw.SetMapOffset(base.MapOffset);
            raw.Name = base.Name;
            raw.SetType(base.Type);
            return raw;
        }

        public override void Read(ref EndianIO.EndianReader BR)
        {
            base.rawdatasize = BR.ReadInt32();
            this.raw_offset.Read(ref BR);
        }

        public override void Write(ref EndianIO.EndianWriter BW)
        {
            BW.Write(base.rawdatasize);
            this.raw_offset.Write(ref BW);
        }

        [TypeConverter(typeof(MetaInterface.BaseObjectConverter))]
        public RawDataOffset Raw_Offset
        {
            get
            {
                return this.raw_offset;
            }
        }
    }
}

