﻿namespace core.TagInterface
{
    using core.IO;
    using System;
    using System.IO;

    public class Bitmap_Raw : BaseObject
    {
        protected MemoryStream[] lod_ms;
        public RawDataOffset[] lod_offset;
        public int[] lod_size;

        public Bitmap_Raw(string name) : base(name)
        {
            this.lod_ms = new MemoryStream[6];
            this.lod_offset = new RawDataOffset[6];
            this.lod_size = new int[6];
            base.size = 0x30;
            base.type = BaseObjectType.Bitmap_Raw;
        }

        public override BaseObject Clone()
        {
            Bitmap_Raw raw = new Bitmap_Raw(base.name);
            for (int i = 0; i < 6; i++)
            {
                if (this.lod_ms[i] != null)
                {
                    raw.lod_ms[i] = new MemoryStream(this.lod_size[i]);
                    raw.lod_ms[i].Write(this.lod_ms[i].ToArray(), 0, this.lod_size[i]);
                    raw.lod_size[i] = this.lod_size[i];
                    raw.lod_offset[i] = (RawDataOffset) this.lod_offset[i].Clone();
                }
            }
            raw.SetMetaOffset(base.MetaOffset);
            raw.SetOffset(base.Offset);
            raw.SetMapOffset(base.MapOffset);
            raw.Name = base.Name;
            raw.SetType(base.Type);
            return raw;
        }

        public virtual void Read(ref EndianIO.EndianReader BR)
        {
            int num;
            for (num = 0; num < 6; num++)
            {
                this.lod_offset[num] = new RawDataOffset("Raw Offset - " + num.ToString());
                this.lod_offset[num].Read(ref BR);
            }
            for (num = 0; num < 6; num++)
            {
                this.lod_size[num] = BR.ReadInt32();
            }
        }

        public virtual void Read_LOD_Raw(ref EndianIO.EndianReader BR, int index)
        {
            this.lod_ms[index] = new MemoryStream(this.lod_size[index]);
            this.lod_ms[index].Write(BR.ReadBytes(this.lod_size[index]), 0, this.lod_size[index]);
        }

        public virtual void Write(ref EndianIO.EndianWriter BW)
        {
            int num;
            for (num = 0; num < 6; num++)
            {
                this.lod_offset[num].Write(ref BW);
            }
            for (num = 0; num < 6; num++)
            {
                BW.Write(this.lod_size[num]);
            }
        }

        public virtual void Write_LOD_Raw(ref EndianIO.EndianWriter BW, int index)
        {
            BW.Write(this.lod_ms[index].ToArray());
        }

        public MemoryStream[] LOD_MS
        {
            get
            {
                return this.lod_ms;
            }
            set
            {
                this.lod_ms = value;
            }
        }

        public RawDataOffset[] LOD_Raw_Data_Offset
        {
            get
            {
                return this.lod_offset;
            }
            set
            {
                this.lod_offset = value;
            }
        }

        public int[] LOD_Raw_Data_Size
        {
            get
            {
                return this.lod_size;
            }
            set
            {
                this.lod_size = value;
            }
        }
    }
}

