﻿namespace core.TagInterface
{
    using core.IO;
    using System;
    using System.ComponentModel;

    public class ByteInteger : BaseObject
    {
        public byte Value;

        public ByteInteger(string name) : base(name)
        {
            base.size = 1;
            base.type = BaseObjectType.ByteInteger;
        }

        public override BaseObject Clone()
        {
            ByteInteger integer = new ByteInteger(base.name);
            integer.Value = this.Value;
            return integer;
        }

        public void Read(ref EndianIO.EndianReader BR)
        {
            this.Value = BR.ReadByte();
        }

        public void Write(ref EndianIO.EndianWriter BW)
        {
            BW.Write(this.Value);
        }

        [Category("Values")]
        public byte Byte
        {
            get
            {
                return this.Value;
            }
            set
            {
                this.Value = value;
            }
        }
    }
}

