﻿namespace core.TagInterface
{
    using core.IO;
    using System;

    public class EnumerableIndex : BaseObject
    {
        public core.TagInterface.Enumerator ChunkNames;
        public short index;

        public EnumerableIndex(string name) : base(name)
        {
            base.size = 4;
            base.type = BaseObjectType.EnumerableIndex;
            this.ChunkNames = new core.TagInterface.Enumerator(name, core.TagInterface.Enumerator.TagEnumeratorIndexType.Word);
        }

        public override BaseObject Clone()
        {
            EnumerableIndex index = new EnumerableIndex(base.name);
            index.ChunkNames = this.ChunkNames;
            index.index = this.index;
            index.SetMetaOffset(base.MetaOffset);
            index.SetOffset(base.Offset);
            index.SetMapOffset(base.MapOffset);
            index.Name = base.Name;
            index.SetType(base.Type);
            return index;
        }

        public void Read(ref EndianIO.EndianReader BR)
        {
            this.ChunkNames.Read(ref BR);
            this.index = BR.ReadInt16();
        }

        public void Write(ref EndianIO.EndianWriter BW)
        {
            this.ChunkNames.Write(ref BW);
            BW.Write(this.index);
        }
    }
}

