﻿namespace core.TagInterface
{
    using core.IO;
    using System;

    public class HaloTagType : BaseObject
    {
        public string TagType;

        public HaloTagType(string name) : base(name)
        {
            base.size = 4;
            base.type = BaseObjectType.HaloTagType;
        }

        public override BaseObject Clone()
        {
            HaloTagType type = new HaloTagType(base.name);
            type.TagType = this.TagType;
            type.SetMetaOffset(base.MetaOffset);
            type.SetOffset(base.Offset);
            type.SetMapOffset(base.MapOffset);
            type.Name = base.Name;
            type.SetType(base.Type);
            return type;
        }

        public void Read(ref EndianIO.EndianReader BR)
        {
            char[] array = core.TagInterface.String.ReadString(ref BR, 4).ToCharArray();
            Array.Reverse(array);
            this.TagType = new string(array);
            if (this.TagType == "\x00ff\x00ff\x00ff\x00ff")
            {
                this.TagType = "null";
            }
        }

        public void Write(ref EndianIO.EndianWriter BW)
        {
            if ((this.TagType != "null") && (this.TagType != ""))
            {
                char[] array = this.TagType.ToCharArray();
                Array.Reverse(array);
                BW.Write(array);
            }
            else if (this.TagType == "")
            {
                BW.Write(0);
            }
            else
            {
                BW.Write(-1);
            }
        }
    }
}

