﻿namespace core.TagInterface
{
    using core.IO;
    using System;
    using System.ComponentModel;

    public class LongInteger : BaseObject
    {
        public int Value;

        public LongInteger(string name) : base(name)
        {
            base.size = 4;
            base.type = BaseObjectType.LongInteger;
        }

        public override BaseObject Clone()
        {
            LongInteger integer = new LongInteger(base.name);
            integer.Value = this.Value;
            return integer;
        }

        public void Read(ref EndianIO.EndianReader BR)
        {
            this.Value = BR.ReadInt32();
        }

        public void Write(ref EndianIO.EndianWriter BW)
        {
            BW.Write(this.Value);
        }

        [Category("Values")]
        public int Long
        {
            get
            {
                return this.Value;
            }
            set
            {
                this.Value = value;
            }
        }
    }
}

