﻿namespace core.TagInterface
{
    using core.IO;
    using System;
    using System.ComponentModel;

    public class Model_Bounds : BaseObject
    {
        private RealBounds u;
        private RealBounds v;
        private RealBounds x;
        private RealBounds y;
        private RealBounds z;

        public Model_Bounds(string name) : base(name)
        {
            this.x = new RealBounds("X");
            this.y = new RealBounds("Y");
            this.z = new RealBounds("Z");
            this.u = new RealBounds("U");
            this.v = new RealBounds("V");
            base.size = 8;
            base.type = BaseObjectType.Model_Bounds;
        }

        public override BaseObject Clone()
        {
            Model_Bounds bounds = new Model_Bounds(base.name);
            bounds.x = this.x;
            bounds.y = this.y;
            bounds.z = this.z;
            bounds.u = this.u;
            bounds.v = this.v;
            bounds.SetMetaOffset(base.MetaOffset);
            bounds.SetOffset(base.Offset);
            bounds.SetMapOffset(base.MapOffset);
            bounds.Name = base.Name;
            bounds.SetType(base.Type);
            return bounds;
        }

        public void Read(ref EndianIO.EndianReader BR)
        {
            this.x.Read(ref BR);
            this.y.Read(ref BR);
            this.z.Read(ref BR);
            this.u.Read(ref BR);
            this.v.Read(ref BR);
        }

        public void Write(ref EndianIO.EndianWriter BW)
        {
            this.x.Write(ref BW);
            this.y.Write(ref BW);
            this.z.Write(ref BW);
            this.u.Write(ref BW);
            this.v.Write(ref BW);
        }

        [Category("Values")]
        public RealBounds U
        {
            get
            {
                return this.u;
            }
            set
            {
                this.u = value;
            }
        }

        [Category("Values")]
        public RealBounds V
        {
            get
            {
                return this.v;
            }
            set
            {
                this.v = value;
            }
        }

        [Category("Values")]
        public RealBounds X
        {
            get
            {
                return this.x;
            }
            set
            {
                this.x = value;
            }
        }

        [Category("Values")]
        public RealBounds Y
        {
            get
            {
                return this.y;
            }
            set
            {
                this.y = value;
            }
        }

        [Category("Values")]
        public RealBounds Z
        {
            get
            {
                return this.z;
            }
            set
            {
                this.z = value;
            }
        }
    }
}

