﻿namespace core.TagInterface
{
    using core.IO;
    using System;
    using System.ComponentModel;
    using System.Drawing;

    public class RGBAColor : BaseObject
    {
        public byte a;
        public byte b;
        private System.Drawing.Color color;
        public byte g;
        public byte r;

        public RGBAColor(string name) : base(name)
        {
            base.size = 4;
            base.type = BaseObjectType.RGBAColor;
        }

        public override BaseObject Clone()
        {
            RealARGBColor color = new RealARGBColor(base.name);
            color.a = this.a;
            color.r = this.r;
            color.g = this.g;
            color.b = this.b;
            color.SetMetaOffset(base.MetaOffset);
            color.SetOffset(base.Offset);
            color.SetMapOffset(base.MapOffset);
            color.Name = base.Name;
            color.SetType(base.Type);
            return color;
        }

        private void ConvertColor()
        {
        }

        public void Read(ref EndianIO.EndianReader BR)
        {
            this.r = BR.ReadByte();
            this.g = BR.ReadByte();
            this.b = BR.ReadByte();
            this.a = BR.ReadByte();
        }

        private void UpdateColor()
        {
        }

        public void Write(ref EndianIO.EndianWriter BW)
        {
            BW.Write(this.r);
            BW.Write(this.g);
            BW.Write(this.b);
            BW.Write(this.a);
        }

        [Category("Values")]
        public byte A
        {
            get
            {
                return this.a;
            }
            set
            {
                this.UpdateColor();
                this.a = value;
            }
        }

        [Category("Values")]
        public byte B
        {
            get
            {
                return this.b;
            }
            set
            {
                this.UpdateColor();
                this.b = value;
            }
        }

        [Category("Values")]
        public System.Drawing.Color Color
        {
            get
            {
                return this.color;
            }
            set
            {
                this.color = value;
                this.ConvertColor();
            }
        }

        [Category("Values")]
        public byte G
        {
            get
            {
                return this.g;
            }
            set
            {
                this.UpdateColor();
                this.g = value;
            }
        }

        [Category("Values")]
        public byte R
        {
            get
            {
                return this.r;
            }
            set
            {
                this.UpdateColor();
                this.r = value;
            }
        }
    }
}

