﻿namespace core.TagInterface
{
    using core.IO;
    using System;
    using System.ComponentModel;

    public class RealBounds : BaseObject
    {
        private float max;
        private float min;

        public RealBounds(string name) : base(name)
        {
            base.size = 8;
            base.type = BaseObjectType.RealBounds;
        }

        public override BaseObject Clone()
        {
            RealBounds bounds = new RealBounds(base.name);
            bounds.min = this.min;
            bounds.max = this.max;
            bounds.SetMetaOffset(base.MetaOffset);
            bounds.SetOffset(base.Offset);
            bounds.SetMapOffset(base.MapOffset);
            bounds.Name = base.Name;
            bounds.SetType(base.Type);
            return bounds;
        }

        public void Read(ref EndianIO.EndianReader BR)
        {
            this.min = BR.ReadSingle();
            this.max = BR.ReadSingle();
        }

        public void Write(ref EndianIO.EndianWriter BW)
        {
            BW.Write(this.min);
            BW.Write(this.max);
        }

        public float Maximum_Bounds
        {
            get
            {
                return this.max;
            }
            set
            {
                this.max = value;
            }
        }

        [Category("Values")]
        public float Minimum_Bounds
        {
            get
            {
                return this.min;
            }
            set
            {
                this.min = value;
            }
        }
    }
}

