﻿namespace core.TagInterface
{
    using core.IO;
    using System;
    using System.ComponentModel;

    public class RealEulerAngles3D : BaseObject
    {
        public Angle p;
        public Angle r;
        public Angle y;

        public RealEulerAngles3D(string name) : base(name)
        {
            this.y = new Angle(name);
            this.p = new Angle(name);
            this.r = new Angle(name);
            base.size = 12;
            base.type = BaseObjectType.RealEulerAngles3D;
        }

        public override BaseObject Clone()
        {
            RealEulerAngles3D anglesd = new RealEulerAngles3D(base.name);
            anglesd.y = (Angle) this.y.Clone();
            anglesd.p = (Angle) this.p.Clone();
            anglesd.r = (Angle) this.r.Clone();
            anglesd.SetMetaOffset(base.MetaOffset);
            anglesd.SetOffset(base.Offset);
            anglesd.SetMapOffset(base.MapOffset);
            anglesd.Name = base.Name;
            anglesd.SetType(base.Type);
            return anglesd;
        }

        public void Read(ref EndianIO.EndianReader BR)
        {
            this.y.Read(ref BR);
            this.p.Read(ref BR);
            this.r.Read(ref BR);
        }

        public void Write(ref EndianIO.EndianWriter BW)
        {
            this.y.Write(ref BW);
            this.p.Write(ref BW);
            this.r.Write(ref BW);
        }

        [Category("Values")]
        public Angle Pitch
        {
            get
            {
                return this.p;
            }
            set
            {
                this.p = value;
            }
        }

        [Category("Values")]
        public Angle Roll
        {
            get
            {
                return this.r;
            }
            set
            {
                this.r = value;
            }
        }

        [Category("Values")]
        public Angle Yaw
        {
            get
            {
                return this.y;
            }
            set
            {
                this.y = value;
            }
        }
    }
}

