﻿namespace core.TagInterface
{
    using core.IO;
    using System;
    using System.ComponentModel;

    public class RealFloat : BaseObject
    {
        public float Value;

        public RealFloat(string name) : base(name)
        {
            base.size = 4;
            base.type = BaseObjectType.RealFloat;
        }

        public override BaseObject Clone()
        {
            RealFloat num = new RealFloat(base.name);
            num.Value = this.Value;
            num.SetMetaOffset(base.MetaOffset);
            num.SetOffset(base.Offset);
            num.SetMapOffset(base.MapOffset);
            num.Name = base.Name;
            num.SetType(base.Type);
            return num;
        }

        public void Read(ref EndianIO.EndianReader BR)
        {
            this.Value = BR.ReadSingle();
        }

        public void Write(ref EndianIO.EndianWriter BW)
        {
            BW.Write(this.Value);
        }

        [Category("Values")]
        public float Float
        {
            get
            {
                return this.Value;
            }
            set
            {
                this.Value = value;
            }
        }
    }
}

