﻿namespace core.TagInterface
{
    using core.IO;
    using System;
    using System.ComponentModel;

    public class RealFraction : BaseObject
    {
        public float Value;

        public RealFraction(string name) : base(name)
        {
            base.size = 4;
            base.type = BaseObjectType.RealFraction;
        }

        public override BaseObject Clone()
        {
            RealFraction fraction = new RealFraction(base.name);
            fraction.Value = this.Value;
            fraction.SetMetaOffset(base.MetaOffset);
            fraction.SetOffset(base.Offset);
            fraction.SetMapOffset(base.MapOffset);
            fraction.Name = base.Name;
            fraction.SetType(base.Type);
            return fraction;
        }

        public void Read(ref EndianIO.EndianReader BR)
        {
            this.Value = BR.ReadSingle();
        }

        public void Write(ref EndianIO.EndianWriter BW)
        {
            BW.Write(this.Value);
        }

        [Category("Values")]
        public float Fraction
        {
            get
            {
                return this.Value;
            }
            set
            {
                this.Value = value;
            }
        }
    }
}

