﻿namespace core.TagInterface
{
    using core.IO;
    using System;
    using System.ComponentModel;

    public class RealPlane2D : BaseObject
    {
        private float d;
        private float i;
        private float j;

        public RealPlane2D(string name) : base(name)
        {
            base.size = 12;
            base.type = BaseObjectType.RealPlane2D;
        }

        public override BaseObject Clone()
        {
            RealPlane2D planed = new RealPlane2D(base.name);
            planed.i = this.i;
            planed.j = this.j;
            planed.d = this.d;
            planed.SetMetaOffset(base.MetaOffset);
            planed.SetOffset(base.Offset);
            planed.SetMapOffset(base.MapOffset);
            planed.Name = base.Name;
            planed.SetType(base.Type);
            return planed;
        }

        public void CopyFrom(RealPlane2D temp)
        {
            this.i = temp.i;
            this.j = temp.j;
            this.d = temp.d;
        }

        public void Read(ref EndianIO.EndianReader BR)
        {
            this.i = BR.ReadSingle();
            this.j = BR.ReadSingle();
            this.d = BR.ReadSingle();
        }

        public void Write(ref EndianIO.EndianWriter BW)
        {
            BW.Write(this.i);
            BW.Write(this.j);
            BW.Write(this.d);
        }

        [Category("Values")]
        public float D
        {
            get
            {
                return this.d;
            }
            set
            {
                this.d = value;
            }
        }

        [Category("Values")]
        public float I
        {
            get
            {
                return this.i;
            }
            set
            {
                this.i = value;
            }
        }

        [Category("Values")]
        public float J
        {
            get
            {
                return this.j;
            }
            set
            {
                this.j = value;
            }
        }
    }
}

