﻿namespace core.TagInterface
{
    using core.IO;
    using System;
    using System.ComponentModel;

    public class RealPlane3D : BaseObject
    {
        private float d;
        private float i;
        private float j;
        private float k;

        public RealPlane3D(string name) : base(name)
        {
            base.size = 0x10;
            base.type = BaseObjectType.RealPlane3D;
        }

        public override BaseObject Clone()
        {
            RealPlane3D planed = new RealPlane3D(base.name);
            planed.i = this.i;
            planed.j = this.j;
            planed.k = this.k;
            planed.d = this.d;
            planed.SetMetaOffset(base.MetaOffset);
            planed.SetOffset(base.Offset);
            planed.SetMapOffset(base.MapOffset);
            planed.Name = base.Name;
            planed.SetType(base.Type);
            return planed;
        }

        public void Read(ref EndianIO.EndianReader BR)
        {
            this.i = BR.ReadSingle();
            this.j = BR.ReadSingle();
            this.k = BR.ReadSingle();
            this.d = BR.ReadSingle();
        }

        public void Write(ref EndianIO.EndianWriter BW)
        {
            BW.Write(this.i);
            BW.Write(this.j);
            BW.Write(this.k);
            BW.Write(this.d);
        }

        [Category("Values")]
        public float D
        {
            get
            {
                return this.d;
            }
            set
            {
                this.d = value;
            }
        }

        [Category("Values")]
        public float I
        {
            get
            {
                return this.i;
            }
            set
            {
                this.i = value;
            }
        }

        [Category("Values")]
        public float J
        {
            get
            {
                return this.j;
            }
            set
            {
                this.j = value;
            }
        }

        [Category("Values")]
        public float K
        {
            get
            {
                return this.k;
            }
            set
            {
                this.k = value;
            }
        }
    }
}

