﻿namespace core.TagInterface
{
    using core.IO;
    using System;
    using System.ComponentModel;

    public class RealPoint2D : BaseObject
    {
        private float x;
        private float y;

        public RealPoint2D(string name) : base(name)
        {
            base.size = 8;
            base.type = BaseObjectType.RealPoint2D;
        }

        public override BaseObject Clone()
        {
            RealPoint2D pointd = new RealPoint2D(base.name);
            pointd.x = this.x;
            pointd.y = this.y;
            pointd.SetMetaOffset(base.MetaOffset);
            pointd.SetOffset(base.Offset);
            pointd.SetMapOffset(base.MapOffset);
            pointd.Name = base.Name;
            pointd.SetType(base.Type);
            return pointd;
        }

        public void CopyFrom(RealPoint2D temp)
        {
            this.x = temp.x;
            this.y = temp.y;
        }

        public void Read(ref EndianIO.EndianReader BR)
        {
            this.x = BR.ReadSingle();
            this.y = BR.ReadSingle();
        }

        public void Write(ref EndianIO.EndianWriter BW)
        {
            BW.Write(this.x);
            BW.Write(this.y);
        }

        [Category("Values")]
        public float X
        {
            get
            {
                return this.x;
            }
            set
            {
                this.x = value;
            }
        }

        [Category("Values")]
        public float Y
        {
            get
            {
                return this.y;
            }
            set
            {
                this.y = value;
            }
        }
    }
}

