﻿namespace core.TagInterface
{
    using core.IO;
    using System;
    using System.ComponentModel;

    public class RealPoint3D : BaseObject
    {
        private float x;
        private float y;
        private float z;

        public RealPoint3D(string name) : base(name)
        {
            base.size = 12;
            base.type = BaseObjectType.RealPoint3D;
        }

        public override BaseObject Clone()
        {
            RealPoint3D pointd = new RealPoint3D(base.name);
            pointd.x = this.x;
            pointd.y = this.y;
            pointd.z = this.z;
            pointd.SetMetaOffset(base.MetaOffset);
            pointd.SetOffset(base.Offset);
            pointd.SetMapOffset(base.MapOffset);
            pointd.Name = base.Name;
            pointd.SetType(base.Type);
            return pointd;
        }

        public void Read(ref EndianIO.EndianReader BR)
        {
            this.x = BR.ReadSingle();
            this.y = BR.ReadSingle();
            this.z = BR.ReadSingle();
        }

        public void Write(ref EndianIO.EndianWriter BW)
        {
            BW.Write(this.x);
            BW.Write(this.y);
            BW.Write(this.z);
        }

        [Category("Values")]
        public float X
        {
            get
            {
                return this.x;
            }
            set
            {
                this.x = value;
            }
        }

        [Category("Values")]
        public float Y
        {
            get
            {
                return this.y;
            }
            set
            {
                this.y = value;
            }
        }

        [Category("Values")]
        public float Z
        {
            get
            {
                return this.z;
            }
            set
            {
                this.z = value;
            }
        }
    }
}

