﻿namespace core.TagInterface
{
    using core.IO;
    using System;
    using System.ComponentModel;

    public class RealQuaternion : BaseObject
    {
        private float i;
        private float j;
        private float k;
        private float w;

        public RealQuaternion(string name) : base(name)
        {
            base.size = 0x10;
            base.type = BaseObjectType.RealQuaternion;
        }

        public override BaseObject Clone()
        {
            RealQuaternion quaternion = new RealQuaternion(base.name);
            quaternion.i = this.i;
            quaternion.j = this.j;
            quaternion.k = this.k;
            quaternion.w = this.w;
            quaternion.SetMetaOffset(base.MetaOffset);
            quaternion.SetOffset(base.Offset);
            quaternion.SetMapOffset(base.MapOffset);
            quaternion.Name = base.Name;
            quaternion.SetType(base.Type);
            return quaternion;
        }

        public void Read(ref EndianIO.EndianReader BR)
        {
            this.i = BR.ReadSingle();
            this.j = BR.ReadSingle();
            this.k = BR.ReadSingle();
            this.w = BR.ReadSingle();
        }

        public void Write(ref EndianIO.EndianWriter BW)
        {
            BW.Write(this.i);
            BW.Write(this.j);
            BW.Write(this.k);
            BW.Write(this.w);
        }

        [Category("Values")]
        public float I
        {
            get
            {
                return this.i;
            }
            set
            {
                this.i = value;
            }
        }

        [Category("Values")]
        public float J
        {
            get
            {
                return this.j;
            }
            set
            {
                this.j = value;
            }
        }

        [Category("Values")]
        public float K
        {
            get
            {
                return this.k;
            }
            set
            {
                this.k = value;
            }
        }

        [Category("Values")]
        public float W
        {
            get
            {
                return this.w;
            }
            set
            {
                this.w = value;
            }
        }
    }
}

