﻿namespace core.TagInterface
{
    using core.IO;
    using System;
    using System.ComponentModel;

    public class RealVector3D : BaseObject
    {
        private float i;
        private float j;
        private float k;

        public RealVector3D(string name) : base(name)
        {
            base.size = 12;
            base.type = BaseObjectType.RealVector3D;
        }

        public override BaseObject Clone()
        {
            RealVector3D vectord = new RealVector3D(base.name);
            vectord.i = this.i;
            vectord.j = this.j;
            vectord.k = this.k;
            vectord.SetMetaOffset(base.MetaOffset);
            vectord.SetOffset(base.Offset);
            vectord.SetMapOffset(base.MapOffset);
            vectord.Name = base.Name;
            vectord.SetType(base.Type);
            return vectord;
        }

        public void Read(ref EndianIO.EndianReader BR)
        {
            this.i = BR.ReadSingle();
            this.j = BR.ReadSingle();
            this.k = BR.ReadSingle();
        }

        public void Write(ref EndianIO.EndianWriter BW)
        {
            BW.Write(this.i);
            BW.Write(this.j);
            BW.Write(this.k);
        }

        [Category("Values")]
        public float I
        {
            get
            {
                return this.i;
            }
            set
            {
                this.i = value;
            }
        }

        [Category("Values")]
        public float J
        {
            get
            {
                return this.j;
            }
            set
            {
                this.j = value;
            }
        }

        [Category("Values")]
        public float K
        {
            get
            {
                return this.k;
            }
            set
            {
                this.k = value;
            }
        }
    }
}

