﻿namespace core.TagInterface
{
    using core.IO;
    using System;
    using System.ComponentModel;

    public class ShortInteger : BaseObject
    {
        public short Value;

        public ShortInteger(string name) : base(name)
        {
            base.size = 2;
            base.type = BaseObjectType.ShortInteger;
        }

        public override BaseObject Clone()
        {
            ShortInteger integer = new ShortInteger(base.name);
            integer.Value = this.Value;
            return integer;
        }

        public void Read(ref EndianIO.EndianReader BR)
        {
            this.Value = BR.ReadInt16();
        }

        public void Write(ref EndianIO.EndianWriter BW)
        {
            BW.Write(this.Value);
        }

        [Category("Values")]
        public short Short
        {
            get
            {
                return this.Value;
            }
            set
            {
                this.Value = value;
            }
        }
    }
}

