﻿namespace core.TagInterface
{
    using core;
    using core.IO;
    using System;
    using System.ComponentModel;
    using System.IO;

    public class Sound_Raw : Data
    {
        protected RawDataOffset raw_offset;
        public short unk1;

        public Sound_Raw(string name, Map.HaloVersionEnum haloversion) : base(name, haloversion, Data.RawDataTypes.H2_ugh_sound)
        {
            this.raw_offset = new RawDataOffset("Raw Offset");
            base.type = BaseObjectType.Sound_Raw;
        }

        public override BaseObject Clone()
        {
            Sound_Raw raw = new Sound_Raw(base.name, base.HaloVersion);
            raw.ms = new MemoryStream(base.rawdatasize);
            if (base.ms != null)
            {
                raw.ms.Write(base.ms.ToArray(), 0, base.rawdatasize);
            }
            raw.rawdatasize = base.rawdatasize;
            raw.size = base.size;
            raw.raw_offset = (RawDataOffset) this.raw_offset.Clone();
            raw.SetMetaOffset(base.MetaOffset);
            raw.SetOffset(base.Offset);
            raw.SetMapOffset(base.MapOffset);
            raw.Name = base.Name;
            raw.SetType(base.Type);
            return raw;
        }

        public override void Read(ref EndianIO.EndianReader BR)
        {
            this.raw_offset.Read(ref BR);
            base.rawdatasize = BR.ReadUInt16();
            this.unk1 = BR.ReadInt16();
        }

        public override void Write(ref EndianIO.EndianWriter BW)
        {
            this.raw_offset.Write(ref BW);
            ushort test = (ushort)base.rawdatasize;
            BW.Write((ushort) base.rawdatasize);
            BW.Write(this.unk1);
        }

        [TypeConverter(typeof(MetaInterface.BaseObjectConverter))]
        public RawDataOffset Raw_Offset
        {
            get
            {
                return this.raw_offset;
            }
        }
    }
}

