﻿namespace core.TagInterface
{
    using core;
    using System;

    public class TagDefinition
    {
        private string extension;
        private string filepath;
        private TagBlockLayout hard_coded_layout;
        private short iD;
        private TagMode mode;
        private string tagType;
        private TagBlockLayout xml_layout;

        public TagDefinition()
        {
            this.mode = TagMode.Hard_Coded;
        }

        public TagDefinition(string tagtype, TagBlockLayout layout, short id, string extension)
        {
            this.mode = TagMode.Hard_Coded;
            this.tagType = tagtype;
            this.hard_coded_layout = layout;
            this.extension = extension;
            this.iD = id;
            this.mode = TagMode.Hard_Coded;
        }

        public TagDefinition(string tagtype, string filepath, short id, string extension)
        {
            this.mode = TagMode.Hard_Coded;
            this.tagType = tagtype;
            this.filepath = filepath;
            this.xml_layout = EntIO.ReadEnt(filepath);
            this.extension = extension;
            this.iD = id;
            this.mode = TagMode.XML;
        }

        public TagDefinition(string tagtype, TagBlockLayout hard_coded_layout, string layout_filepath, short id, string extension, TagMode mode)
        {
            this.mode = TagMode.Hard_Coded;
            this.tagType = tagtype;
            this.hard_coded_layout = hard_coded_layout;
            this.extension = extension;
            this.filepath = layout_filepath;
            this.xml_layout = EntIO.ReadEnt(this.filepath);
            this.iD = id;
            this.mode = mode;
        }

        public string Extension
        {
            get
            {
                return this.extension;
            }
        }

        public string FilePath
        {
            get
            {
                return this.filepath;
            }
            set
            {
                this.filepath = value;
            }
        }

        public TagBlockLayout Hard_Coded_Layout
        {
            get
            {
                return this.hard_coded_layout;
            }
            set
            {
                this.hard_coded_layout = value;
            }
        }

        public short ID
        {
            get
            {
                return this.iD;
            }
        }

        public TagBlockLayout Layout
        {
            get
            {
                if (this.mode == TagMode.XML)
                {
                    return this.xml_layout;
                }
                return this.hard_coded_layout;
            }
        }

        public TagMode Mode
        {
            get
            {
                return this.mode;
            }
            set
            {
                this.mode = value;
            }
        }

        public string TagType
        {
            get
            {
                return this.tagType;
            }
        }

        public TagBlockLayout XML_Layout
        {
            get
            {
                return this.xml_layout;
            }
            set
            {
                this.xml_layout = value;
            }
        }

        public enum TagMode
        {
            XML,
            Hard_Coded
        }
    }
}

