﻿namespace core.Rebuilder
{
    using core;
    using core.H2;
    using core.IO;
    using core.TagInterface;
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.Drawing;
    using System.IO;
    using System.Windows.Forms;

    public class Rebuilder : Form
    {
        private List<string> addedfilepaths;
        private Button browseforscenario;
        private IContainer components = null;
        private CheckBox deathzones;
        private RichTextBox debugbox;
        private GroupBox groupBox1;
        private List<int> idents;
        private CheckBox keepexistingspawns;
        private Label label1;
        private Map map;
        private List<MetaInterface> metas;
        private Button RebuildButton;
        private CheckBox sbspdecals;
        private CheckBox sbsplights;
        private CheckBox sbsploopingsounds;
        private CheckBox sbspmachine;
        private CheckBox sbspobstacle;
        private CheckBox sbspscenery;
        private CheckBox sbspskies;
        private CheckBox sbspsoundscenery;
        private TextBox scenariopath;
        private List<string> stringids;
        private uint tempident;
        private CheckBox transferdecr;
        private CheckBox vehicles;
        private CheckBox weapons;

        public Rebuilder(Map map)
        {
            this.InitializeComponent();
            this.map = map;
        }

        private void browseforscenario_Click(object sender, EventArgs e)
        {
            OpenFileDialog dialog = new OpenFileDialog();
            dialog.RestoreDirectory = true;
            dialog.InitialDirectory = ProgramSettings.DecompiledTagsPath;
            dialog.Filter = "Scenario (*." + Tag_Layouts.h2tagdefs.GetTagDefinitionByTagType("scnr").Extension + ")|*." + Tag_Layouts.h2tagdefs.GetTagDefinitionByTagType("scnr").Extension;
            if (dialog.ShowDialog() != DialogResult.Cancel)
            {
                this.scenariopath.Text = dialog.FileName;
            }
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing && (this.components != null))
            {
                this.components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void InitializeComponent()
        {
            this.scenariopath = new TextBox();
            this.label1 = new Label();
            this.browseforscenario = new Button();
            this.RebuildButton = new Button();
            this.debugbox = new RichTextBox();
            this.sbspscenery = new CheckBox();
            this.sbspmachine = new CheckBox();
            this.sbspobstacle = new CheckBox();
            this.sbspdecals = new CheckBox();
            this.sbspskies = new CheckBox();
            this.sbsploopingsounds = new CheckBox();
            this.sbspsoundscenery = new CheckBox();
            this.transferdecr = new CheckBox();
            this.sbsplights = new CheckBox();
            this.keepexistingspawns = new CheckBox();
            this.vehicles = new CheckBox();
            this.deathzones = new CheckBox();
            this.groupBox1 = new GroupBox();
            this.weapons = new CheckBox();
            this.groupBox1.SuspendLayout();
            base.SuspendLayout();
            this.scenariopath.BorderStyle = BorderStyle.FixedSingle;
            this.scenariopath.Location = new Point(0x53, 12);
            this.scenariopath.Name = "scenariopath";
            this.scenariopath.Size = new Size(0x1bf, 20);
            this.scenariopath.TabIndex = 0;
            this.label1.AutoSize = true;
            this.label1.Font = new Font("Microsoft Sans Serif", 12f, FontStyle.Regular, GraphicsUnit.Point, 0);
            this.label1.Location = new Point(1, 11);
            this.label1.Name = "label1";
            this.label1.Size = new Size(0x4c, 20);
            this.label1.TabIndex = 1;
            this.label1.Text = "Scenario:";
            this.browseforscenario.FlatStyle = FlatStyle.Flat;
            this.browseforscenario.Location = new Point(0x218, 12);
            this.browseforscenario.Name = "browseforscenario";
            this.browseforscenario.Size = new Size(0x4b, 0x15);
            this.browseforscenario.TabIndex = 2;
            this.browseforscenario.Text = "...";
            this.browseforscenario.UseVisualStyleBackColor = true;
            this.browseforscenario.Click += new EventHandler(this.browseforscenario_Click);
            this.RebuildButton.FlatStyle = FlatStyle.Flat;
            this.RebuildButton.Location = new Point(0x218, 0x26);
            this.RebuildButton.Name = "RebuildButton";
            this.RebuildButton.Size = new Size(0x4b, 0x15);
            this.RebuildButton.TabIndex = 3;
            this.RebuildButton.Text = "Rebuild";
            this.RebuildButton.UseVisualStyleBackColor = true;
            this.RebuildButton.Click += new EventHandler(this.RebuildButton_Click);
            this.debugbox.BorderStyle = BorderStyle.FixedSingle;
            this.debugbox.Dock = DockStyle.Bottom;
            this.debugbox.Location = new Point(0, 0x90);
            this.debugbox.Name = "debugbox";
            this.debugbox.Size = new Size(620, 0x87);
            this.debugbox.TabIndex = 4;
            this.debugbox.Text = "";
            this.sbspscenery.AutoSize = true;
            this.sbspscenery.Location = new Point(6, 0x17);
            this.sbspscenery.Name = "sbspscenery";
            this.sbspscenery.Size = new Size(0x41, 0x11);
            this.sbspscenery.TabIndex = 5;
            this.sbspscenery.Text = "Scenery";
            this.sbspscenery.UseVisualStyleBackColor = true;
            this.sbspmachine.AutoSize = true;
            this.sbspmachine.Location = new Point(6, 0x2e);
            this.sbspmachine.Name = "sbspmachine";
            this.sbspmachine.Size = new Size(0x48, 0x11);
            this.sbspmachine.TabIndex = 6;
            this.sbspmachine.Text = "Machines";
            this.sbspmachine.UseVisualStyleBackColor = true;
            this.sbspobstacle.AutoSize = true;
            this.sbspobstacle.Location = new Point(0x4e, 0x17);
            this.sbspobstacle.Name = "sbspobstacle";
            this.sbspobstacle.Size = new Size(0x49, 0x11);
            this.sbspobstacle.TabIndex = 7;
            this.sbspobstacle.Text = "Obstacles";
            this.sbspobstacle.UseVisualStyleBackColor = true;
            this.sbspdecals.AutoSize = true;
            this.sbspdecals.Location = new Point(0x4e, 0x2e);
            this.sbspdecals.Name = "sbspdecals";
            this.sbspdecals.Size = new Size(0x3b, 0x11);
            this.sbspdecals.TabIndex = 8;
            this.sbspdecals.Text = "Decals";
            this.sbspdecals.UseVisualStyleBackColor = true;
            this.sbspskies.AutoSize = true;
            this.sbspskies.Location = new Point(6, 0x45);
            this.sbspskies.Name = "sbspskies";
            this.sbspskies.Size = new Size(0x34, 0x11);
            this.sbspskies.TabIndex = 9;
            this.sbspskies.Text = "Skies";
            this.sbspskies.UseVisualStyleBackColor = true;
            this.sbsploopingsounds.AutoSize = true;
            this.sbsploopingsounds.Location = new Point(0x9d, 0x45);
            this.sbsploopingsounds.Name = "sbsploopingsounds";
            this.sbsploopingsounds.Size = new Size(0x67, 0x11);
            this.sbsploopingsounds.TabIndex = 11;
            this.sbsploopingsounds.Text = "Looping Sounds";
            this.sbsploopingsounds.UseVisualStyleBackColor = true;
            this.sbspsoundscenery.AutoSize = true;
            this.sbspsoundscenery.Location = new Point(0x9d, 0x17);
            this.sbspsoundscenery.Name = "sbspsoundscenery";
            this.sbspsoundscenery.Size = new Size(0x63, 0x11);
            this.sbspsoundscenery.TabIndex = 12;
            this.sbspsoundscenery.Text = "Sound Scenery";
            this.sbspsoundscenery.UseVisualStyleBackColor = true;
            this.transferdecr.AutoSize = true;
            this.transferdecr.Location = new Point(0x9d, 0x2e);
            this.transferdecr.Name = "transferdecr";
            this.transferdecr.Size = new Size(0x38, 0x11);
            this.transferdecr.TabIndex = 13;
            this.transferdecr.Text = "DECR";
            this.transferdecr.UseVisualStyleBackColor = true;
            this.sbsplights.AutoSize = true;
            this.sbsplights.Location = new Point(0x4e, 0x45);
            this.sbsplights.Name = "sbsplights";
            this.sbsplights.Size = new Size(0x36, 0x11);
            this.sbsplights.TabIndex = 14;
            this.sbsplights.Text = "Lights";
            this.sbsplights.UseVisualStyleBackColor = true;
            this.keepexistingspawns.AutoSize = true;
            this.keepexistingspawns.Location = new Point(0x170, 0x3d);
            this.keepexistingspawns.Name = "keepexistingspawns";
            this.keepexistingspawns.Size = new Size(0x83, 0x11);
            this.keepexistingspawns.TabIndex = 15;
            this.keepexistingspawns.Text = "Keep Existing Spawns";
            this.keepexistingspawns.UseVisualStyleBackColor = true;
            this.vehicles.AutoSize = true;
            this.vehicles.Location = new Point(0x106, 0x17);
            this.vehicles.Name = "vehicles";
            this.vehicles.Size = new Size(0x42, 0x11);
            this.vehicles.TabIndex = 0x10;
            this.vehicles.Text = "Vehicles";
            this.vehicles.UseVisualStyleBackColor = true;
            this.deathzones.AutoSize = true;
            this.deathzones.Location = new Point(0x106, 0x2e);
            this.deathzones.Name = "deathzones";
            this.deathzones.Size = new Size(0x53, 0x11);
            this.deathzones.TabIndex = 0x11;
            this.deathzones.Text = "Death Zone";
            this.deathzones.UseVisualStyleBackColor = true;
            this.groupBox1.Controls.Add(this.weapons);
            this.groupBox1.Controls.Add(this.sbspmachine);
            this.groupBox1.Controls.Add(this.deathzones);
            this.groupBox1.Controls.Add(this.sbspscenery);
            this.groupBox1.Controls.Add(this.vehicles);
            this.groupBox1.Controls.Add(this.sbspobstacle);
            this.groupBox1.Controls.Add(this.sbspdecals);
            this.groupBox1.Controls.Add(this.sbsplights);
            this.groupBox1.Controls.Add(this.sbspskies);
            this.groupBox1.Controls.Add(this.transferdecr);
            this.groupBox1.Controls.Add(this.sbsploopingsounds);
            this.groupBox1.Controls.Add(this.sbspsoundscenery);
            this.groupBox1.Location = new Point(5, 0x26);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new Size(0x165, 100);
            this.groupBox1.TabIndex = 0x12;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "Spawns To Transfer";
            this.weapons.AutoSize = true;
            this.weapons.Location = new Point(0x106, 0x45);
            this.weapons.Name = "weapons";
            this.weapons.Size = new Size(0x48, 0x11);
            this.weapons.TabIndex = 0x12;
            this.weapons.Text = "Weapons";
            this.weapons.UseVisualStyleBackColor = true;
            base.AutoScaleDimensions = new SizeF(6f, 13f);
            base.AutoScaleMode = AutoScaleMode.Font;
            base.ClientSize = new Size(620, 0x117);
            base.Controls.Add(this.groupBox1);
            base.Controls.Add(this.keepexistingspawns);
            base.Controls.Add(this.debugbox);
            base.Controls.Add(this.RebuildButton);
            base.Controls.Add(this.browseforscenario);
            base.Controls.Add(this.label1);
            base.Controls.Add(this.scenariopath);
            base.Name = "Rebuilder";
            this.Text = "Rebuilder";
            base.Load += new EventHandler(this.Rebuilder_Load);
            this.groupBox1.ResumeLayout(false);
            this.groupBox1.PerformLayout();
            base.ResumeLayout(false);
            base.PerformLayout();
        }

        private void LoadMeta(Meta m)
        {
        }

        private void LoadScenarioFirst(string filename)
        {
            if (this.addedfilepaths.IndexOf(filename) == -1)
            {
                try
                {
                    DecompiledTagInterface item = new DecompiledTagInterface(filename, Map.HaloVersionEnum.Halo2, false);
                    this.debugbox.Text = "Processing " + filename + "...\n";
                    Application.DoEvents();
                    this.metas.Add(item);
                    this.addedfilepaths.Add(filename);
                    this.idents.Add((int) this.tempident);
                    this.tempident += 0x10001;
                }
                catch
                {
                    MessageBox.Show("Error");
                }
            }
        }

        private void RebuildButton_Click(object sender, EventArgs e)
        {
            int num12;
            int num13;
            TagBlock block2;
            TagReference reference;
            string str2;
            TagIdent ident;
            MetaInterface current;
            List<int> list2;
            List<int> list3;
            int num20;
            this.addedfilepaths = new List<string>();
            this.metas = new List<MetaInterface>();
            this.idents = new List<int>();
            this.stringids = new List<string>();
            foreach (Map.StringID gid in this.map.strings)
            {
                this.stringids.Add(gid.Name);
            }
            this.tempident = 0xe1740000;
            this.debugbox.Text = "Starting rebuild...\n";
            Application.DoEvents();
            Meta meta = this.map.matg_Meta;
            matg matg = (matg) meta.Interface.Header.Chunks[0];
            this.metas.Add(meta.Interface);
            this.addedfilepaths.Add(Tag_Layouts.GetFullTagPath(meta.Name, meta.TagType, Map.HaloVersionEnum.Halo2));
            this.idents.Add((int) this.tempident);
            this.tempident += 0x10001;
            ugh_ h_ = this.map.ugh_Interface;
            Meta meta2 = new Meta(1, ref this.map);
            sncl sncl = (sncl) meta2.Interface.Header.Chunks[0];
            this.metas.Add(meta2.Interface);
            this.addedfilepaths.Add(Tag_Layouts.GetFullTagPath(meta2.Name, meta2.TagType, Map.HaloVersionEnum.Halo2));
            this.idents.Add((int) this.tempident);
            this.tempident += 0x10001;
            Meta meta3 = new Meta(2, ref this.map);
            spk_ k_ = (spk_) meta3.Interface.Header.Chunks[0];
            this.metas.Add(meta3.Interface);
            this.addedfilepaths.Add(Tag_Layouts.GetFullTagPath(meta3.Name, meta3.TagType, Map.HaloVersionEnum.Halo2));
            this.idents.Add((int) this.tempident);
            this.tempident += 0x10001;
            this.LoadScenarioFirst(this.scenariopath.Text);
            scnr scnr = (scnr) this.metas[3].Header.Chunks[0];
            List<int[]> list = new List<int[]>();
            if (((((this.sbspscenery.Checked || this.sbspmachine.Checked) || (this.sbspobstacle.Checked || this.sbspskies.Checked)) || ((this.sbspsoundscenery.Checked || this.sbsploopingsounds.Checked) || (this.transferdecr.Checked || this.sbspdecals.Checked))) || (this.vehicles.Checked || this.deathzones.Checked)) || this.weapons.Checked)
            {
                int chunkCount = 0;
                int num2 = 0;
                int num3 = 0;
                int num4 = 0;
                int num5 = 0;
                int num6 = 0;
                int num7 = 0;
                int num8 = 0;
                int num9 = 0;
                int num10 = 0;
                int num11 = 0;
                if (!this.keepexistingspawns.Checked)
                {
                    if (this.sbspscenery.Checked)
                    {
                        scnr.Scenery_Placement.RemoveAllChunks();
                        scnr.Scenery_Palette.RemoveAllChunks();
                    }
                    if (this.sbspmachine.Checked)
                    {
                        scnr.Machine_Placement.RemoveAllChunks();
                        scnr.Machine_Palette.RemoveAllChunks();
                        scnr.Control_Palette.RemoveAllChunks();
                        scnr.Control_Placement.RemoveAllChunks();
                        scnr.Device_Groups.RemoveAllChunks();
                    }
                    if (this.sbspobstacle.Checked)
                    {
                        scnr.Obstacle_Placement.RemoveAllChunks();
                        scnr.Obstacle_Palette.RemoveAllChunks();
                    }
                    if (this.sbspskies.Checked)
                    {
                        scnr.Sky_Palette.RemoveAllChunks();
                    }
                    if (this.sbspsoundscenery.Checked)
                    {
                        scnr.Sound_Scenery_Palette.RemoveAllChunks();
                        scnr.Sound_Scenery_Placement.RemoveAllChunks();
                    }
                    if (this.sbsploopingsounds.Checked)
                    {
                        scnr.Background_Sound_Palette.RemoveAllChunks();
                    }
                    if (this.sbsplights.Checked)
                    {
                        scnr.Light_Volumes_Palette.RemoveAllChunks();
                        scnr.Light_Volumes_Placement.RemoveAllChunks();
                    }
                    if (this.vehicles.Checked)
                    {
                        scnr.Vehicle_Palette.RemoveAllChunks();
                        scnr.Vehicle_Placement.RemoveAllChunks();
                    }
                    if (this.deathzones.Checked)
                    {
                        scnr.Scenario_Kill_Triggers.RemoveAllChunks();
                        scnr.Trigger_Volumes.RemoveAllChunks();
                    }
                    if (this.weapons.Checked)
                    {
                        scnr.Weapon_Palette.RemoveAllChunks();
                        scnr.Weapon_Placement.RemoveAllChunks();
                    }
                }
                else
                {
                    chunkCount = scnr.Scenery_Palette.ChunkCount;
                    num2 = scnr.Machine_Palette.ChunkCount;
                    num3 = scnr.Obstacle_Palette.ChunkCount;
                    num4 = scnr.Obstacle_Palette.ChunkCount;
                    num5 = scnr.Background_Sound_Palette.ChunkCount;
                    num6 = scnr.Sound_Scenery_Palette.ChunkCount;
                    num7 = scnr.Device_Groups.ChunkCount;
                    num8 = scnr.Control_Palette.ChunkCount;
                    num9 = scnr.Vehicle_Palette.ChunkCount;
                    num10 = scnr.Weapon_Palette.ChunkCount;
                    num11 = scnr.Trigger_Volumes.ChunkCount;
                }
                foreach (scnr.Structure_BSPS_Layout layout in scnr.Structure_BSPS.Chunks)
                {
                    string str = ProgramSettings.DecompiledTagsPath + @"\H2\" + layout.Structure_BSP_0.GetTagPath();
                    num12 = str.LastIndexOf(".");
                    EndianIO nio = new EndianIO(str.Substring(0, num12) + ".psr", EndianType.BigEndian);
                    nio.Open();
                    nio.In.SeekTo(0);
                    TagBlock tagblock = new TagBlock("", Predicted_Scenario_Resources.Layout, 1, Map.HaloVersionEnum.Halo2);
                    DecompiledTagInterface.RecursivelyReadElements(tagblock, ref nio.In, Map.HaloVersionEnum.Halo2);
                    Predicted_Scenario_Resources chunk = (Predicted_Scenario_Resources) tagblock.GetChunk(0);
                    nio.Close();
                    if (this.sbspscenery.Checked)
                    {
                        num13 = 0;
                        while (num13 < chunk.scenery_pallete.ChunkCount)
                        {
                            scnr.Scenery_Palette.AddChunk(chunk.scenery_pallete.Chunks[num13]);
                            num13++;
                        }
                        num13 = 0;
                        while (num13 < chunk.scenery_placement.ChunkCount)
                        {
                            scnr.Scenery_Placement_Layout tagblocklayout = (scnr.Scenery_Placement_Layout) chunk.scenery_placement.Chunks[num13];
                            tagblocklayout.Scenery_Chunk__Number_.Value = (short) (tagblocklayout.Scenery_Chunk__Number_.Value + ((short) chunkCount));
                            tagblocklayout.bsp_index_1.Value = (short) layout.Chunk_Number;
                            tagblocklayout.bsp_index_2.Value = (short) layout.Chunk_Number;
                            scnr.Scenery_Placement.AddChunk(tagblocklayout);
                            num13++;
                        }
                        chunkCount += chunk.scenery_pallete.ChunkCount;
                    }
                    if (this.sbspmachine.Checked)
                    {
                        num13 = 0;
                        while (num13 < chunk.device_groups.ChunkCount)
                        {
                            scnr.Device_Groups.AddChunk(chunk.device_groups.Chunks[num13]);
                            num13++;
                        }
                        num13 = 0;
                        while (num13 < chunk.machine_pallete.ChunkCount)
                        {
                            scnr.Machine_Palette.AddChunk(chunk.machine_pallete.Chunks[num13]);
                            num13++;
                        }
                        num13 = 0;
                        while (num13 < chunk.machine_placement.ChunkCount)
                        {
                            scnr.Machine_Placement_Layout layout3 = (scnr.Machine_Placement_Layout) chunk.machine_placement.Chunks[num13];
                            layout3.Palette_Chunk__Number_.Value = (short) (layout3.Palette_Chunk__Number_.Value + ((short) num2));
                            layout3.bsp_index_1.Value = (short) layout.Chunk_Number;
                            if (layout3.Device_Group_Chunk__Number_.Value != -1)
                            {
                                layout3.Device_Group_Chunk__Number_.Value = (short) (layout3.Device_Group_Chunk__Number_.Value + ((short) num7));
                            }
                            scnr.Machine_Placement.AddChunk(layout3);
                            num13++;
                        }
                        num2 += chunk.machine_pallete.ChunkCount;
                        num13 = 0;
                        while (num13 < chunk.control_pallete.ChunkCount)
                        {
                            scnr.Control_Palette.AddChunk(chunk.control_pallete.Chunks[num13]);
                            num13++;
                        }
                        num13 = 0;
                        while (num13 < chunk.control_placement.ChunkCount)
                        {
                            scnr.Control_Placement_Layout layout4 = (scnr.Control_Placement_Layout) chunk.control_placement.Chunks[num13];
                            layout4.Palette_Chunk__Number_.Value = (short) (layout4.Palette_Chunk__Number_.Value + ((short) num8));
                            layout4.bsp_index_1.Value = (short) layout.Chunk_Number;
                            if (layout4.Device_Group_Chunk__Number_.Value != -1)
                            {
                                layout4.Device_Group_Chunk__Number_.Value = (short) (layout4.Device_Group_Chunk__Number_.Value + ((short) num7));
                            }
                            scnr.Control_Placement.AddChunk(layout4);
                            num13++;
                        }
                        num8 += chunk.control_pallete.ChunkCount;
                        num7 += chunk.device_groups.ChunkCount;
                    }
                    if (this.sbsplights.Checked)
                    {
                        foreach (scnr.Light_Volumes_Palette_Layout layout5 in chunk.light_pallete.Chunks)
                        {
                            scnr.Light_Volumes_Palette.AddChunk(layout5);
                        }
                        foreach (scnr.Light_Volumes_Placement_Layout layout6 in chunk.light_placement.Chunks)
                        {
                            scnr.Light_Volumes_Placement.AddChunk(layout6);
                        }
                    }
                    if (this.sbspobstacle.Checked)
                    {
                        num13 = 0;
                        while (num13 < chunk.obstacle_pallete.ChunkCount)
                        {
                            scnr.Obstacle_Palette.AddChunk(chunk.obstacle_pallete.Chunks[num13]);
                            num13++;
                        }
                        num13 = 0;
                        while (num13 < chunk.obstacle_placement.ChunkCount)
                        {
                            scnr.Obstacle_Placement_Layout layout7 = (scnr.Obstacle_Placement_Layout) chunk.obstacle_placement.Chunks[num13];
                            layout7.Palette_Chunk__Number_.Value = (short) (layout7.Palette_Chunk__Number_.Value + ((short) num3));
                            layout7.bsp_index_1.Value = (short) layout.Chunk_Number;
                            scnr.Obstacle_Placement.AddChunk(layout7);
                            num13++;
                        }
                        num3 += chunk.obstacle_pallete.ChunkCount;
                    }
                    if (this.sbspsoundscenery.Checked)
                    {
                        num13 = 0;
                        while (num13 < chunk.sound_scenery_palette.ChunkCount)
                        {
                            scnr.Sound_Scenery_Palette.AddChunk(chunk.sound_scenery_palette.Chunks[num13]);
                            num13++;
                        }
                        num13 = 0;
                        while (num13 < chunk.sound_scenery_placement.ChunkCount)
                        {
                            scnr.Sound_Scenery_Placement_Layout layout8 = (scnr.Sound_Scenery_Placement_Layout) chunk.sound_scenery_placement.Chunks[num13];
                            layout8.palette_index.Value = (short) (layout8.palette_index.Value + ((short) num6));
                            layout8.bsp_index.Value = (short) layout.Chunk_Number;
                            scnr.Sound_Scenery_Placement.AddChunk(layout8);
                            num13++;
                        }
                        num6 += chunk.sound_scenery_palette.ChunkCount;
                    }
                    if (this.sbsploopingsounds.Checked)
                    {
                        num13 = 0;
                        while (num13 < chunk.looping_sounds.ChunkCount)
                        {
                            scnr.Background_Sound_Palette_Layout layout9 = (scnr.Background_Sound_Palette_Layout) chunk.looping_sounds.Chunks[num13];
                            scnr.Background_Sound_Palette.AddChunk(layout9);
                            num13++;
                        }
                    }
                    if (this.sbspskies.Checked)
                    {
                        foreach (scnr.Sky_Palette_Layout layout10 in chunk.sky_pallete.Chunks)
                        {
                            scnr.Sky_Palette.AddChunk(layout10);
                        }
                        int[] item = new int[chunk.sky_indexes.ChunkCount];
                        foreach (Predicted_Scenario_Resources.Sky_Cluster_Index index in chunk.sky_indexes.Chunks)
                        {
                            item[index.Chunk_Number] = index.Index.Value;
                            if (item[index.Chunk_Number] != -1)
                            {
                                item[index.Chunk_Number] += num4;
                            }
                        }
                        list.Add(item);
                        num4 += chunk.sky_pallete.ChunkCount;
                    }
                    if (this.sbspdecals.Checked)
                    {
                        scnr.Decal_Palette.RemoveAllChunks();
                        scnr.Decal_Placement.RemoveAllChunks();
                        foreach (scnr.Decal_Palette_Layout layout11 in chunk.decal_pallete.Chunks)
                        {
                            scnr.Decal_Palette.AddChunk(layout11);
                        }
                        foreach (scnr.Decal_Placement_Layout layout12 in chunk.decal_placement.Chunks)
                        {
                            scnr.Decal_Placement.AddChunk(layout12);
                        }
                    }
                    if (this.transferdecr.Checked)
                    {
                        scnr.Decorator_Palette.RemoveAllChunks();
                        foreach (scnr.Decorator_Palette_Layout layout13 in chunk.decorators.Chunks)
                        {
                            scnr.Decorator_Palette.AddChunk(layout13);
                        }
                    }
                    if (this.deathzones.Checked)
                    {
                        num13 = 0;
                        while (num13 < chunk.death_zones.ChunkCount)
                        {
                            scnr.Trigger_Volumes.AddChunk(chunk.death_zones.Chunks[num13]);
                            num13++;
                        }
                        num13 = 0;
                        while (num13 < chunk.vehicle_placement.ChunkCount)
                        {
                            scnr.Scenario_Kill_Triggers_Layout zone = (scnr.Scenario_Kill_Triggers_Layout) chunk.kill_zones.Chunks[num13];
                            zone.trigger_volume.Value = (short) (zone.trigger_volume.Value + ((short) num9));
                            scnr.Scenario_Kill_Triggers.AddChunk(zone);
                            num13++;
                        }
                        num11 = chunk.death_zones.ChunkCount;
                    }
                    if (this.vehicles.Checked)
                    {
                        num13 = 0;
                        while (num13 < chunk.vehicle_pallete.ChunkCount)
                        {
                            scnr.Vehicle_Palette.AddChunk(chunk.vehicle_pallete.Chunks[num13]);
                            num13++;
                        }
                        num13 = 0;
                        while (num13 < chunk.vehicle_placement.ChunkCount)
                        {
                            scnr.Vehicle_Placement_Layout layout14 = (scnr.Vehicle_Placement_Layout) chunk.vehicle_placement.Chunks[num13];
                            layout14.Vehicle_Chunk__Number_.Value = (short) (layout14.Vehicle_Chunk__Number_.Value + ((short) num9));
                            layout14.bsp_index_1.Value = (short) layout.Chunk_Number;
                            scnr.Vehicle_Placement.AddChunk(layout14);
                            num13++;
                        }
                        num9 += chunk.vehicle_pallete.ChunkCount;
                    }
                    if (this.weapons.Checked)
                    {
                        num13 = 0;
                        while (num13 < chunk.weapon_pallete.ChunkCount)
                        {
                            scnr.Weapon_Palette.AddChunk(chunk.weapon_pallete.Chunks[num13]);
                            num13++;
                        }
                        for (num13 = 0; num13 < chunk.weapon_placement.ChunkCount; num13++)
                        {
                            scnr.Weapon_Placement_Layout layout15 = (scnr.Weapon_Placement_Layout) chunk.weapon_placement.Chunks[num13];
                            layout15.Palette_Chunk__Number_.Value = (short) (layout15.Palette_Chunk__Number_.Value + ((short) num10));
                            layout15.bsp_index_1.Value = (short) layout.Chunk_Number;
                            scnr.Weapon_Placement.AddChunk(layout15);
                        }
                        num10 += chunk.weapon_pallete.ChunkCount;
                    }
                }
            }
            Stack<TagBlock> stack = new Stack<TagBlock>();
            stack.Push(meta.Interface.Header);
            stack.Push(this.metas[3].Header);
            while (stack.Count > 0)
            {
                block2 = stack.Pop();
                Application.DoEvents();
                foreach (TagBlockLayout layout16 in block2.Chunks)
                {
                    foreach (BaseObject obj2 in layout16)
                    {
                        DecompiledTagInterface interface2;
                        string tagType;
                        if (obj2.Type == BaseObjectType.TagReference)
                        {
                            reference = (TagReference) obj2;
                            if (reference.Ident.TagName != "null")
                            {
                                tagType = reference.Ident.TagType;
                                if ((tagType != null) && ((((tagType == "sncl") || (tagType == "spk!")) || (tagType == "matg")) || (tagType == "ugh!")))
                                {
                                    continue;
                                }
                                str2 = Tag_Layouts.GetFullTagPath(reference.Ident.TagName, reference.Ident.TagType, Map.HaloVersionEnum.Halo2);
                                this.debugbox.Text = "Processing " + str2 + "...\n";
                                Application.DoEvents();
                                if (this.addedfilepaths.IndexOf(str2) != -1)
                                {
                                    continue;
                                }
                                if (File.Exists(str2))
                                {
                                    interface2 = new DecompiledTagInterface(str2, Map.HaloVersionEnum.Halo2, false);
                                    this.metas.Add(interface2);
                                    this.addedfilepaths.Add(str2);
                                    this.idents.Add((int) this.tempident);
                                    this.tempident += 0x10001;
                                    stack.Push(interface2.Header);
                                }
                                else
                                {
                                    reference.Ident.TagName = "null";
                                }
                            }
                        }
                        else if (obj2.Type == BaseObjectType.TagIdent)
                        {
                            ident = (TagIdent) obj2;
                            if (ident.TagName != "null")
                            {
                                tagType = ident.TagType;
                                if ((tagType != null) && ((((tagType == "sncl") || (tagType == "spk!")) || (tagType == "matg")) || (tagType == "ugh!")))
                                {
                                    continue;
                                }
                                str2 = Tag_Layouts.GetFullTagPath(ident.TagName, ident.TagType, Map.HaloVersionEnum.Halo2);
                                if (this.addedfilepaths.IndexOf(str2) != -1)
                                {
                                    continue;
                                }
                                this.debugbox.Text = "Processing " + str2 + "...\n";
                                Application.DoEvents();
                                if (File.Exists(str2))
                                {
                                    interface2 = new DecompiledTagInterface(str2, Map.HaloVersionEnum.Halo2, false);
                                    this.metas.Add(interface2);
                                    this.addedfilepaths.Add(str2);
                                    this.idents.Add((int) this.tempident);
                                    this.tempident += 0x10001;
                                    stack.Push(interface2.Header);
                                }
                                else
                                {
                                    ident.TagName = "null";
                                }
                            }
                        }
                        else if (obj2.Type == BaseObjectType.Syntax_Block)
                        {
                            ident = ((Syntax_Block) obj2).Tag_Reference;
                            if (ident.TagName != "null")
                            {
                                tagType = ident.TagType;
                                if ((tagType != null) && ((((tagType == "sncl") || (tagType == "spk!")) || (tagType == "matg")) || (tagType == "ugh!")))
                                {
                                    continue;
                                }
                                str2 = Tag_Layouts.GetFullTagPath(ident.TagName, ident.TagType, Map.HaloVersionEnum.Halo2);
                                if (this.addedfilepaths.IndexOf(str2) != -1)
                                {
                                    continue;
                                }
                                this.debugbox.Text = "Processing " + str2 + "...\n";
                                Application.DoEvents();
                                if (File.Exists(str2))
                                {
                                    interface2 = new DecompiledTagInterface(str2, Map.HaloVersionEnum.Halo2, false);
                                    this.metas.Add(interface2);
                                    this.addedfilepaths.Add(str2);
                                    this.idents.Add((int) this.tempident);
                                    this.tempident += 0x10001;
                                    stack.Push(interface2.Header);
                                }
                                else
                                {
                                    ident.TagName = "null";
                                }
                            }
                        }
                        else if (obj2.Type == BaseObjectType.TagBlock)
                        {
                            stack.Push((TagBlock) obj2);
                        }
                    }
                }
            }
            Application.DoEvents();
            this.metas.Add(this.map.ugh_Meta.Interface);
            this.addedfilepaths.Add(Tag_Layouts.GetFullTagPath(this.map.ugh_Meta.Name, this.map.ugh_Meta.TagType, Map.HaloVersionEnum.Halo2));
            this.idents.Add((int) this.tempident);
            this.tempident += 0x10001;
            Application.DoEvents();
            scnr.Predicted_Resources_0.RemoveAllChunks();
            using (List<MetaInterface>.Enumerator TagEnumerator5 = this.metas.GetEnumerator())
            {
                while (TagEnumerator5.MoveNext())
                {
                    current = TagEnumerator5.Current;
                    switch (current.Tag_Type)
                    {
                        case "bipd":
                        case "bloc":
                        case "ctrl":
                        case "jpt!":
                        case "mach":
                        case "scen":
                        case "ssce":
                        case "vehi":
                        {
                            scnr.Predicted_Resources_0_Layout layout17 = new scnr.Predicted_Resources_0_Layout();
                            layout17.Resource.TagName = current.Tag_Name;
                            layout17.Resource.TagType = current.Tag_Type;
                            scnr.Predicted_Resources_0.AddChunk(layout17);
                            break;
                        }
                        case "eqip":
                        case "garb":
                        case "proj":
                        {
                            scnr.Predicted_Resources_0_Layout layout18 = new scnr.Predicted_Resources_0_Layout();
                            layout18.Resource.TagName = current.Tag_Name;
                            layout18.Resource.TagType = current.Tag_Type;
                            scnr.Predicted_Resources_0.AddChunk(layout18);
                            scnr.Predicted_Resources_0.AddChunk(layout18.Clone());
                            break;
                        }
                        case "weap":
                        {
                            scnr.Predicted_Resources_0_Layout layout19 = new scnr.Predicted_Resources_0_Layout();
                            layout19.Resource.TagName = current.Tag_Name;
                            layout19.Resource.TagType = current.Tag_Type;
                            scnr.Predicted_Resources_0.AddChunk(layout19);
                            scnr.Predicted_Resources_0.AddChunk(layout19.Clone());
                            scnr.Predicted_Resources_0.AddChunk(layout19.Clone());
                            break;
                        }
                    }
                }
            }
            h_.Sound_Permutations35.RemoveAllChunks();
            h_.Sound_Choices44.RemoveAllChunks();
            h_.Sound_Raw_Data68.RemoveAllChunks();
            h_.Sound_Names25.RemoveAllChunks();
            h_.Unknown28.RemoveAllChunks();
            num13 = 0;
            while (num13 < this.metas.Count)
            {
                current = this.metas[num13];
                if (current.Tag_Type == "snd!")
                {
                    snd_ d_ = (snd_) current.Header.GetChunk(0);
                    d_.Index_to_5th.Value = (short) h_.Sound_Permutations35.ChunkCount;
                    Sound_Resource_Layout layout20 = d_.Sound_Resource;
                    for (int i = 0; i < layout20.Sound_Permutations.ChunkCount; i++)
                    {
                        ugh_.Sound_Permutations35_Layout layout21 = (ugh_.Sound_Permutations35_Layout) layout20.Sound_Permutations.Chunks[i];
                        int num15 = h_.Sound_Choices44.ChunkCount;
                        if (layout21.indexto4thblock1.Value != -1)
                        {
                            ugh_.Unknown28_Layout layout22 = (ugh_.Unknown28_Layout) layout20.Sound_unknown4thblock.Chunks[layout21.indexto4thblock1.Value];
                            bool flag = false;
                            foreach (ugh_.Unknown28_Layout layout23 in h_.Unknown28.Chunks)
                            {
                                if ((((layout22.No_Name.Value == layout23.No_Name.Value) && (layout22.No_Name_0.Value == layout23.No_Name_0.Value)) && ((layout22.No_Name_1.Value == layout23.No_Name_1.Value) && (layout22.No_Name_2.Value == layout23.No_Name_2.Value))) && (layout22.No_Name_3.Value == layout23.No_Name_3.Value))
                                {
                                    flag = true;
                                    layout21.indexto4thblock1.Value = (short) layout23.Chunk_Number;
                                }
                            }
                            if (!flag)
                            {
                                h_.Unknown28.AddChunk(layout22);
                                layout21.indexto4thblock1.Value = (short) (h_.Unknown28.ChunkCount - 1);
                            }
                        }
                        if (layout21.indexto4thblock2.Value != -1)
                        {
                        }
                        if (layout21.indexto4thblock3.Value != -1)
                        {
                        }
                        for (int j = 0; j < layout21.chunkCount.Value; j++)
                        {
                            ugh_.Sound_Choices44_Layout layout24 = (ugh_.Sound_Choices44_Layout) layout20.Sound_Choices.Chunks[layout21.Index.Value + j];
                            int num17 = h_.Sound_Raw_Data68.ChunkCount;
                            for (int k = 0; k < layout24.chunkCount.Value; k++)
                            {
                                h_.Sound_Raw_Data68.AddChunk(layout20.Sound_Raw_Data.Chunks[layout24.Index.Value + k]);
                            }
                            bool flag2 = false;
                            ugh_.Sound_Names25_Layout layout25 = (ugh_.Sound_Names25_Layout) layout20.Sound_Names.Chunks[layout24.Name_Index.Value];
                            foreach (ugh_.Sound_Names25_Layout layout26 in h_.Sound_Names25.Chunks)
                            {
                                if (layout25.Name.Value == layout26.Name.Value)
                                {
                                    layout24.Name_Index.Value = (short) layout26.Chunk_Number;
                                    flag2 = true;
                                    break;
                                }
                            }
                            if (!flag2)
                            {
                                h_.Sound_Names25.AddChunk(layout25);
                                layout24.Name_Index.Value = (short) (h_.Sound_Names25.ChunkCount - 1);
                            }
                            layout24.Index.Value = (short) num17;
                            h_.Sound_Choices44.AddChunk(layout24);
                        }
                        layout21.Index.Value = (short) num15;
                        h_.Sound_Permutations35.AddChunk(layout21);
                    }
                }
                num13++;
            }
            int num19 = 0;
            foreach (MetaInterface interface4 in this.metas)
            {
                stack.Push(interface4.Header);
                while (stack.Count > 0)
                {
                    block2 = stack.Pop();
                    foreach (TagBlockLayout layout16 in block2.Chunks)
                    {
                        foreach (BaseObject obj2 in layout16)
                        {
                            if (obj2.Type == BaseObjectType.TagIdent)
                            {
                                ident = (TagIdent) obj2;
                                if (ident.TagName != "null")
                                {
                                    str2 = Tag_Layouts.GetFullTagPath(ident.TagName, ident.TagType, Map.HaloVersionEnum.Halo2);
                                    num13 = this.addedfilepaths.IndexOf(str2);
                                    if (num13 == -1)
                                    {
                                        ident.Ident = -1;
                                    }
                                    else
                                    {
                                        ident.Ident = this.idents[num13];
                                    }
                                }
                                else
                                {
                                    ident.Ident = -1;
                                }
                            }
                            else if (obj2.Type == BaseObjectType.TagReference)
                            {
                                reference = (TagReference) obj2;
                                if (reference.Ident.TagName != "null")
                                {
                                    str2 = Tag_Layouts.GetFullTagPath(reference.Ident.TagName, reference.Ident.TagType, Map.HaloVersionEnum.Halo2);
                                    num13 = this.addedfilepaths.IndexOf(str2);
                                    if (num13 == -1)
                                    {
                                        reference.Ident.Ident = -1;
                                    }
                                    else
                                    {
                                        reference.Ident.Ident = this.idents[num13];
                                    }
                                }
                                else
                                {
                                    reference.Ident.Ident = -1;
                                }
                            }
                            else if (obj2.Type == BaseObjectType.Raw_Tag_Block)
                            {
                                Raw_Tag_Block block3 = (Raw_Tag_Block) obj2;
                                if (block3.Tag_Ident.TagName != "null")
                                {
                                    str2 = Tag_Layouts.GetFullTagPath(block3.Tag_Ident.TagName, block3.Tag_Ident.TagType, Map.HaloVersionEnum.Halo2);
                                    num13 = this.addedfilepaths.IndexOf(str2);
                                    block3.Tag_Ident.Ident = this.idents[num19];
                                }
                                else
                                {
                                    block3.Tag_Ident.Ident = -1;
                                }
                            }
                            else if (obj2.Type == BaseObjectType.Unicode_Raw)
                            {
                                Unicode_Raw raw = (Unicode_Raw) obj2;
                                foreach (Unicode_Raw.Unicode_String str3 in raw.Unicode_Strings.Chunks)
                                {
                                    num12 = this.stringids.IndexOf(str3.name.Value);
                                    if (num12 == -1)
                                    {
                                        this.stringids.Add(str3.name.Value);
                                        num12 = this.stringids.Count - 1;
                                    }
                                    str3.name.Index = (short) num12;
                                }
                            }
                            else
                            {
                                core.TagInterface.StringID gid2;
                                if (obj2.Type == BaseObjectType.StringID)
                                {
                                    gid2 = (core.TagInterface.StringID) obj2;
                                    num12 = this.stringids.IndexOf(gid2.Text);
                                    if (num12 == -1)
                                    {
                                        this.stringids.Add(gid2.Text);
                                        num12 = this.stringids.Count - 1;
                                    }
                                    gid2.Index = (short) num12;
                                    gid2.StringLength = gid2.Text.Length;
                                }
                                else if (obj2.Type == BaseObjectType.Syntax_Block)
                                {
                                    if (((Syntax_Block) obj2).Is_String_ID_Referenced)
                                    {
                                        gid2 = ((Syntax_Block) obj2).String_ID;
                                        num12 = this.stringids.IndexOf(gid2.Text);
                                        if (num12 == -1)
                                        {
                                            this.stringids.Add(gid2.Text);
                                            num12 = this.stringids.Count - 1;
                                        }
                                        gid2.Index = (short) num12;
                                        gid2.StringLength = gid2.Text.Length;
                                    }
                                }
                                else if (obj2.Type == BaseObjectType.TagBlock)
                                {
                                    stack.Push((TagBlock) obj2);
                                }
                            }
                        }
                    }
                }
                num19++;
            }
            this.map.io.Open();
            this.map.io.In.SeekTo(this.map.Map_Header.GeometryCacheOffset);
            byte[] buffer = this.map.io.In.ReadBytes(this.map.Map_Header.GeometryCacheSize);
            this.map.io.In.SeekTo(this.map.Map_Header.IndexOffset);
            byte[] buffer2 = this.map.io.In.ReadBytes(this.map.Map_Header.Index_HeaderSize);
            this.map.io.Out.BaseStream.SetLength(0x800L);
            this.map.io.Out.SeekTo(0x800);
            this.debugbox.Text = this.debugbox.Text + "Writing internal sound raw\n";
            foreach (ugh_.Sound_Raw_Data68_Layout layout27 in h_.Sound_Raw_Data68.Chunks)
            {
                if (layout27.Sound_Raw.Raw_Offset.Map_Location == MapTypes.Internal)
                {
                    Application.DoEvents();
                    layout27.Sound_Raw.Raw_Offset.Data_Offset = (int) this.map.io.Out.BaseStream.Position;
                    layout27.Sound_Raw.Write_Raw(ref this.map.io.Out);
                    this.WritePadding();
                }
            }
            foreach (MetaInterface interface3 in this.metas)
            {
                if (interface3.Tag_Type == "mode")
                {
                    mode mode = (mode) interface3.Header.GetChunk(0);
                    list2 = new List<int>();
                    list3 = new List<int>();
                    this.debugbox.Text = this.debugbox.Text + "Writing internal model type1 raw for " + interface3.Tag_Name + "\n";
                    Application.DoEvents();
                    foreach (mode.Part_Layout layout28 in mode.Part.Chunks)
                    {
                        if (layout28.Visual_Raw.Raw_Offset.Map_Location == MapTypes.Internal)
                        {
                            num20 = list2.IndexOf(layout28.Visual_Raw.Raw_Offset.Data_Offset);
                            if (num20 == -1)
                            {
                                list2.Add(layout28.Visual_Raw.Raw_Offset.Data_Offset);
                                layout28.Visual_Raw.Raw_Offset.Data_Offset = (int) this.map.io.Out.BaseStream.Position;
                                list3.Add(layout28.Visual_Raw.Raw_Offset.Data_Offset);
                                layout28.Visual_Raw.Write_Raw(ref this.map.io.Out);
                                this.WritePadding();
                            }
                            else if (num20 != -1)
                            {
                                layout28.Visual_Raw.Raw_Offset.Data_Offset = list3[num20];
                            }
                        }
                    }
                    if (mode.Unknown_5.ChunkCount > 0)
                    {
                        this.debugbox.Text = this.debugbox.Text + "Writing internal model type2 raw for " + interface3.Tag_Name + "\n";
                        Application.DoEvents();
                    }
                    foreach (mode.Unknown_Raw_Data_Layout layout29 in mode.Unknown_5.Chunks)
                    {
                        if (layout29.Visual_Raw.Raw_Offset.Map_Location == MapTypes.Internal)
                        {
                            num20 = list2.IndexOf(layout29.Visual_Raw.Raw_Offset.Data_Offset);
                            if (num20 == -1)
                            {
                                list2.Add(layout29.Visual_Raw.Raw_Offset.Data_Offset);
                                layout29.Visual_Raw.Raw_Offset.Data_Offset = (int) this.map.io.Out.BaseStream.Position;
                                list3.Add(layout29.Visual_Raw.Raw_Offset.Data_Offset);
                                layout29.Visual_Raw.Write_Raw(ref this.map.io.Out);
                                this.WritePadding();
                            }
                            else if (num20 != -1)
                            {
                                layout29.Visual_Raw.Raw_Offset.Data_Offset = list3[num20];
                            }
                        }
                    }
                }
            }
            List<int> list4 = new List<int>();
            List<int> list5 = new List<int>();
            List<int> list6 = new List<int>();
            List<int> list7 = new List<int>();
            List<int> list8 = new List<int>();
            int num21 = 0;
            foreach (scnr.Structure_BSPS_Layout layout in scnr.Structure_BSPS.Chunks)
            {
                int num22 = 0;
                ident = layout.Light_Map_0;
                if (ident.TagName != "null")
                {
                    str2 = Tag_Layouts.GetFullTagPath(ident.TagName, ident.TagType, Map.HaloVersionEnum.Halo2);
                    num13 = this.addedfilepaths.IndexOf(str2);
                    list8.Add(num13);
                    num22 = num13;
                }
                else
                {
                    list8.Add(-1);
                }
                int num23 = 0;
                ident = layout.Structure_BSP_0;
                if (ident.TagName != "null")
                {
                    str2 = Tag_Layouts.GetFullTagPath(ident.TagName, ident.TagType, Map.HaloVersionEnum.Halo2);
                    num13 = this.addedfilepaths.IndexOf(str2);
                    list7.Add(num13);
                    num23 = num13;
                }
                SBSP sbsp = (SBSP) this.metas[num23].Header.GetChunk(0);
                this.debugbox.Text = this.debugbox.Text + "Writing internal bsp cluster raw for " + ident.Name + "\n";
                Application.DoEvents();
                foreach (SBSP.Detail_Objects cluster in sbsp.detail_objects.Chunks)
                {
                    if (cluster.rawdata.Raw_Offset.Map_Location == MapTypes.Internal)
                    {
                        cluster.rawdata.Raw_Offset.Data_Offset = (int) this.map.io.Out.BaseStream.Position;
                        cluster.rawdata.Write_Raw(ref this.map.io.Out);
                        this.WritePadding();
                    }
                    if (this.sbspskies.Checked)
                    {
                        cluster.sky_index.Value = (byte) list[num21][cluster.Chunk_Number];
                    }
                }
                num21++;
                this.debugbox.Text = this.debugbox.Text + "Writing internal bsp scenery raw for " + ident.Name + "\n";
                Application.DoEvents();
                foreach (SBSP.Scenery_Cluster cluster2 in sbsp.bsp_permutations.Chunks)
                {
                    if (cluster2.rawdata.Raw_Offset.Map_Location == MapTypes.Internal)
                    {
                        cluster2.rawdata.Raw_Offset.Data_Offset = (int) this.map.io.Out.BaseStream.Position;
                        cluster2.rawdata.Write_Raw(ref this.map.io.Out);
                        this.WritePadding();
                    }
                }
                if (num22 != -1)
                {
                    this.debugbox.Text = this.debugbox.Text + "Writing internal lightmap raw for " + ident.Name + "\n";
                    Application.DoEvents();
                    ltmp ltmp = (ltmp) this.metas[num22].Header.Chunks[0];
                    foreach (ltmp.Unknown17_Layout layout30 in ltmp.Unknown17.Chunks)
                    {
                        foreach (ltmp.Unknown17_Layout.Lightmap_Raw_Layout layout31 in layout30.lightmap_raw.Chunks)
                        {
                            if (layout31.raw_data.Raw_Offset.Map_Location == MapTypes.Internal)
                            {
                                layout31.raw_data.Raw_Offset.Data_Offset = (int) this.map.io.Out.BaseStream.Position;
                                layout31.raw_data.Write_Raw(ref this.map.io.Out);
                                this.WritePadding();
                            }
                        }
                    }
                }
                list2 = new List<int>();
                list3 = new List<int>();
                this.debugbox.Text = this.debugbox.Text + "Writing internal unknown bsp raw for " + ident.Name + "\n";
                Application.DoEvents();
                foreach (SBSP.Decorators block4 in sbsp.decorators.Chunks)
                {
                    foreach (SBSP.Decorators.Raw_Data_Tag_Block block5 in block4.raw_data_block.Chunks)
                    {
                        if (block5.rawdata.Raw_Offset.Map_Location == MapTypes.Internal)
                        {
                            num20 = list2.IndexOf(block5.rawdata.Raw_Offset.Data_Offset);
                            if (num20 == -1)
                            {
                                list2.Add(block5.rawdata.Raw_Offset.Data_Offset);
                                block5.rawdata.Raw_Offset.Data_Offset = (int) this.map.io.Out.BaseStream.Position;
                                list3.Add(block5.rawdata.Raw_Offset.Data_Offset);
                                block5.rawdata.Write_Raw(ref this.map.io.Out);
                                this.WritePadding();
                            }
                            else
                            {
                                block5.rawdata.Raw_Offset.Data_Offset = list3[num20];
                            }
                        }
                    }
                }
                this.debugbox.Text = this.debugbox.Text + "Writing internal bsp raw for " + ident.Name + "\n";
                Application.DoEvents();
                foreach (SBSP.SBSP_Water water in sbsp.water_definitions.Chunks)
                {
                    if ((water.rawdata.Raw_Offset.Map_Location == MapTypes.Internal) && (water.rawdata.Raw_Offset.Data_Offset != -1))
                    {
                        water.rawdata.Raw_Offset.Data_Offset = (int) this.map.io.Out.BaseStream.Position;
                        water.rawdata.Write_Raw(ref this.map.io.Out);
                        this.WritePadding();
                    }
                }
            }
            foreach (MetaInterface interface3 in this.metas)
            {
                if (interface3.Tag_Type == "weat")
                {
                    this.debugbox.Text = this.debugbox.Text + "Writing internal weather raw for " + interface3.Tag_Name + "\n";
                    Application.DoEvents();
                    weat weat = (weat) interface3.Header.GetChunk(0);
                    foreach (weat.Particle_Layout layout32 in weat.Particle.Chunks)
                    {
                        if (layout32.Visual_Raw.Raw_Offset.Map_Location == MapTypes.Internal)
                        {
                            layout32.Visual_Raw.Raw_Offset.Data_Offset = (int) this.map.io.Out.BaseStream.Position;
                            layout32.Visual_Raw.Write_Raw(ref this.map.io.Out);
                            this.WritePadding();
                        }
                    }
                }
            }
            foreach (MetaInterface interface3 in this.metas)
            {
                if (interface3.Tag_Type == "DECR")
                {
                    this.debugbox.Text = this.debugbox.Text + "Writing internal DECR raw for " + interface3.Tag_Name + "\n";
                    Application.DoEvents();
                    DECR decr = (DECR) interface3.Header.GetChunk(0);
                    if (decr.Visual_Raw.Raw_Offset.Map_Location == MapTypes.Internal)
                    {
                        decr.Visual_Raw.Raw_Offset.Data_Offset = (int) this.map.io.Out.BaseStream.Position;
                        decr.Visual_Raw.Write_Raw(ref this.map.io.Out);
                        this.WritePadding();
                    }
                }
            }
            foreach (MetaInterface interface3 in this.metas)
            {
                if (interface3.Tag_Type == "PRTM")
                {
                    this.debugbox.Text = this.debugbox.Text + "Writing internal PRTM raw for " + interface3.Tag_Name + "\n";
                    Application.DoEvents();
                    PRTM prtm = (PRTM) interface3.Header.GetChunk(0);
                    if (prtm.Visual_Raw.Raw_Offset.Map_Location == MapTypes.Internal)
                    {
                        prtm.Visual_Raw.Raw_Offset.Data_Offset = (int) this.map.io.Out.BaseStream.Position;
                        prtm.Visual_Raw.Write_Raw(ref this.map.io.Out);
                        this.WritePadding();
                    }
                }
            }
            this.debugbox.Text = this.debugbox.Text + "Writing internal ugh raw type2 \n";
            Application.DoEvents();
            foreach (ugh_.Diff_Model_Raw_Data87_Layout layout33 in h_.Diff_Model_Raw_Data87.Chunks)
            {
                if (layout33.Visual_Raw.Raw_Offset.Map_Location == MapTypes.Internal)
                {
                    layout33.Visual_Raw.Raw_Offset.Data_Offset = (int) this.map.io.Out.BaseStream.Position;
                    layout33.Visual_Raw.Write_Raw(ref this.map.io.Out);
                    this.WritePadding();
                }
            }
            foreach (MetaInterface interface3 in this.metas)
            {
                if (interface3.Tag_Type == "jmad")
                {
                    this.debugbox.Text = this.debugbox.Text + "Writing internal animation raw for " + interface3.Tag_Name + "\n";
                    Application.DoEvents();
                    jmad jmad = (jmad) interface3.Header.GetChunk(0);
                    list2 = new List<int>();
                    list3 = new List<int>();
                    foreach (jmad.Unknown_11_Layout layout34 in jmad.Unknown_11.Chunks)
                    {
                        if (layout34.Raw_Data.Raw_Offset.Map_Location == MapTypes.Internal)
                        {
                            num20 = list2.IndexOf(layout34.Raw_Data.Raw_Offset.Data_Offset);
                            if (num20 == -1)
                            {
                                list2.Add(layout34.Raw_Data.Raw_Offset.Data_Offset);
                                layout34.Raw_Data.Raw_Offset.Data_Offset = (int) this.map.io.Out.BaseStream.Position;
                                list3.Add(layout34.Raw_Data.Raw_Offset.Data_Offset);
                                layout34.Raw_Data.Write_Raw(ref this.map.io.Out);
                                this.WritePadding();
                            }
                            else if (num20 != -1)
                            {
                                layout34.Raw_Data.Raw_Offset.Data_Offset = list3[num20];
                            }
                        }
                    }
                }
            }
            for (num13 = 0; num13 < list7.Count; num13++)
            {
                Meta meta4;
                int num24 = (int) this.map.io.Out.BaseStream.Position;
                list5.Add(num24);
                int num25 = (this.map.Index_Header.Constant - 0x20) + this.map.Map_Header.Index_HeaderSize;
                int num26 = num25 - num24;
                int size = 0;
                if (list8[num13] == -1)
                {
                    meta4 = TagCompiler.CompileSBSPMetaFromTagInterface(this.metas[list7[num13]], num24, num26, null);
                }
                else
                {
                    meta4 = TagCompiler.CompileSBSPMetaFromTagInterface(this.metas[list7[num13]], num24, num26, this.metas[list8[num13]]);
                }
                this.map.io.Out.Write(meta4.MS.ToArray());
                size = meta4.Size;
                list4.Add(size);
                scnr.Structure_BSPS_Layout layout35 = (scnr.Structure_BSPS_Layout) scnr.Structure_BSPS.Chunks[num13];
                layout35.Structure_BSP_Offset.Value = num24;
                layout35.Structure_BSP_Size.Value = size;
                layout35.Primary_Magic_Meta_Offset.Value = num25;
            }
            int count = this.stringids.Count;
            int position = (int) this.map.io.Out.BaseStream.Position;
            for (num13 = 0; num13 < count; num13++)
            {
                core.TagInterface.String.WriteString(ref this.map.io.Out, this.stringids[num13], 0x80);
            }
            this.WritePadding();
            int num30 = (int) this.map.io.Out.BaseStream.Position;
            int num31 = 0;
            for (num13 = 0; num13 < count; num13++)
            {
                this.map.io.Out.Write(num31);
                num31 += this.stringids[num13].Length + 1;
            }
            this.WritePadding();
            int num32 = (int) this.map.io.Out.BaseStream.Position;
            for (num13 = 0; num13 < count; num13++)
            {
                core.TagInterface.String.WriteString(ref this.map.io.Out, this.stringids[num13], this.stringids[num13].Length + 1);
            }
            this.WritePadding();
            int num33 = (int) this.map.io.Out.BaseStream.Position;
            for (num13 = 0; num13 < this.metas.Count; num13++)
            {
                core.TagInterface.String.WriteString(ref this.map.io.Out, this.metas[num13].Tag_Name, this.metas[num13].Tag_Name.Length + 1);
            }
            this.WritePadding();
            int num34 = (int) this.map.io.Out.BaseStream.Position;
            int num35 = 0;
            for (num13 = 0; num13 < this.metas.Count; num13++)
            {
                this.map.io.Out.Write(num35);
                num35 += this.metas[num13].Tag_Name.Length + 1;
            }
            this.WritePadding();
            num13 = 0;
            while (num13 < 8)
            {
                matg.Unicode[num13].Index_Offset = (int) this.map.io.Out.BaseStream.Position;
                matg.Unicode[num13].Unicode_Strings.WriteChunks(ref this.map.io.Out, MetaInterface.InterfaceMode.CompiledTagMode);
                this.WritePadding();
                matg.Unicode[num13].Table_Offset = (int) this.map.io.Out.BaseStream.Position;
                matg.Unicode[num13].Write_Raw(ref this.map.io.Out);
                this.WritePadding();
                num13++;
            }
            matg.crazy_offset1.Value = (int) this.map.io.Out.BaseStream.Position;
            matg.crazy_offset2.Value = (int) this.map.io.Out.BaseStream.Position;
            this.map.io.Out.Write(buffer);
            this.WritePadding();
            foreach (MetaInterface interface3 in this.metas)
            {
                if (interface3.Tag_Type == "bitm")
                {
                    this.debugbox.Text = this.debugbox.Text + "Writing internal bitmap raw for " + interface3.Tag_Name + "\n";
                    Application.DoEvents();
                    bitm bitm = (bitm) interface3.Header.GetChunk(0);
                    foreach (bitm.Bitmap_Data_Layout layout36 in bitm.Bitmap_Data.Chunks)
                    {
                        num13 = 5;
                        while (num13 > -1)
                        {
                            if ((layout36.rawdata.lod_offset[num13].Data_Offset != -1) && (layout36.rawdata.lod_offset[num13].Map_Location == MapTypes.Internal))
                            {
                                layout36.rawdata.lod_offset[num13].Data_Offset = (int) this.map.io.Out.BaseStream.Position;
                                this.map.io.Out.Write(layout36.rawdata.LOD_MS[num13].ToArray());
                                this.WritePadding();
                            }
                            num13--;
                        }
                    }
                }
            }
            int num36 = (int) this.map.io.Out.BaseStream.Position;
            int num37 = (this.map.Index_Header.Constant - num36) - 0x20;
            int magic = num37 + list4[0];
            this.map.io.Out.Write(buffer2);
            List<int> list9 = new List<int>();
            List<int> list10 = new List<int>();
            for (num13 = 0; num13 < this.metas.Count; num13++)
            {
                if ((this.metas[num13].Tag_Type == "ltmp") || (this.metas[num13].Tag_Type == "sbsp"))
                {
                    list9.Add(0);
                    list10.Add(0);
                }
                else
                {
                    this.debugbox.Text = "Compiling " + this.metas[num13].Tag_Name + "...\n";
                    Application.DoEvents();
                    try
                    {
                        int mapoffset = (int) this.map.io.Out.BaseStream.Position;
                        Meta meta5 = TagCompiler.CompileMetaFromTagInterface(this.metas[num13], mapoffset, magic);
                        this.map.io.Out.Write(meta5.MS.ToArray());
                        list9.Add(mapoffset);
                        list10.Add(meta5.size);
                    }
                    catch
                    {
                        MessageBox.Show("Error Compiling");
                    }
                }
            }
            this.WritePadding();
            int num40 = this.map.Index_Header.Tags_Offset - this.map.Map_Header.IndexOffset;
            this.map.io.Out.SeekTo(num36 + num40);
            for (num13 = 0; num13 < this.metas.Count; num13++)
            {
                char[] array = this.metas[num13].Tag_Type.ToCharArray();
                Array.Reverse(array);
                this.map.io.Out.Write(array);
                this.map.io.Out.Write(this.idents[num13]);
                int num41 = list9[num13] + magic;
                if ((this.metas[num13].Tag_Type == "ltmp") || (this.metas[num13].Tag_Type == "sbsp"))
                {
                    this.map.io.Out.Write(0);
                    this.map.io.Out.Write(0);
                }
                else
                {
                    this.map.io.Out.Write(num41);
                    this.map.io.Out.Write(list10[num13]);
                }
            }
            int length = (int) this.map.io.Out.BaseStream.Length;
            this.map.io.Out.SeekTo(8);
            this.map.io.Out.Write(length);
            this.map.io.Out.SeekTo(0x10);
            this.map.io.Out.Write(num36);
            int num43 = (length - num36) - this.map.Map_Header.Index_HeaderSize;
            int num44 = (num43 + this.map.Map_Header.Index_HeaderSize) + list4[0];
            this.map.io.Out.SeekTo(0x18);
            this.map.io.Out.Write(num43);
            this.map.io.Out.Write(num44);
            this.map.io.Out.SeekTo(320);
            this.map.io.Out.Write(0);
            this.map.io.Out.SeekTo(0x158);
            this.map.io.Out.Write(matg.crazy_offset1.Value);
            this.map.io.Out.SeekTo(0x160);
            this.map.io.Out.Write(position);
            this.map.io.Out.Write(count);
            this.map.io.Out.Write(num31);
            this.map.io.Out.Write(num30);
            this.map.io.Out.Write(num32);
            int num45 = this.metas.Count;
            this.map.io.Out.SeekTo(0x2c0);
            this.map.io.Out.Write(num45);
            this.map.io.Out.Write(num33);
            this.map.io.Out.Write(num35);
            this.map.io.Out.Write(num34);
            this.map.io.Out.SeekTo(num36 + 12);
            this.map.io.Out.Write(this.idents[3]);
            this.map.io.Out.SeekTo(num36 + 0x18);
            this.map.io.Out.Write(num45);
            this.map.io.Close();
            this.metas = null;
            GC.Collect(GC.MaxGeneration);
            MessageBox.Show("Done");
        }

        private void Rebuilder_Load(object sender, EventArgs e)
        {
        }

        private void WritePadding()
        {
            int size = 0x200 - (((int) this.map.io.Out.BaseStream.Position) % 0x200);
            if (size != 0x200)
            {
                core.TagInterface.Padding.Write(ref this.map.io.Out, size);
            }
        }
    }
}

